2003-12-31  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* print-rtl.c (print_rtx): For hard register, write out register
	number and register name instead of calling PRINT_REG.
	* defaults.h (PRINT_REG): Deleted.
	* config/i386/i386.c (print_reg): Remove handling of CODE of -1.
	Move comments here from i386.h.
	(print_operand, print_operand_address): Call print_reg directly.
	* config/i386/i386.h (PRINT_REG): Deleted.

2003-12-31  Roger Sayle  <roger@eyesopen.com>

	* config/ia64/hpux.h (TARGET_OS_CPP_BUILTINS): Define
	_INCLUDE_LONGLONG.

2003-12-31  Zack Weinberg  <zack@codesourcery.com>

	* gcc.c (init_spec): Add -lunwind to shared case too if
	USE_LIBUNWIND_EXCEPTIONS.

2003-12-31  Joseph S. Myers  <jsm@polyomino.org.uk>

	* doc/include/texinfo.tex: Update to version 2003-12-21.10.
	* doc/gcc.texi, doc/gccint.texi: Don't set font for
	@def... commands.
	* doc/invoke.texi: Don't use empty @opindex.

2003-12-31  Mark Mitchell  <mark@codesourcery.com>

	* c-common.c (c_expand_expr): Remove code to return a value
	different from that returned by expand_expr.
	* expr.c (store_expr): Use the validity of a target MEM, rather
	than checking DECL_RTL (exp), to figure out if a copy is
	required.

2003-12-31  Kazu Hirata  <kazu@cs.umass.edu>

	* config/v850/lib1funcs.asm: Fix comment formatting.
	* config/v850/v850.c: Likewise.
	* config/v850/v850.h: Likewise.
	* config/v850/v850.md: Likewise.

2003-12-31  Kazu Hirata  <kazu@cs.umass.edu>

	* config/i386/i386.md (*movqi_insv_2): Remove AND in the
	set source.

2003-12-31  Kazuhiro Inaoka  <inaoka.kazuhiro@renesas.com>

	* config.gcc: Added m32r-linux m32rle-elf and m32le-linux targets.
	* doc/invoke.texi: Document -mflush-func, -mflush-trap options.
	Also add documentation for -mdebug, -malign-loops, -missue-rate,
	and -mbranch-cost options.
	* config/m32r/t-linux: New file: m32r-linux support.
	* config/m32r/xm-linux.h: Likewise.
	* config/m32r/xm-m32r.h: Likewise.
	* config/m32r/linux.h: Likewise.
	* config/m32r/little.h: New file: Little endian code generation
	support.
	* config/m32r/m32r-protos.h (m32r_legitimize_pic_address,
	m32r_legitimate_pic_operand_p, load_pic_register): Add
	prototypes.
	* config/m32r/m32r.c (m32r_init): Add options for cache-flush.
	(addr24_operand): Changes for PIC code generation.
	* config/m32r/m32r.h (LABEL_ALIGN): Define to calculate PNOP
	length at labels.
	(ASM_SPEC): Add PIC support.
	(FUNCTION_PROFILER): New define.
	(TRAMPOLINE_SIZE, INITIALIZE_TRAMPOLINE): Changed to support
	trampoline.
	(CONDITIONAL_REGISTER_USAGE, CONSTANT_ADDRESS_P,
	 LEGITIMIZE_ADDRESS, JUMP_TABLES_IN_TEXT_SECTION,
	 PIC_OFFSET_TABLE_REGNUM, FINALIZE_PIC, LEGITIMATE_PIC_OPERAND_P,
	 ASM_OUTPUT_ADDR_DIFF_ELT, CASE_VECTOR_MODE): Define for PIC.
	(move_src_operand, m32r_compute_frame_size, m32r_expand_prologue,
	 m32r_finalize_pic): Changes for PIC and profile support.
	(global_offset_table, load_pic_register, m32r_legitimate_pic_operand_p,
	 m32r_legitimize_pic_address): Add for PIC support.
	(m32r_file_start): Changed for little-endian-target.
	* config/m32r/m32r.md (mvqi, movhi, movsi, movdi, movsf, movdf,
	tablejump, tablejump_insn, call, call_value, call_value_via_label):
	Changes for PIC.
	(pic_load_addr, get_pc, builtin_setjmp_receiver): Added for PIC.
	(flush_icache): Changes for cache-flush trap.

2003-12-30  Kazu Hirata  <kazu@cs.umass.edu>

	* config/i386/i386.h: Remove an unnecessary #undef.

2003-12-30  Roger Sayle  <roger@eyesopen.com>

	* cppfiles.c (pch_open_file): Minor tweak to work-around native
	HPPA compiler bug.

2003-12-30  Kazu Hirata  <kazu@cs.umass.edu>

	* config/rs6000/aix.h: Fix comment formatting.
	* config/rs6000/rs6000-modes.def: Likewise.
	* config/rs6000/rs6000.c: Likewise.
	* config/rs6000/rs6000.h: Likewise.
	* config/rs6000/rs6000.md: Likewise.

2003-12-30  Kazu Hirata  <kazu@cs.umass.edu>

	* config/i386/i386-protos.h: Remove prototype for
	const_int_1_operand.
	* config/i386/i386.c (const_int_1_operand): Remove.
	* config/i386/i386.h (PREDICATE_CODES): Remove
	const_int_1_operand.
	* config/i386/i386.md: Replace all uses of const_int_1_operand
	with const1_operand.
	* config/i386/pentium.md: Likewise.

2003-12-30  Geoffrey Keating  <geoffk@greed.local>

	* doc/tm.texi (PREFERRED_RELOAD_CLASS): Describe use of NO_REGS
	with constants.

2003-12-30  Mark Mitchell  <mark@codesourcery.com>

	* stor-layout.c (layout_decl): Turn bitfields into ordinary
	fields, even if they are the first field in a structure.

2003-12-30  Roger Sayle  <roger@eyesopen.com>

	* fold-const.c (fold) <COND_EXPR>: Don't require strict type
	equality, instead just prevent replacing a COND_EXPR of non-void
	type by one of its operands of void type.

2003-12-30  Andreas Schwab  <schwab@suse.de>

	* doc/c-tree.texi: Fix @item vs. @itemx.
	* doc/cpp.texi: Likewise.
	* doc/install.texi: Likewise.
	* doc/invoke.texi: Likewise.

2003-12-30  Nathan Sidwell  <nathan@codesourcery.com>

	* builtins.c (expand_builtin_apply_args_1): Fix typo in previous
	change.

2003-12-30  Jan Hubicka  <jh@suse.cz>

	PR target/11936
	* i386.h (CLASS_LIKELY_SPILLED_P): Return true for
	FP_TOP_REG/FP_SECOND_REG.

2003-12-30  Steven Bosscher  <steven@gcc.gnu.org>

	Backport from tree-ssa (relevant changes only):
	2003-12-18  Zdenek Dvorak  <rakdver@atrey.karlin.mff.cuni.cz>

	* et-forest.h (et_forest_create, et_forest_delete,
	et_forest_add_node, et_forest_add_edge, et_forest_remove_node,
	et_forest_remove_edge, et_forest_parent,
	et_forest_common_ancestor, et_forest_node_value,
	et_forest_enumerate_sons): Declarations removed.
	(struct et_node): New.
	(et_new_tree, et_free_tree, et_set_father, et_split, et_nca,
	et_below): Declare.
	* et-forest.c (struct et_forest_occurrence, struct et_forest,
	struct et_forest_node): Removed.
	(et_forest_create, et_forest_delete,
	et_forest_add_node, et_forest_add_edge, et_forest_remove_node,
	et_forest_remove_edge, et_forest_parent,
	et_forest_common_ancestor, et_forest_node_value,
	et_forest_enumerate_sons, splay, remove_all_occurrences,
	find_leftmost_node, find_rightmost_node, calculate_value): Removed.
	(struct et_occ): New.
	(et_nodes, et_occurences): New.
	(set_depth, set_depth_add, set_prev, set_next, et_recomp_min,
	et_check_occ_sanity, et_check_sanity, et_check_tree_sanity,
	record_path_before_1, record_path_before, check_path_after_1,
	check_path_after, et_splay, et_new_occ, et_new_tree,
	et_free_tree, et_set_father, et_split, et_nca, et_below): New.
	* basic-block.h (struct basic_block_def): New field dom.
	(struct dominance_info): Type removed.
	(calculate_dominance_info, free_dominance_info,
	nearest_common_dominator, set_immediate_dominator,
	get_immediate_dominator, dominated_by_p, get_dominated_by,
	add_to_dominance_info, delete_from_dominance_info,
	recount_dominator, redirect_immediate_dominators,
	iterate_fix_dominators, verify_dominators): Declarations
	changed.
	(enum dom_state): New.
	(dom_computed): New variable.
	(first_dom_son, next_dom_son): Declare.
	* dominance.c (struct dominance_info): Removed.
	(BB_NODE, SET_BB_NODE): Removed.
	(calculate_dominance_info, free_dominance_info,
	nearest_common_dominator, set_immediate_dominator,
	get_immediate_dominator, dominated_by_p, get_dominated_by,
	add_to_dominance_info, delete_from_dominance_info,
	recount_dominator, redirect_immediate_dominators,
	iterate_fix_dominators, verify_dominators,
	debug_dominance_info): Work over new datastructure.  Access
	dominance datastructures through CFG.
	(assign_dfs_numbers, compute_dom_fast_query, first_dom_son,
	next_dom_son): New.
	* bt-load.c (dom): Variable removed.
	(augment_live_range, combine_btr_defs, migrate_btr_def,
	migrate_btr_defs, branch_target_load_optimize): Updated for the
	new interface for dominance information.
	* cfg.c {exit_entry_blocks): Update initializer.
	* cfglayout.c (copy_bbs): Removed loops argument. Updated for
	the new interface for dominance information.
	* cfglayout.h (copy_bbs): Declaration changed.
	* cfgloop.c (flow_loop_pre_header_find, flow_loops_cfg_dump,
	flow_loop_scan, canonicalize_loop_headers, flow_loops_find): Updated
	for the new interface for dominance information.
	(flow_loop_scan): Loops argument removed.
	(flow_loops_free): Don't release dominators.
	* cfgloop.h (struct cfg): Dom field removed.
	(flow_loop_scan, loop_split_edge_with, simple_loop_p,
	just_once_each_iteration_p, split_loop_bb): Declaration changed.
	* cfgloopanal.c (simple_loop_exit_p, simple_increment,
	just_once_each_iteration_p, simple_loop_p): Remove loops argument.
	Updated for the new interface for dominance information.
	* cfgloopmanip.c (remove_bbs, find_path, create_preheader,
	split_loop_bb, loopify, duplicate_loop_to_header_edge,
	force_single_succ_latches, loop_split_edge_with): Ditto.
	* gcse.c (dominators): Variable removed.
	(free_code_hoist_mem, compute_code_hoist_data, hoist_code):
	Updated for the new interface for dominance information.
	* ifcvt.c (post_dominators): Variable removed.
	(mark_loop_exit_edges, merge_if_block, find_if_header,
	find_cond_trap, find_if_case_1, find_if_case_2, if_convert):
	Updated for the new interface for dominance information.
	* loop-init.c (rtl_loop_optimizer_init,
	rtl_loop_optimizer_finalize): Ditto.
	* loop-unroll.c (decide_peel_simple, decide_peel_once_rolling,
	decide_peel_completely, decide_unroll_stupid,
	decide_unroll_constant_iterations,
	decide_unroll_runtime_iterations): Loops argument removed.
	Updated for the new interface for dominance information.
	(unroll_and_peel_loops, peel_loops_completely,
	unroll_loop_runtime_iterations): Updated for the new interface for
	dominance information.
	* loop-unswitch.c (may_unswitch_on_p, unswitch_loops,
	unswitch_single_loop, unswitch_loop): Updated for the new
	interface for dominance information.
	* predict.c (process_note_predictions, process_note_prediction,
	estimate_probability, note_prediction_to_br_prob): Ditto.
	* sched-rgn.c (find_rgns, init_regions): Ditto.
	* toplev.c (rest_of_handle_branch_prob): Free the dominators.

2003-12-30  Jan Hubicka  <jh@suse.cz>

	PR target/13456
	* i386.md (allocate_stack_worker):  Use different pattern for pre and
	post reload expansion.
	(allocate_stack_worker_1, allocate_stack_worker_rex64): Use
	match_scratch.
	(allocate_stack_worder_1_postreload,
	allocate_stack_worker_rex64_postreload): New.

2003-12-29  Nathan Sidwell  <nathan@codesourcery.com>

	* builtins.c (expand_builtin_apply_args_1): Add pretend args size
	to the virtual incoming args pointer for downward stacks.

2003-12-29  Roger Sayle  <roger@eyesopen.com>

	PR fortran/12632
	* fold-const.c (fold) <COND_EXPR>: Don't fold a constant condition,
	if the type of the selected branch doesn't match its' parent.

2003-12-29  Jan Hubicka  <jh@suse.cz>

	* coverage.c (read_counts_file): Better error messages; cause corrupted
	profiles to produce hard errors, not just warnings
	(get_coverage_counts): Similarly.

	* toplev.c (rest_of_handle_loop_optimize): Enable LOOP_AUTO_UNROLL.

2003-12-29  Phil Edwards  <phil@codesourcery.com>

	* doc/cppopts.texi:  Use of -idirafter, -iprefix, -iwithprefix, and
	-iwithprefixbefore is not discouraged.

2003-12-28  Mostafa Hagog  <mustafa@il.ibm.com>

	* sbitmap.c (sbitmap_union_of_diff_cg, sbitmap_a_and_b_cg,
	sbitmap_a_xor_b_cg): Accumulate "changed" properly.
	(sbitmap_not): Zero all bits past n_bit.

2003-12-27  Zdenek Dvorak  <rakdver@atrey.karlin.mff.cuni.cz>

	PR opt/13159
	* cfgloopanal.c (mark_irreducible_loops): Fix the strongly connected
	components detection.
	* loop-unswitch.c (unswitch_loop): Preserve simple preheaders.

2003-12-27  Bernardo Innocenti  <bernie@develer.com>

	* config/m68k/uclinux.h (LIB_SPEC): Add elf2flt magic required for
	correct linking of executables using id-based shared libraries.

2003-12-27  Kazu Hirata  <kazu@cs.umass.edu>

	* config/i386/i386-interix.h: Remove uses of "register"
	specifier in declarations of arguments and local variables.
	* config/i386/i386.c: Likewise.
	* config/i386/i386elf.h: Likewise.
	* config/i386/ptx4-i.h: Likewise.
	* config/i386/sysv4.h: Likewise.

2003-12-26  Fariborz Jahanian <fjahanian@apple.com>
	    Geoffrey Keating <geoffk@apple.com>
	    David Edelsohn <edelsohn@gnu.org>

	* config/rs6000/rs6000.c (legitimate_offset_address_p): Do not
	restrict DFmode and TFmode to word alignment.
	* config/rs6000/rs6000.md (movdf_hardfloat64): Use 'o' constraint
	for ld/std and order before mr.

2003-12-26  Andrew Pinski  <pinskia@physics.uc.edu>

	* config/darwin.h (LINK_COMMAND_SPEC): Arrange
	-fprofile-generate to imply -lgcov.

2003-12-26  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (ldm_h8300s_2_normal): Use HImode for
	addresses.

2003-12-25  Kazu Hirata  <kazu@cs.umass.edu>

	* config/m32r/m32r.md: Remove a constraint from a splitter.

2003-12-25  Andrew Pinski  <pinskia@physics.uc.edu>

	PR C++/13429, C/11944
	* c-common.c (c_build_qualified_type): Return early when type is
	error_mark_node.
	(c_apply_type_quals_to_decl): Likewise.

2003-12-25  Kazu Hirata  <kazu@cs.umass.edu>

	* config/alpha/alpha-modes.def: Fix comment formatting.
	* config/alpha/alpha.c: Likewise.
	* config/alpha/alpha.h: Likewise.
	* config/alpha/elf.h: Likewise.
	* config/alpha/lib1funcs.asm: Likewise.
	* config/alpha/openbsd.h: Likewise.
	* config/alpha/vms-cc.c: Likewise.
	* config/alpha/vms-crt0-64.c: Likewise.
	* config/alpha/vms-crt0.c: Likewise.
	* config/alpha/vms-ld.c: Likewise.
	* config/alpha/vms-psxcrt0-64.c: Likewise.
	* config/alpha/vms-psxcrt0.c: Likewise.
	* config/alpha/vms.h: Likewise.
	* config/arc/arc.c: Likewise.
	* config/arm/aof.h: Likewise.
	* config/arm/arm-modes.def: Likewise.
	* config/arm/arm.c: Likewise.
	* config/arm/arm.h: Likewise.
	* config/arm/arm.md: Likewise.
	* config/arm/linux-elf.h: Likewise.
	* config/arm/vxworks.h: Likewise.
	* config/avr/avr.c: Likewise.
	* config/avr/avr.h: Likewise.

2003-12-24  Kazu Hirata  <kazu@cs.umass.edu>

	* config/xtensa/elf.h: Fix comment formatting.
	* config/xtensa/xtensa-protos.h: Likewise.
	* config/xtensa/xtensa.c: Likewise.
	* config/xtensa/xtensa.h: Likewise.

2003-12-24  Kazu Hirata  <kazu@cs.umass.edu>

	* config/avr/avr.c: Fix comment formatting.
	* config/avr/avr.md: Likewise.

2003-12-24  Kazu Hirata  <kazu@cs.umass.edu>

	PR target/12721.
	* config/avr/avr.c: Include ggc.h.
	(tmp_reg_rtx): Declare with GTY.
	(zero_reg_rtx): Likewise.
	(ldi_reg_rtx): Remove.
	(avr_override_options): Initialize zero_reg_rtx and
	ldi_reg_rtx.
	(avr_init): Remove.
	Include gt-avr.h.
	* config/avr/avr.h (LDI_REG_REGNO): Remove.
	Remove externs for tmp_reg_rtx, zero_reg_rtx, and ldi_reg_rtx.

2003-12-24  David Edelsohn  <edelsohn@gnu.org>

	* doc/md.texi: Document PowerPC vector register constraint letter.

2003-12-23  Mark Mitchell  <mark@codesourcery.com>

	* calls.c (expand_call): Recognize calls to "sqrt" and create
	corresponding notes.

2003-12-23  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* config/mips/mips.c (override_options): Use `inform' instead
	of `warning' for -g -mabi=32 and native assembler.

	* config/mips/t-iris6 (CRTSTUFF_T_CFLAGS, TARGET_LIBGCC2_CFLAGS):
	Don't pass -Wno-error.

2003-12-23  David Edelsohn  <edelsohn@gnu.org>

	* function.c (assign_parms): Update max_parm_reg and
	parm_reg_stack_loc when adding new parm reg.

2003-12-23  Kazu Hirata  <kazu@cs.umass.edu>

	* config/ns32k/ns32k.c: Convert to ISO-C.

2003-12-23  Zack Weinberg  <zack@codesourcery.com>

	* config/ia64/ia64.c (ia64_va_arg): Pass pointer for
	variable-sized type through convert_memory_address.
	(ia64_in_small_data_p): Always return false for FUNCTION_DECLs.

2003-12-23  Jan Hubicka  <jh@suse.cz>

	* common.opt (fprofile-generate,fprofile-use): Add.
	* gcc.c (LINK_COMMAND_SPEC): Arrange -fprofile-generate to imply -lgcov
	* opts.c (profile_arc_flag_set, flag_profile_values_set,
	flag_unroll_loops_set, flag_tracer_set,
	flag_value_profile_transformations_set,
	flag_peel_loops_set): New static variables.
	(common_handle_option): Deal with -fprofile-generate/-fprofile-use
	* invoke.texi (-fprofile-generate, -fprofile-use): Describe.

2003-12-23  Mark Mitchell  <mark@codesourcery.com>

	* Makefile.in (OBJS-common): Remove dwarfout.o.
	(dwarfout.o): Remove.
	* common.opt: Remove -gdwarf, -gdwarf+.
	* defaults.h (PREFERRED_DEBUGGING_TYPE): Do not check for
	DWARF_DEBUGGING_INFO.
	* dwarf2out.c: Fix typo in comment.
	* dwarfout.c: Remove.
	* opts.c (common_handle_option): Remove OPT_gdwarf, OPT_gdwarf_.
	* toplev.c (process_options): Remove check for
	DWARF_DEBUGGING_INFO.
	* config/elfos.h (DWARF_DEBUGGING_INFO): Do not #define it or
	#undef it.
	* config/netware.h (DWARF_DEBUGGING_INFO): Likewise.
	* config/ptx4.h (DWARF_DEBUGGING_INFO): Likewise.
	* config/vxworks.h (DWARF_DEBUGGING_INFO): Likewise.
	* config/alpha/unicosmk.h (DWARF_DEBUGGING_INFO): Likewise.
	* config/arc/arc.h (DWARF_DEBUGGING_INFO): Likewise.
	* config/i386/sco5.h (DWARF_DEBUGGING_INFO): Likewise.
	* config/i386/x86-64.h (DWARF_DEBUGGING_INFO): Likewise.
	* config/m32r/m32r.h (DWARF_DEBUGGING_INFO): Likewise.
	* config/mcore/mcore-elf.h (DWARF_DEBUGGING_INFO): Likewise.
	* config/sparc/linux64.h (DWARF_DEBUGGING_INFO): Likewise.
	* config/sparc/liteelf.h (DWARF_DEBUGGING_INFO): Likewise.
	* config/sparc/sol26-sld.h (DWARF_DEBUGGING_INFO): Likewise.
	* config/sparc/sp86x-elf.h (DWARF_DEBUGGING_INFO): Likewise.
	* doc/invoke.texi: Do not mention -gdwarf, -gdwarf-1, -gdwarf-1+,
	or -gdwarf+.
	* doc/tm.texi: Likewise.

	* c-common.c (flag_abi_version): Default to 2.
	* c-cppbuiltin.c (c_cpp_builtins): Define __GXX_ABI_VERSION
	uniformly for versions above 2.
	* doc/invoke.texi: Update documentation for -fabi-version.

2003-12-22  Geoffrey Keating  <geoffk@apple.com>

	* config/rs6000/rs6000.md: Change many instances of '!
	TARGET_POWERPC64' to 'TARGET_32BIT' when the pattern being guarded
	was guarded only because it changed CR0 or the carry bit in XER.

2003-12-23  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/13394
	* toplev.c (rest_of_compilation): Move call to
	check_function_return_warnings right after the sibcall
	optimization pass.

2003-12-23  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR c/13382
	* c-typeck.c (convert_for_assignment): When converting from
	integral type to pointer type, always call convert.

2003-12-22  Mark Mitchell  <mark@codesourcery.com>

	* doc/invoke.texi: Deprecate -fwritable-strings.

	* c-common.c (flag_external_templates): Remove.
	(flag_alt_external_templates): Likewise.
	* c-common.h (flag_external_templates): Remove.
	(flag_alt_external_templates): Likewise.
	* c-opts.c (c_common_handle_option): Unsupport
	-falt-external-templates and -ftemplates.
	* doc/invoke.texi: Remove mention of -fexternal-templates and
	-falt-external-templates.

2003-12-22  Andrew Pinski  <pinskia@physics.uc.edu>

	PR target/13466
	* config.gcc (powerpc-*-darwin): Remove overridden value of need_64bit_hwint.

	* emit-rtl.c (copy_rtx_if_shared): Add comment about its use of
	copy_rtx_if_shared_1.
	(copy_rtx_if_shared_1): Add comment about what the function does.

	* c-decl.c (finish_function): Change order of checks.
	(c_expand_body): Likewise.

2003-12-22  Fariborz Jahanian <fjahanian@apple.com>

	* config/rs6000/rs6000.c (legitimate_offset_address_p): Correct
	check for the legitimate offset when memory of
	DImode/DFmode/TFmode/TImode mode is being referenced and target
	is TARGET_POWERPC64.

2003-12-22  Dale Johannesen  <dalej@apple.com>

	* reload1.c:  Add reg_reloaded_call_part_clobbered.
	(reload_as_needed):  Use it.
	(forget_old_reloads_1):  Ditto.
	(emit_reload_insns):  Ditto.

2003-12-22  Dale Johannesen  <dalej@apple.com>

	PR optimization/12828
	* loop.c:  Add find_regs_nested to look inside CLOBBER(MEM).
	(scan_loop):  Call it.
	* regclass.c (reg_scan_mark_regs):  Look inside CLOBBER(MEM).

2003-12-22  Andrew Pinski  <pinskia@physics.uc.edu>

	PR c/9163
	* c-decl.c (poplevel): Only set DECL_INITIAL of a current function
	if it is non-null.
	(finish_function): Check for error_mark_node or null on DECL_RESULT and
	DECL_RESULT of fndecl.
	(c_expand_body): Only expand when DECL_INITIAL of fndecl is not
	error_mark_node and not null.

2003-12-21  Dan Nicolaescu  <dann@ics.uci.edu>

	* rtl.h (dump_rtx_statistics): Declare it.
	* rtl.c (rtx_alloc_counts, rtx_alloc_sizes, rtvec_alloc_counts,
	rtx_alloc_sizes): New static vars.
	(rtx_alloc, rtvec_alloc): Update them.
	(dump_rtx_statistics): New function.
	* toplev.c (finalize): Call it.
	* ggc-page.c (struct globals): Fix comments. Add new member
	total_allocated_per_order.
	(ggc_alloc): Keep track of the total allocated memory.
	(ggc_print_statistics): Clarify message. Print total allocated
	memory stats.
	* configure.in (gather-detailed-mem-stats): New flag.
	* configure: Regenerate.
	* config.in: Regenerate.
	* doc/install.texi (Configuration): Document
	--enable-gather-detailed-mem-stats.

2003-12-22  Kazu Hirata  <kazu@cs.umass.edu>

	* system.h (CONVERT_HARD_REGISTER_TO_SSA_P): Poison.
	* config/i386/i386.h (CONVERT_HARD_REGISTER_TO_SSA_P): Remove.

2003-12-21  Roger Sayle  <roger@eyesopen.com>

	* config/ia64/hpux.h (TARGET_OS_CPP_BUILTINS): Define _ILP32
	when compiling in ILP32 mode.

2003-12-21  Andrew Pinski  <pinskia@physics.uc.edu>

	* config/rs6000/rs6000.c (rs6000_tls_referenced_p): Return early if
	TARGET_HAVE_TLS is false.

2003-12-21  Kazu Hirata  <kazu@cs.umass.edu>

	* config/ip2k/ip2k-protos.h: Remove the prototype for
	asm_output_section_name.
	* config/ip2k/ip2k.c (asm_output_section_name): Remove.

2003-12-21  Kazu Hirata  <kazu@cs.umass.edu>

	* alias.c: Fix comment formatting.
	* alloc-pool.c: Likewise.
	* bitmap.c: Likewise.
	* bitmap.h: Likewise.
	* bt-load.c: Likewise.
	* c-common.c: Likewise.
	* c-common.h: Likewise.
	* c-decl.c: Likewise.
	* c-opts.c: Likewise.
	* c-pretty-print.c: Likewise.
	* caller-save.c: Likewise.
	* cfghooks.h: Likewise.
	* cgraph.c: Likewise.
	* collect2.c: Likewise.
	* cppfiles.c: Likewise.
	* cpplib.h: Likewise.
	* dwarf2out.c: Likewise.
	* dwarfout.c: Likewise.
	* emit-rtl.c: Likewise.
	* final.c: Likewise.
	* function.c: Likewise.
	* gcov.c: Likewise.
	* gcse.c: Likewise.
	* genemit.c: Likewise.
	* ggc.h: Likewise.
	* haifa-sched.c: Likewise.
	* ifcvt.c: Likewise.
	* libgcc2.h: Likewise.
	* loop.c: Likewise.
	* predict.h: Likewise.
	* unwind-libunwind.c: Likewise.
	* varasm.c: Likewise.

2003-12-21  Kazu Hirata  <kazu@cs.umass.edu>

	* config/mn10300/mn10300.c (mn10300_encode_section_info): Fix
	a warning.

2003-12-21  Kazu Hirata  <kazu@cs.umass.edu>

	* config/arm/arm.c: Convert to ISO-C.
	* config/avr/avr.h: Likewise.
	* config/fr30/fr30.c: Likewise.
	* config/ip2k/ip2k.c: Likewise.
	* config/mn10300/mn10300.c: Likewise.

2003-12-20  Andrew Pinski  <pinskia@gcc.gnu.org>
	    Matt Thomas  <matt@3am-software.com>

	PR target/12749
	* config/i386/i386.c (print_operand): Print only the first
	8 characters of the float in hex.

2003-12-20  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.h (TRAMPOLINE_TEMPLATE): Shorten sequence when generating PA
	2.0 code.
	(TRAMPOLINE_CODE_SIZE, MIN_CACHELINE_SIZE): New defines.
	(INITIALIZE_TRAMPOLINE): Rework to pass line length, and aligned start
	and end addresses to I and D cache instruction patterns.
	* pa.md (anddi3, iordi3): Change predicates of operands 1 and 2 to
	and_operand and ior_operand, respectively.  When generating 64-bit
	code, only one operand needs to be a register operand.
	(xordi3): Change predicates of operands 1 and 2 to register_operand.
	(one_cmpldi2): Change predicate of operand 1 to register_operand.
	(dcacheflush, icacheflush): Revise to flush an arbitrary number of
	cache lines.

2003-12-20  Josef Zlomek  <zlomekj@suse.cz>

	PR optimization/13430, PR optimization/12322
	* bb-reorder.c (copy_bb_p): Do not allow block with many successors to
	be copied.
	(find_traces_1_round): Surround check for fake edges by
	#ifdef ENABLE_CHECKING #endif.

2003-12-20  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR other/7956
	* genmultilib: New variable disable_multilib.  Set it to 'yes'
	if enable_multilib was set to 'no'.  Emit DISABLE_MULTILIB
	if disable_multilib was set to 'yes'.
	* gcc.c: Include multilib.h before tm.h.
	* config/sparc/sol2-bi.h (LINK_ARCH_SPEC): Emit an error
	message for multiarch options if DISABLE_MULTILIB is set.
	* config/sparc/sol2-gld-bi.h (LINK_ARCH_SPEC): Likewise.

2003-12-20  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR c/12085
	* c-typeck.c (build_function_call): Issue a warning if a
	function is called through an incompatible prototype and
	replace the call by a trap in this case.

2003-12-19  James E Wilson  <wilson@specifixinc.com>

	* install.texi (ia64-*-linux): Document minimum libunwind version
	number.

2003-12-19  Per Bothner  <per@bothner.com>

	* langhooks.c (lhd_print_error_function):  Fix for PR c/13110.
	Don't do pp_newline; it causes an extra blank line.
	* pretty-print.c (pp_base_flush):  Clear pp_needs_newline.

2003-12-19  Jason Merrill  <jason@redhat.com>

	* tree.c (get_unwidened): Decide whether to narrow a bitfield
	reference based on TYPE_SIZE, not TYPE_PRECISION.

	* stmt.c (parse_output_constraint): Warn about in-out constraint
	that doesn't allow a register.
	(parse_input_constraint): Warn about matching constraint that
	doesn't allow a register.

2003-12-19  James E Wilson  <wilson@specifixinc.com>

	* flow.c (mark_set_regs, case PARALLEL): Scan loop forwards.
	Add case for ASM_OPERANDS.
	* global.c (global_alloc): Set regs_ever_live for regs_asm_clobbered
	registers.

2003-12-19  Kazu Hirata  <kazu@cs.umass.edu>

	* expr.c (check_max_integer_computation_mode): Remove.
	* dojump.c (do_jump): Don't use MAX_INTEGER_COMPUTATION_MODE.
	* fold-const.c (fold): Likewise.
	* system.h (MAX_INTEGER_COMPUTATION_MODE): Poison.
	* doc/tm.texi (MAX_INTEGER_COMPUTATION_MODE): Remove.

2003-12-19  James E Wilson  <wilson@specifixinc.com>

	* configure.in: Delete libunwind_has_eh_support test.
	* configure: Regenerate.
	* config.gcc (ia64*-*-linux*): Delete reference to t-libunwind-no-eh
	and libunwind_has_eh_support check.
	* config/t-libunwind-no-eh: Delete.

2003-12-19  Joseph S. Myers  <jsm@polyomino.org.uk>

	* c-format.c (print_char_table): Allow 'I' flag on floating point
	decimal formats.

2003-12-19  Stuart Hastings  <stuart@apple.com>

	* gcc/config/i386/i386.c (ix86_expand_call, x86_output_mi_thunk):
	Trivial fixes for i386.c on Darwin/x86.

2003-12-19  Fariborz Jahanian <fjahanian@apple.com>

	* config/rs6000/rs6000.c (legitimate_lo_sum_address_p): Add code to
	recognize macho-style lo_sum adrress patterns.

2003-12-19  Kazu Hirata  <kazu@cs.umass.edu>

	* dwarfout.c: Remove uses of "register" specifier in
	declarations of arguments and local variables.
	* gensupport.c: Likewise.
	* local-alloc.c: Likewise.
	* regclass.c: Likewise.

2003-12-19  Kelley Cook  <kelleycook@wideopenwest.com>

	* config.guess: Remove.

2003-12-19  Jakub Jelinek  <jakub@redhat.com>

	* config/ia64/unwind-ia64.c (ia64_copy_rbs): New function.
	(unw_access_gr): Only call ia64_rse_rnat_addr if addr is above
	regstk_top.
	(uw_frame_state_for): Handle locations inside bundles.
	(uw_init_context_1): Initialize context->rnat.
	Set context->regstk_top to lowest rbs address which has nat collection
	in context->rnat.
	(uw_install_context): Fix rnat restoring.
	Restore ar.rsc to previous state.
	* config/ia64/linux.h (MD_FALLBACK_FRAME_STATE_FOR,
	MD_HANDLE_UNWABI): Handle unwinding through SA_ONSTACK frames.

2003-12-19  Jakub Jelinek  <jakub@redhat.com>

	PR c++/13239
	* builtins.c (expand_builtin_expect_jump): Update
	TREE_VALUE (arglist) if unsave_expr_now langhook
	created a new tree.

2003-12-19  Richard Earnshaw  <rearnsha@arm.com>

	* arm.c (thumb_base_register_rtx_p): Use regno in comparison against
	FIRST_PSEUDO_REGISTER.

2003-12-18  Hartmut Penner  <hpenner@de.ibm.com>

	* gcc/config/rs6000/rs6000.c (USE_ALTIVEC_FOR_ARG_P): Don't check
	for SVR4 ABI.

2003-12-18  Geoffrey Keating  <geoffk@apple.com>

	* config/rs6000/aix.h (OS_MISSING_POWERPC64): Define.
	(OS_MISSING_ALTIVEC): Define.
	* config/rs6000/darwin.h (ASM_SPEC): Be generous about supplying
	-force_cpusubtype_ALL.
	* config/rs6000/rs6000.c (rs6000_override_options): Rearrange
	CPU information table; now always set all CPU-specific values.
	Also, use Altivec and powerpc64 when chip and OS supports them.

2003-12-18  Geoffrey Keating  <geoffk@apple.com>

	* fixinc/inclhack.def (darwin_macho_dyldh): New.
	* fixinc/fixincl.x: Regenerate.

2003-12-18  Dara Hazeghi  <dhazeghi@yahoo.com>

	* version.c (version_string): Renumber as 3.4.0
	* doc/include/gcc-common.texi: Likewise

2003-12-18  Richard Henderson  <rth@redhat.com>

	* genrecog.c (print_host_wide_int): New.
	(write_switch, write_cond): Use it.

2003-12-18  Richard Henderson  <rth@redhat.com>

	* c-decl.c (check_bitfield_type_and_width): Remove enum special
	case suppression of pedwarn.
	* system.h (ENUM_BITFIELD): Use __extension__.
	(CHAR_BITFIELD): Likewise.

2003-12-18  Ulrich Weigand  <uweigand@de.ibm.com>
	    Mark Dettinger  <dettinge@de.ibm.com>

	* config/s390/s390.md (UNSPEC_SRST): New constant.
	("strlendi", "strlensi"): New expanders.
	("*strlendi", "*strlensi"): New insns.

2003-12-18  Mark Mitchell  <mark@codesourcery.com>

	* config/sol2.h (LINK_ARCH32_SPEC): Define in terms of ...
	(LINK_ARCH32_SPEC_BASE): ... this new macro.
	* config/sparc/sol2-bi.h (LINK_ARCH64_SPEC): Define in terms of
	...
	(LINK_ARCH64_SPEC_BASE): ... this new macro.
	* config/sparc/sol2-gld-bi.h (LINK_ARCH32_SPEC): New macro.
	(LINK_ARCH64_SPEC): Likewise.

2003-12-18  Jason Merrill  <jason@redhat.com>

	PR middle-end/13234
	* tree-dump.c (dequeue_and_dump): Handle 'r' and 's' code
	classes.

2003-12-18  Steven Bosscher  <stevenb@suse.de>

	* Makefile.in (tracer.o, bb-reorder.o): Depend on timevar.h
	* toplev.c (rest_of_handle_reorder_blocks, rest_of_handle_tracer):
	Don't push and pop TV_REORDER_BLOCKS timevars, do it...
	* bb-reorder.c (reorder_basic_blocks): ...here, and...
	* tracer.c (tracer): here.

2003-12-18  Ulrich Weigand  <uweigand@de.ibm.com>

	* loop.c (move_movables): Handle combination of m->consec,
	m->move_insn_first, and m->insert_temp all nonzero correctly.

2003-12-18  Kazu Hirata  <kazu@cs.umass.edu>

	* calls.c (load_register_parameters): Don't use
	LOAD_ARGS_REVERSED.
	* system.h (LOAD_ARGS_REVERSED): Poison.
	* doc/tm.texi (LOAD_ARGS_REVERSED): Remove.

2003-12-17  Per Bothner  <per@bothner.com>

	* emit-rtl.c (set_new_first_and_last_label_num):  Remove function.
	* rtl.h (set_new_first_and_last_label_num):  Remove declaration.

2003-12-17  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.c (frv_ifcvt_modify_insn): Don't leave alone
	scratch insns of the then branch that clobber regs needed by the
	else branch.

2003-12-17  Kazu Hirata  <kazu@cs.umass.edu>

	* calls.c (expand_call): Update comments.
	* system.h (PRETEND_OUTGOING_VARARGS_NAMED): Poison.
	* targhooks.c: Do not refer to PRETEND_OUTGOING_VARARGS_NAMED.

2003-12-17  James E Wilson  <wilson@specifixinc.com>
	    Roger Sayle  <roger@eyesopen.com>

	* Makefile.in (gcse.o): Add $(TREE_H) to dependencies.
	* gcse.c: Include tree.h.
	(implicit_set_cond_p): New.
	(find_implicit_sets): Call it.

2003-12-17  Santiago Vila  <sanvila@unex.es>

	* config/kfreebsdgnu.h (TARGET_OS_CPP_BUILTINS): Rename from
	TARET_OS_CPP_BUILTINS.

2003-12-16  Kazu Hirata  <kazu@cs.umass.edu>

	* emit-rtl.c: Fix signed/unsigned comparison warnings.

2003-12-17  Joseph S. Myers  <jsm@polyomino.org.uk>

	* predict.c (struct block_info_def, struct edge_info_def): Change
	bit-fields of width 1 to unsigned int.

2003-12-16  Geoffrey Keating  <geoffk@apple.com>

	PR 12480
	* c-pch.c (pch_init): Improve error message when precompiled
	header can't be written.

	PR 12606
	* c-pch.c (pch_init): Make a PCH file appear invalid while it's
	being written.
	(c_common_write_pch): Make it valid once it's done.

2003-12-17  Ulrich Weigand  <uweigand@de.ibm.com>

	PR target/11992
	* config/s390/s390.md ("*cmpmem_long_64"): Use CLCLE instruction
	instead of CLCL.
	("*cmpmem_long_31"): Likewise.

2003-12-17  Vladimir Makarov  <vmakarov@redhat.com>

	* config/ia64/ia64.c: Add more comments about insn bundling.

2003-12-17  Richard Earnshaw  <rearnsha@arm.com>

	PR optimization/10592
	* caller-save.c (mark_referenced_regs): Don't short-circuit a reg
	or subreg in SET_DEST if it isn't a hard register.

2003-12-17  David Edelsohn  <edelsohn@gnu.org>

	* collect2.c (main): Add -fno-profile-arcs -fno-test-coverage
	-fno-branch-probabilities to arguments when compiling ctors and
	dtors.

2003-12-17  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* config/sparc/sol2.h: Set SUPPORTS_INIT_PRIORITY to 0.
	* config/sparc/sol2-gld.h: Set SUPPORTS_INIT_PRIORITY to 1.

2003-12-17  Richard Earnshaw  <rearnsha@arm.com>

	* arm.c (thumb_base_register_rtx_p): Don't allow virtual registers
	as base registers for sub-word operations.
	(thumb_legitimate_address_p): Simplify REG+REG test.

2003-12-17  Segher Boessenkool  <boessen@de.ibm.com>

	* opts.c (wrap_help): Fix overflow.

2003-12-17  Fred Fish  <fnf@redhat.com>

	* configure.in: Remove code to examine linker scripts and set
	HAVE_MIPS_LIBGLOSS_STARTUP_DIRECTIVES.
	* configure, config.in: Regenerate.

2003-12-16  Mark Mitchell  <mark@codesourcery.com>

	PR c++/12218
	* varasm.c (initializer_constant_valid_p): Allow a conversion from
	an integral constant to an OFFSET_TYPE.

2003-12-16  Kazu Hirata  <kazu@cs.umass.edu>

	PR target/11012
	* config/m32r/m32r.c (gen_compare): Call gen_addsi3 instead of
	gen_cmp_ne_small_const_insn.
	* config/m32r/m32r.md (cmp_ne_small_const_insn): Remove.

2003-12-17  Neil Booth  <neil@daikokuya.co.uk>
	    Joseph S. Myers  <jsm@polyomino.org.uk>

	PR c/3347
	* c-decl.c (enum_decl_context): Remove BITFIELD.
	(grokdeclarator): Take bit-field width as an input.
	Perform bit-field width validation with
	check_bitfield_type_and_width rather than waiting for
	finish_struct.
	(groktypename, groktypename_in_parm_context, start_decl,
	push_parm_decl, grokfield, start_function): Update calls to
	grokdeclarator.
	(check_bitfield_type_and_width): New function.
	(finish_struct): Move bit-field validation to grokdeclarator
	and check_bitfield_type_and_width.

2003-12-16  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR bootstrap/13386
	* configure.in (gcc_cv_ld_hidden): Set to yes on hppa64*-*-hpux* when
	using HP native linker.
	* configure: Rebuilt.

2003-12-16  Mark Mitchell  <mark@codesourcery.com>

	PR c++/13275
	* c-common.h (enum rid): Add RID_OFFSETOF.
	* c-parser.in (rid_to_yy): Ignore RID_OFFSETOF.
	* ginclude/stddef.h (offsetof): Reimplement for C++, using
	__offsetof__.
	* doc/extend.texi: Document __offsetof__.

2003-12-16  Stan Cox  <scox@redhat.com>

	* config/iq2000/iq2000.h: Formatting.
	(MAX_INT_TYPE_SIZE, MAX_INT_TYPE_SIZE, CONST_COSTS, RTX_COSTS)
	(ADDRESS_COST, ASM_OUTPUT_INTERNAL_LABEL, ASM_OUTPUT_INTERNAL_LABEL)
	(IMPLICIT_FIX_EXPR, EASY_DIV_EXPR, SLOW_ZERO_EXTEND): Remove
	* config/iq2000/iq2000.c: Formatting.
	(iq2000_rtx_costs): New.

2003-12-16  Richard Earnshaw  <rearnsha@arm.com>

	* arm.md (addsi3_carryin_shift): Add missing register constraints.

2003-12-16  Loren James Rittle  <ljrittle@acm.org>

	* testsuite/g++.old-deja/g++.eh/badalloc1.C: Tweak to
	pass with -pthread on FreeBSD systems.

2003-12-16  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.c (mips_file_end): Only write symbols that have
	been referenced at some point.

2003-12-16  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.c: Include langhooks.h
	(mips_build_builtin_va_list): Use lang_hooks.types.make_type.

2003-12-16  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/13313
	* combine.c (make_extraction) [REG]: Do not use
	gen_lowpart_for_combine when POS is non-zero.

2003-12-16  Hartmut Penner  <hpenner@de.ibm.com>

	* altivec.h (vec_cmple, vec_all_numeric): Fix typo.
	* testsuite/gcc.dg/altivec-10.c: Test for above.

2003-12-15  David O'Brien  <obrien@FreeBSD.org>

	* Makefile.in (CPPFLAGS): Initialize from configure.

2003-12-15  Roger Sayle  <roger@eyesopen.com>

	PR middle-end/13400
	* ifcvt.c (noce_process_if_block): Disable unconditional write
	optimizations if we could introduce a store to trapping memory
	that wasn't present previously.

2003-12-15  Kazu Hirata  <kazu@cs.umass.edu>

	* system.h (DEFAULT_CALLER_SAVES): Poison.
	* toplev.c (flag_caller_saves): Always initialize with 0.
	* doc/tm.texi (DEFAULT_CALLER_SAVES): Remove.

2003-12-15  Kazu Hirata  <kazu@cs.umass.edu>

	* flow.c (EXIT_IGNORE_STACK): Move to ...
	* defaults.h (EXIT_IGNORE_STACK): ... here.
	* dojump.c (clear_pending_stack_adjust): Don't use #ifdef
	EXIT_IGNORE_STACK.
	* function.c (expand_function_end): Likewise.
	* global.c (global_alloc): Likewise.
	* ra.c (init_ra): Likewise.
	* reload1.c (init_elim_table): Likewise.
	* reorg.c (fill_simple_delay_slots): Likewise.
	* resource.c (init_resource_info): Likewise.
	* doc/tm.texi (EXIT_IGNORE_STACK): Document that the default
	is 0.

2003-12-15  J"orn Rennecke <joern.rennecke@superh.com>

	* reload.c (reg_overlap_mentioned_for_reload_p):
	When looking at a PLUS in X, avoid spuriously returning nonzero
	when IN is a REG or another simple PLUS, or a MEM containing one.

	* loop.c (loop_invariant_p): Amend comment about where new registers
	might come from.

2003-12-15  Andreas Jaeger  <aj@suse.de>

	* config/rs6000/rs6000.c (rs6000_output_function_epilogue): Remove
	handling of obsolete language CHILL.

2003-12-15  Waldek Hebisch  <hebisch@math.uni.wroc.pl>

	* tree.c (initializer_zerop): Add test for empty set.
	* integrate.c (function_cannot_inline_p): Forbid inlining
	functions calling `longjmp'.

2003-12-15  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/11773
	* doc/gcov.texi (Gcov and Optimization): Document inline function
	behaviour. Fix some file suffixes.

2003-12-14  David O'Brien  <obrien@FreeBSD.org>

	* config/i386/i386.h (__amd64, __amd64__): Remove duplicates.

2003-12-14  Mark Mitchell  <mark@codesourcery.com>

	* c-common.h (c_parse_error): Declare it.
	* c-common.c (c_parse_error): New function.
	* c-parse.y (yyerror): Use it.

2003-12-14  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR target/13054
	* pa-protos.h (indexed_memory_operand, borx_reg_operand,
	move_dest_operand, move_src_operand): New protypes.
	(basereg_operand, move_operand, reg_or_nonsymb_mem_operand): Deleted.
	* pa.c (copy_reg_pointer, indexed_memory_operand, move_dest_operand,
	move_src_operand): New functions.
	(basereg_operand, reg_or_nonsymb_mem_operand, move_operand): Delete.
	(reg_or_0_or_nonsymb_mem_operand): Return false for unscaled indexed
	address until cse is not expected on targets with non-equivalent
	space registers.
	(hppa_legitimize_address): Canonicalize unscaled indexed addresses
	on targets non-equivalent space registers.
	(emit_move_sequence): Break out indexed addresses from destination
	operand.  Similarly, break out unscaled indexed addresses from
	source operand on targets with non-equivalent space registers.  Fix
	REG_POINTER flag when possible.  Mark register pointer when creating
	new pointers.
	(print_operand): Handle unscaled index addresses.
	* pa.h (IS_INDEX_ADDR_P, IS_LO_SUM_DLT_ADDR_P): New macro subroutines
	for EXTRA_CONSTRAINT.
	(EXTRA_CONSTRAINT): Rework to make more readable.
	(MODE_OK_FOR_SCALED_INDEXING_P, MODE_OK_FOR_UNSCALED_INDEXING_P): New
	subroutines for GO_IF_LEGITIMATE_ADDRESS.
	(GO_IF_LEGITIMATE_ADDRESS): Rework using new subroutines.  Allow scaled
	and unscaled addresses.  Canonicalize unscaled indexed addresses on
	targets with non-equivalent space registers.  Document issues in
	handling indexed address modes on PA-RISC.
	(PREDICATE_CODES): Update for new and deleted predicates.
	* pa.md (move_dest_operand, move_src_operand, indexed_memory_operand):
	Use new predicates in move patterns.
	Add peephole2 patterns to optimize floating point stores.  Fix
	constrain preferencing in move patterns.  Delete patterns for handling
	unscaled indexed memory loads.  Add missing load and store with
	base-register modification patterns.  Correct SFmode floating point
	store pattern.  Add missing zero extension loads.

2003-12-13  Steven Bosscher  <stevenb@suse.de>

	* ggc-zone.c (struct alloc_zone): Don't pre-declare, it already
	comes in with ggc.h.  Add a new bool field `dead'.
	(destroy_ggc_zone): Don't destroy a zone at once.  Instead, only
	set the `dead' flag for the dead zone.  Wrap a sanity check in
	ENABLE_CHECKING.
	(ggc_collect_1): Always mark and sweep if a zone has the `dead'
	flag set.
	(ggc_collect): Free dead zones after collecting.

2003-12-13  Jan Hubicka  <jh@suse.cz>

	* coverage.c (get_coverage_counts):  Use inform instead of warning
	about missing profile.

2003-12-12  Steven Bosscher  <stevenb@suse.de>

	* Makefile.in (opts.o, explow.o): Depend on langhooks.h

2003-12-12  Geoffrey Keating  <geoffk@apple.com>

	* config.gcc <i[34567]86-*-darwin*>: Don't use fixproto.
	<powerpc-*-darwin*>: Likewise.

2003-12-12  Jakub Jelinek  <jakub@redhat.com>

	* config/ia64/linux.h (IA64_GATE_AREA_END): Increase by 64K.
	(MD_FALLBACK_FRAME_STATE_FOR): Set fpsr_loc, br_loc[6] and
	br_loc[7].  Update comment.
	(MD_HANDLE_UNWABI): Define.
	* config/ia64/unwind-ia64.c (struct unw_state_record): Add
	unwabi field.
	(struct _Unwind_Context): Increase br_loc array size to 8 entries.
	(desc_abi): Set unwabi.
	(uw_update_reg_address): Allow br up to 7.
	(uw_update_context): Invoke MD_HANDLE_UNWABI if defined.
	(uw_install_context): Load b1..b5 from correct locations.
	Fix insn loading ar.fpsr.
	* doc/tm.texi: Document MD_HANDLE_UNWABI.

2003-12-12  Roger Sayle  <roger@eyesopen.com>

	PR optimization/13037
	* loop.c (update_giv_derive): Ignore redundant sets of a biv when
	calculating how to derive a giv from a biv.

2003-12-12  Neil Booth  <neil@daikokuya.co.uk>

	PR preprocessor/12935 preprocessor/12952 preprocessor/13046
	* cpplib.c (prepare_directive_trad): Clear skipping only in
	#if and #elif directives.
	(do_undef): Call the handler even if the identifier is not a macro.
	* cpptrad.c (scan_parameters): Emit an error message.
	(_cpp_create_trad_definition): Remember the params list even on
	failure.

2003-12-11  Zack Weinberg  <zack@codesourcery.com>

	* arm.c (ARM_ADDRESS_COST, THUMB_ADDRESS_COST): Convert macros
	to inline functions: arm_arm_address_cost, arm_thumb_address_cost
	respectively.
	(arm_address_cost): Use 'em.

2003-12-12  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config/alpha/osf.h (TARGET_OS_CPP_BUILTINS): Define
	__STDC_VERSION__ to ISO C94 for C++.

	* fixinc/inclhack.def (alpha_wchar): New fix.
	* fixinc/fixincl.x: Regenerate.
	* fixinc/tests/base/wchar.h: New file.

2003-12-11  David Mosberger  <davidm@hpl.hp.com>

	* unwind-libunwind.c (_Unwind_SetGR): Clear the NaT bit as
	required by C++ ABI for Itanium.
	* config/t-libunwind (LIB2ADDEH): Remove unwind-libunwind.c.
	* config/t-libunwind-no-eh: New file.
	* configure.in: Check libunwind for _Unwind_Resume() and if it's
	present, set libunwind_has_eh_support to "yes".
	* configure: Regenerate.
	* config.gcc (ia64*-*-linux*): If $libunwind_has_eh_support is
	set to yes, use t-libunwind, otherwise, use t-libunwind-no-eh.

2003-12-11  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.c (mips_global_pointer): Force functions with
	a nonlocal goto to set up $gp.

2003-12-11  James E Wilson  <wilson@specifixinc.com>

	PR target/13132
	* function.c (gen_mem_addressof): When no decl, explicitly clear flag
	bits.

2003-12-12  Nick Clifton  <nickc@redhat.com>

	* config/m32r/m32r.c: Convert to ISO-C

2003-12-12  Kazuhiro Inaoka  <inaoka.kazuhiro@renesas.com>

	* doc/invoke.texi: Replace Mitsubishi with Renesas.
	* config/m32r/m32r.h: Ditto.
	* config/m32r/m32r.c: Ditto.
	* config/m32r/m32r.md: Ditto.

2003-12-11  Steven Bosscher  <steven@gcc.gnu.org>

	* basic-block.h (BLOCK_HEAD, BLOCK_END): Remove.
	(BLOCK_HEAD_TREE, BLOCK_END_TREE): Remove.
	(basic_block_def): Rename `head' to `head_' and `end' to `end_'.
	(BB_HEAD, BB_END): New accessor macros for the `head_' and `end_'
	fields of a basic block.
	* bb-reorder.c, bt-load.c, caller-save.c, cfg.c, cfganal.c,
	cfgbuild.c, cfgcleanup.c, cfglayout.c, cfgloop.c, cfgloopanal.c,
	cfgloopmanip.c, cfgrtl.c, combine.c, conflict.c, df.c, emit-rtl.c,
	final.c, flow.c, function.c, gcse.c, global.c, graph.c,
	haifa-sched.c, ifcvt.c, lcm.c, local-alloc.c, loop-unswitch.c,
	loop.c, postreload.c, predict.c, profile.c, ra-build.c, ra-debug.c,
	ra-rewrite.c, ra.c, recog.c, reg-stack.c, regclass.c, regmove.c,
	regrename.c, reload1.c, resource.c, sched-ebb.c, sched-rgn.c,
	sibcall.c, tracer.c, config/frv/frv.c, config/i386/i386.c,
	config/ia64/ia64.c: Use the BB_HEAD and BB_END macros instead of
	accessing the `head' and `end' fields of a basic block directly.

	* gengtype.c: Teach about "void**" pointers and "void *" function
	types.  Fixes earlier commit.

2003-12-10  Geoffrey Keating  <geoffk@apple.com>

	* doc/extend.texi (Vector Extensions): Document that bitwise
	operations also work on vectors.

2003-12-10  Richard Earnshaw  <rearnsha@arm.com>

	* arm.md: New split patterns for optimizing bitfield accesses.

2003-12-10  Steven Bosscher  <stevenb@suse.de>

	* README.Portability: Remove K+R section.

	* gengtype-lex.l: Teach about "void**" pointers and
	"void*" function types.

2003-12-10  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR target/13354
	* config/sparc/sparc.c (sparc_output_mi_thunk): Load DELTA
	manually if one can do that with only one instruction.

2003-12-10  Nick Clifton  <nickc@redhat.com>

	* config.gcc (arm-linux): Include linux.h in tm_file so that
	LINUX_TARGET_OS_CPP_BUILTINS is defined.
	* config/arm/linux-elf.h (LIB_SPEC): Protect the definition.

2003-12-09  James E Wilson  <wilson@specifixinc.com>

	* rtl.def (CODE_LABEL, NOTE): Correct operand numbers in comments.

2003-12-09  Matt Austern  <austern@apple.com>

	PR c/13134
	* c-decl.c (duplicate_decls): Copy visibility flag when appropriate.

2003-12-09  Kazuhiro Inaoka <inaoka.kazuhiro@renesas.com>

	* config/m32r/m32r.h: Add support for m32r2 processor.  Including
	a new command line option -m32r2 to select it.
	* config/m32r/m32r.c: Add support for the new processor variant.
	* config/m32r/m32r.md: Likewise.
	* config/m32r/t-m32r: Add m32r2 multilibs.
	* doc/invoke.texi: Document the new command line switch.

2003-12-08  Kazu Hirata  <kazu@cs.umass.edu>

	* defaults.h (LOCAL_REGNO): Give the default definition.
	* flow.c (LOCAL_REGNO): Remove.
	* reload1.c (LOCAL_REGNO): Likewise.

2003-12-08  Geoffrey Keating  <geoffk@apple.com>

	PR target/11848
	* rs6000.h (CANNOT_CHANGE_MODE_CLASS): Allow change of mode
	in floating-point registers between TFmode and DImode.
	* rs6000.c (rs6000_emit_move): Split moves early.
	(secondary_reload_class): Random Whitespace Change.
	(rs6000_split_multireg_move): Support moves involving FP registers.
	Emit instructions directly.
	* rs6000-protos.h (rs6000_split_multireg_move): Update prototype.
	* altivec.md: Update for changes to rs6000_split_multireg_move.
	* rs6000.md: Update for changes to rs6000_split_multireg_move.
	(movtf_internal): Support moves to/from GPRs.

2003-12-08  Stuart Hastings  <stuart@apple.com>

	* config/i386/i386.md: Typo in split of fp-valued if_then_else.

2003-12-08  James E Wilson  <wilson@specifixinc.com>

	PR target/13132
	* expmed.c (extract_bit_field): Only call mode_for_size for scalar
	integer modes.

2003-12-08  Nathanael Nerode  <neroden@gcc.gnu.org>

	* doc/install.texi: Revert change of Dec 7; gcc is still a 2.13
	directory.

2003-12-08  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.md (subdi2): Merge with _internal insn_and_split,
	by using match_scratch.
	(negdi2): New.

2003-12-08  Jason Merrill <jason@redhat.com>
	    Daniel Berlin  <dberlin@dberlin.org>

	PR debug/11114
	Support namespaces in DWARF 2 output.
	* dwarf2out.c (gen_namespace_die): New function.
	(force_namespace_die, setup_namespace_context): New fns.
	(declare_in_namespace): New fn.
	(gen_decl_die): Call declare_in_namespace.  Handle namespaces.
	(dwarf2out_decl): Handle namespaces.
	(scope_die_for): Pass through a namespace scope.
	(class_scope_p): Rename to class_or_namespace_scope_p.
	(gen_subprogram_die, gen_variable_die): Adjust.
	(gen_struct_or_union_die): Always emit a declaration
	if context_die is a namespace.

2003-12-08  Jan Hubicka  <jh@suse.cz>

	* unwind-pe.h (read_uleb128): Fix handling of large values
	(read_sleb128): Fix handling of large values

2003-12-08  Andrew Pinski  <pinskia@physics.uc.edu>

	PR middle-end/10060
	* emit-rtl.c (copy_rtx_if_shared): Split out into ...
	(copy_rtx_if_shared_1): here and optimize the last one
	in the sequence into tail-recursion.
	(reset_used_flags): Optimize the last one
	in the sequence into tail-recursion.

2003-12-08  Richard Earnshaw  <rearnsha@arm.com>

	* arm.md: New split to transform ((X << y) - 1) into ~(~(X-1) << y)
	for constant X.

2003-12-08  Richard Sandiford  <rsandifo@redhat.com>

	* calls.c (expand_call): Don't try using tail or recursive calls
	after the function body has been expanded.

2003-12-08  Jan Hubicka  <jh@suse.cz>

	* i386.md (cmpstr expander): Obey TARGET_INLINE_ALL_STRINGOPS

2003-12-08  Arnaud Charlet  <charlet@act-europe.fr>

	PR ada/13324, PR ada/12614
	* doc/install.texi: Update requirements for building Ada.

2003-12-07  David Edelsohn  <edelsohn@gnu.org>
	    Graham Reed <greed@pobox.com>

	* collect2.c (GCC_OK_SYMBOL): Add support for AIX C_WEAKEXT.
	(GCC_UNDEF_SYMBOL): Same.

2003-12-07  Kazu Hirata  <kazu@cs.umass.edu>

	* final.c (final_scan_insn): Don't use FINAL_PRESCAN_LABEL.
	* system.h (FINAL_PRESCAN_LABEL): Poison.
	* doc/tm.texi (FINAL_PRESCAN_LABEL): Remove.

2003-12-07  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (compare): Combine toplevel and $(SUBDIRS) cases.

2003-12-07  Nathanael Nerode  <neroden@gcc.gnu.org>

	* configure.in, aclocal.m4: Revert to pre-2.5x conversion status.
	* configure: Regenerate with autoconf 2.13.

	* configure.in: Replace AC_INIT, AC_OUTPUT, AC_CANONICAL_SYSTEM
	with modern equivalents.
	* configure: Regenerate.

	* configure.in: Replace gcc_AC_CHECK_TYPE with AC_CHECK_TYPE.
	* aclocal.m4 (gcc_AC_CHECK_TYPE): Remove.
	* configure: Regenerate.

	* configure: Regenerate with (preferred) autoconf 2.57.
	* doc/install.texi: Note that 'gcc' is now a 2.57 directory.

2003-12-07  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/12965
	* caller-save.c (save_call_clobbered_regs): Do not save/restore
	registers around no-return calls.

2003-12-07  Nathanael Nerode  <neroden@gcc.gnu.org>

	* configure.in: Make minimum necessary changes for autoconf 2.5x.
	* aclocal.m4: Make minimum necessary changes for autoconf 2.5x.
	* configure: Regenerate with autoconf 2.58.

2003-12-07  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/13318
	* loop.c (express_from): Protect integer division from overflow.

2003-12-07  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/13060
	* function.c (fixup_var_refs_1) [SUBREG]: Recognize even if a
	replacement already exists.  Fix again the whole insn if that fails.

2003-12-06  Andrew Pinski  <pinskia@physics.uc.edu>

	* config/rs6000/rs6000.c (macho_branch_islands): Use
	HOST_WIDE_INT_PRINT_UNSIGNED.

2003-12-06  Richard Sandiford  <rsandifo@redhat.com>

	* varasm.c (incorporeal_function_p): New.
	(assemble_external): Use it as a filter.
	* config/mips/mips.c (mips_output_external): Don't check for builtin
	functions here.

2003-12-06  Richard Earnshaw  <reanrsha@arm.com>

	* arm.md (IOR (COMPARISON) (AND)): New define_splits.

2003-12-06  Kelley Cook  <kcook@gcc.gnu.org>

	* Makefile.in (program_transform_cross_name): Delete.
	(GCC_CROSS_NAME, CPP_CROSS_NAME): Delete.
	(PROTOIZE_CROSS_NAME, UNPROTOIZE_CROSS_NAME): Delete.
	(AR_FOR_TARGET, RANLIB_FOR_TARGET, NM_FOR_TARGET): Adjust for above.
	(install_cpp, install_driver, install-man, uninstall): Likewise.

2003-12-06  Alan Modra  <amodra@bigpond.net.au>

	PR 13169
	* basic-block.h (PROP_ASM_SCAN): Define.
	* final.c (regs_asm_clobbered): New array.
	* regs.h (regs_asm_clobbered): Declare.
	* flow.c (life_analysis): Init it.
	(mark_set_regs): Set PROP_ASM_SCAN for asms.
	(mark_set_1): Set regs_asm_clobbered.
	* global.c (global_alloc): Don't set eliminable_regset when
	regs_asm_clobbered.

2003-12-05  Mark Mitchell  <mark@codesourcery.com>

	* config/ia64/ia64.h (MUST_PASS_IN_STACK): Define.

	PR c++/13314
	* emit-rtl.c (set_mem_attributes_minus_bitpos): Robustify.

2003-12-05  Andrew Pinski <pinskia@physics.uc.edu>

	PR driver/13211
	* gcc.c (execute) Increment execution_count when returning
	early because verbose_only_flag is true.

2003-12-05  Per Bothner  <pbothner@apple.com>

	* cppfiles.c (file_hash_hash):  New static function.
	(hash_string_eq):  Renamed static function to file_hash_eq.
	(_cpp_init_files):  Create file_hash table with above callbacks.
	(cpp_included):  Must use htab_find_with_hash insead of htab_find.
	(_cpp_find_find, make_cpp_dir):  Must use htab_find_slot_with_hash.

2003-12-05  Per Bothner  <pbothner@apple.com>

	* line-map.h (source_location):  New typedef.
	(fileline):  Redefined as source_location.
	(struct line_map, linemap_add, linemap_lookup):  Replace filefile
	by source_location.
	* line-map.c (linemap_add, linemap_lookup):  Use source_location.

2003-12-05  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.c (alpha_build_builtin_va_list): Add dummy
	field to suppress -Wpadded warnings.

2003-12-05  Stuart Hastings  <stuart@apple.com>

	* config/rs6000/rs6000.md: Correct macro test of TARGET_MACHO.

2003-12-05  Stuart Menefy <stuart.menefy@st.com>
	    J"orn Rennecke <joern.rennecke@superh.com>

	PR target/13302
	* sh.c (sh_build_builtin_va_list): Use (*lang_hooks.types.make_type).

2003-12-05  Roger Sayle  <roger@eyesopen.com>

	* dojump.c (do_jump): If the expression being compared against
	zero, is the subreg of a promoted variable, perform the comparison
	in the promoted mode.
	* simplify-rtx.c (simplify_unary_operation): Optimize sign and
	zero-extensions of subregs of promoted variables where the
	extension is identical to that used to promote the variable.

2003-12-05  Hans-Peter Nilsson  <hp@axis.com>

	PR target/13256
	* resource.h (enum mark_resource_type): Remove member MARK_DEST.
	The only user changed as follows:
	* resource.c (mark_set_resources) <case SET>: Always recurse for
	SET_SRC (x).
	<case SIGN_EXTRACT, case ZERO_EXTRACT>: Always recurse on
	operands.
	<case STRICT_LOW_PART>: Delete, deferring to default code.

2003-12-05  Waldek Hebisch <hebisch@math.uni.wroc.pl>

	* stmt.c (expand_nl_goto_receiver): Copy hard register clobbers
	and ASM_INPUT barrier from expand_builtin_setjmp_receiver.

2003-12-05  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.c (mips_expand_call): Don't allow laziy binding
	for n32 & n64 abicalls.

2003-12-05  Richard Sandiford  <rsandifo@redhat.com>

	PR bootstrap/13145
	* config/mips/mips.h (FIRST_PSEUDO_REGISTER): Adjust comment.
	* config/mips/mips.c (mips_reg_names, mips_sw_reg_names): Add $fcall.
	(mips_load_got): Always create a constant MEM.
	(mips_expand_call): Use load_callsi and load_calldi.
	* config/mips/mips.md (UNSPEC_LOAD_CALL, FAKE_CALL_REGNO): New consts.
	(load_callsi, load_calldi): New patterns.

2003-12-05  Peter Gerwinski <peter@gerwinski.de>

	* tree.def (PLACEHOLDER_EXPR): Clarify commentary.

2003-12-05  Steven Bosscher  <stevenb@suse.de>

	* config/d30v/d30v-protos.h , config/d30v/d30v.c,
	config/dsp16xx/dsp16xx-protos.h, config/dsp16xx/dsp16xx.c,
	config/fr30/fr30-protos.h, config/fr30/fr30.c,
	config/i370/i370-protos.h, config/i370/i370.c,
	config/i960/i960-protos.h, config/i960/i960.c,
	config/ip2k/ip2k-protos.h, config/ip2k/ip2k.c,
	config/m32r/m32r-protos.h, config/m32r/m32r.c,
	config/mn10300/mn10300-protos.h, config/mn10300/mn10300.c,
	config/ns32k/ns32k-protos.h, config/ns32k/ns32k.c:
	Convert to ISO C90 function declarations and definitions.

2003-12-05  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* doc/extend.texi (Constructing Calls): Add warning about
	the limitations of the functions.

2003-12-05  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR middle-end/11151
	* function.h (struct function): New field 'x_naked_return_label'.
	* function.c (free_after_compilation): Set it to NULL.
	(expand_function_end): Emit 'naked_return_label' if it exists.
	* rtl.h (expand_naked_return): Declare.
	* stmt.c (expand_naked_return): New function to generate a
	jump to 'naked_return_label'.
	* builtins.c (expand_builtin_return): Call expand_naked_return
	instead of expand_null_return.
	* config/sparc/sparc.md (untyped_return): Likewise.

2003-12-04  Andrew Pinski  <pinskia@physics.uc.edu>

	PR target/11322
	* config/sh/netbsd-elf.h (NO_PROFILE_COUNTERS): Define.

	PR target/12467
	* config/rs6000/altivec.md (altivec_vmsummbm): Fix typo.

2003-12-04  Stuart Hastings  <stuart@apple.com>

	* rs6000.c (output_call, macho_branch_islands,
	add_compiler_branch_island, no_previous_def, get_previous_label)
	Revisions of xx_stub functions for branch islands,
	add -fPIC support for Darwin.
	* rs6000-protos.h (output_call) Prototype.
	* rs6000.md Use output_call.
	* invoke.texi Explain Darwin semantics of -longcall.
	* testsuite/gcc.dg/darwin-abi-1.c Revise testcase for -longcall/jbsr.

2003-12-04  Richard Henderson  <rth@redhat.com>

	* config/i386/i386.md (addqi3_carry): Use q not r constraints.
	(subqi3_carry): Likewise.

2003-12-04  J"orn Rennecke <joern.rennecke@superh.com>

	PR optimization/13260
	* sh-protos.h (sh_expand_t_scc): Declare.
	* sh.h (PREDICATE_CODES): Add cmpsi_operand.
	* sh.c (cmpsi_operand, sh_expand_t_scc): New functions.
	* sh.md (cmpsi): Use cmpsi_operand.  If T_REG is compared to
	something that is not a CONST_INT, copy it into a pseudo register.
	(subc): Fix description of new T value.
	(slt, sgt, sge, sgtu): Don't clobber T after rtl generation is over.
	(sltu, sleu, sgeu): Likewise.
	(seq, sne): Likewise. Use sh_expand_t_scc.

2003-12-04  Nathanael Nerode  <neroden@gcc.gnu.org>

	* configure.in: Generalize the CONFIG_HEADERS pattern under which
	we stamp cstamp-h.
	* configure: Regenerate.

	* configure.in: Pull AC_CHECK_HEADER call out of shell if statement
	to avoid trouble when updating to autoconf 2.5x.
	* configure: Regenerate (with autoconf 2.13 still).

2003-12-04  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.md (truncdiqi2): Use andi opcode for immediate.
	(reload_outdf+1,reload_outdf+2): Remove constraints.
	(movv16sf_i): Fxi multiplier for SUBREG_BYTE.
	(movv8qi_i+2): Zero-extend low byte before adding it to high byte.
	(fipr, ftrv): Add .s suffix to opcode.

2003-12-04  Richard Sandiford  <rsandifo@redhat.com>

	PR target/13186

	Revert all of the following patch, except the addition of
	hook_bool_machine_mode_true:

	2003-11-02  Richard Sandiford  <rsandifo@redhat.com>

	* Makefile.in (targhooks.o, reload.o): Update dependencies.
	(GTFILES): Add targhooks.c.
	(gt-targhooks.h): New rule; depend on s-gtype.
	* target.h (direct_pool_load_p): New hook.
	* target-def.h (TARGET_DIRECT_POOL_LOAD_P): New macro.
	(TARGET_INITIALIZER): Include it.
	* targhooks.h (default_direct_pool_load_p): Declare.
	(hook_bool_machine_mode_true): Declare.
	* targhooks.c: Include insn-config.h, recog.h, ggc.h and
	gt-targhooks.h.
	(pool_symbol): New variable.
	(default_direct_pool_load_p): New function.
	(hook_bool_machine_mode_true): New function.
	* reload.c: Include target.h.
	(find_reloads): If an alternative will force a constant into memory,
	count an extra reload if constant pool symbols are not valid
	addresses.  If an alternative uses memory to move values between
	registers, count the move as two reloads rather than one.
	* config/s390/s390.c (TARGET_DIRECT_POOL_LOAD_P): Define.
	* doc/tm.texi (TARGET_DIRECT_POOL_LOAD_P): Document.

2003-12-03  Mark Mitchell  <mark@codesourcery.com>

	* config/ia64/hpux.h (TARGET_HAVE_TLS): Define it to false.
	* config/ia64/ia64.h (TARGET_HAVE_TLS): Define it to true if
	HAVE_AS_TLS is true.
	* config/ia64/ia64.c (TARGET_HAVE_TLS): Do not define it.

2003-12-03  James E Wilson  <wilson@specifixinc.com>

	* gcc.c (init_spec): Pass -lunwind to init_gcc_specs in eh_name.

	* gcc-page.c (extra_order_size_tab): Correct comment.

2003-12-03  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (push): Call gen_push_h8300hs_advanced
	instead of gen_push_h8300hs.
	(pop): Call gen_pop_h8300hs_advanced instead of
	gen_pop_h8300hs.
	* config/h8300/h8300.h (TRAMPOLINE_SIZE): Use Pmode.
	* config/h8300/h8300.md (*tablejump_h8300hs_advanced):
	Tighten the predicate.
	(*tablejump_h8300hs_normal): Tighten the predicate.
	(push_h8300hs): Change to
	push_h8300hs_advanced.
	(pop_h8300hs): Change to pop_h8300hs_advanced.

2003-12-03  Eric Christopher  <echristo@redhat.com>

	* rtl.c: Fix typo.
	* config/mips/mips.h: Ditto. Fix formatting.

2003-12-04  Ben Elliston  <bje@wasabisystems.com>

	* future.options: Remove. Move to gnu.org web pages.

2003-12-03  Eric Christopher  <echristo@redhat.com>

	* c-parse.in (c_in_iteration_stmt, c_in_case_stmt): Move
	from here...
	* c-tree.h: to here.

2003-12-03  Jan Hubicka  <jh@suse.cz>

	PR optimization/12324
	* toplev.c  (rest_of_decl_compilation): Do not deffer when compiling
	in unit-at-a-time mode.

2003-12-03  Jakub Jelinek  <jakub@redhat.com>

	* expr.c (store_constructor): Only set RTX_UNCHANGING_P for
	read-only field if cleared is 0.

2003-12-03  Nathanael Nerode  <neroden@gcc.gnu.org>

	* config.gcc: Mark obsolete targets for GCC 3.4.

2003-12-03  Zack Weinberg  <zack@codesourcery.com>

	* aclocal.m4 (AM_ICONV): Add explicit check for iconv.h.
	* config.in, configure.in: Regenerate.
	* cpphash.h: Check both HAVE_ICONV and HAVE_ICONV_H before
	including iconv.h.

2003-12-03  Alan Modra  <amodra@bigpond.net.au>

	PR target/11229
	* cse.c (cse_insn): Set classp using src_const_elt if
	src_eqv_elt is NULL.

2003-12-03  Richard Earnshaw  <rearnsha@arm.com>

	* gcse.c (reg_clear_last_set): New function.
	(reg_set_info): If data is non-null, treat it as an sbitmap of
	registers, set the bit for the register being set.
	(compute_store_table): Allocate last_set_in with xcalloc.  Do not
	memset this array on each iteration.  Pass reg_set_in_block[bb->index]
	to note_stores while computing last_set_in instead of scanning
	last_set_in after the first pass through the insns.
	Clear last_set_in using reg_clear_last_set instead of explicitly
	rescanning after each insn.  If checking is enabled, assert that
	last_set_in is completely zeroed after each bb has been processed.

2003-12-02  Geoffrey Keating  <geoffk@geoffk.org>

	* df.c (df_uses_record) <MEM>: The argument of a MEM is read-only,
	never read-write.
	<REG>: Delete incorrect comment.
	<SET>: Remove 'use_flags' variable.

2003-12-03  David Edelsohn  <edelsohn@gnu.org>

	* function.c (assign_parms): Make sure parm PARALLEL combined
	in reg is composed of more than one object and the mode really
	produces a reg.

2003-12-03  Jan Hubicka  <jh@suse.cz>

	* i386.c (classify_argument): Make it 64bit clean.

2003-12-02  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.c (mips_output_external): Replace checks for
	specific builtin-in functions with a check for DECL_BUILTIN_IN.

2003-12-02  Richard Henderson  <rth@redhat.com>

	* rtl.h (PUT_CODE, PUT_MODE): Remove ENUM_BITFIELD cast.
	* tree.h (TREE_SET_CODE): Likewise.
	* recog.h (struct insn_operand_data): Move const after ENUM_BITFIELD.

2003-12-02  Ben Elliston  <bje@wasabisystems.com>

	* dbxstclass.h: Rename from this ..
	* xcoff.h: .. to this.
	* xcoffout.c: Include xcoff.h.

2003-12-01  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (GCC_CFLAGS): Add -Wold-style-definition.

2003-12-01  James Lemke <jim@wasabisystems.com>

	* config/arm/arm.c (arm_rtx_costs): Improve for xscale multiply.

2003-12-01  Roger Sayle  <roger@eyesopen.com>

	PR optimization/11634
	* recog.c (split_insn): Factor test of INSN_P and handling of
	set_noop_p out of here into the two callers.
	(split_all_insns): Add INSN_P test and set_noop_p handling here.
	If deleting a no-op set after reload that has a REG_UNUSED note,
	mark the basic block as changed and recalculate life information.
	(split_all_insns_noflow): Add INSN_P test and set_noop_p handling
	here.

2003-12-01  Roger Sayle  <roger@eyesopen.com>

	PR optimization/12322
	* gcse.c (struct ls_expr): Change type of hash_index from int to
	unsigned int.
	(hash_expr): Document hash_table_size parameter and wrap long line.
	(ldst_entry): Calculate expression's hash_index and record in ptr.
	(trim_ld_motion_mems): Use hash_index to search a single bucket
	instead of scanning the entire hash_table.  Remove the "del" local
	variable and use the equivalent "expr == 0" instead.  Change last
	to be a pointer to the pointer to the current element, to simplify
	and speed-up deleting from a linked list.

2003-12-01  James E Wilson  <wilson@specifixinc.com>

	* doc/contrib.texi: Update David Mosberger.

	* doc/c-tree.texi (CONSTRUCTOR): Clarify element order and handling
	of missing fields.

	PR target/8407
	* config/ia64/ia64.c (ia64_function_arg): For single-reg HFA, call
	gen_rtx_REG to create new reg with argument mode.

2003-12-01  Steven Bosscher  <stevenb@suse.de>

	* ggc.h (struct alloc_zone): Move forward declaration up.
	(new_ggc_zone): New function prototype.
	(destroy_ggc_zone): Ditto.
	* ggc-simple.c (new_ggc_zone): New function, does nothing.
	(destroy_ggc_zone): Ditto.
	* ggc-page.c (new_ggc_zone): New function, does nothing.
	(destroy_ggc_zone): Ditto.
	* ggc-zone.c (struct page_entry): Fix comment.
	(ggc_alloc_typed): Use a switch statement instead of ifs.
	(new_ggc_zone): New function to set up a new GC zone.
	(destroy_ggc_zone): New function to remove a GC zone.
	init_ggc): Use new_ggc_zone to set up the default zones.
	(ggc_collect): Walk a list of zones, instead of just the
	default zones.  Report statistics using the zone name.

2003-12-01  Ulrich Weigand  <uweigand@de.ibm.com>

	* unroll.c (find_splittable_givs): Add missing extend_value_for_giv.

2003-12-01  Roger Sayle  <roger@eyesopen.com>

	PR optimization/12628
	* toplev.c (rest_of_handle_jump_bypass): Call reg_scan.
	* regclass.c (reg_scan): Include allocate_reg_info time in
	TV_REG_SCAN.  Minor clean-ups.
	(reg_scan_update): Minor clean-ups.

2003-12-01  Ulrich Weigand  <uweigand@de.ibm.com>

	* config.gcc (s390x-ibm-tpf*): Add extra_parts.

2003-12-01  James E Wilson  <wilson@specifixinc.com>

	* config/ia64/ia64.h (FUNCTION_ARG_REGNO_P): Use AR_REG_FIRST not
	GR_ARG_FIRST.

2003-12-01  Zack Weinberg  <zack@codesourcery.com>

	* common.opt: Remove -fgnu-linker.
	* flags.h: Remove flag_gnu_linker.
	* opts.c: Don't handle OPT_fgnu_linker.
	* toplev.c: Don't initialize flag_gnu_linker.
	Remove gnu-linker entry from f_options.
	* config/dsp16xx/dsp16xx.h (OPTIMIZATION_OPTIONS):
	Don't reset flag_gnu_linker.
	* config/mips/mips.c (override_options): Likewise.
	* doc/invoke.texi: Remove all mention of -fgnu-linker.

2003-12-01  Daniel Berlin  <dberlin@dberlin.org>

	* ggc-zone.c (ggc_pch_write_object): Calculate object size using
	ggc_get_size (which accounts for large objects properly).

2003-12-01  Jeff Sturm  <jsturm@one-point.com>

	PR optimization/13024
	* toplev.c (rest_of_handle_new_regalloc): Remove rebuild_notes
	parameter.
	(rest_of_handle_old_regalloc): Likewise.  Add rebuild_notes
	declaration.  Rebuild jump labels following local_alloc if necessary.
	(rest_of_compilation): Remove rebuild_label_notes_after_reload
	declaration.  Don't pass rebuild_notes parameter to
	rest_of_handle_new_regalloc and rest_of_handle_old_regalloc.
	Don't rebuild jump labels.

2003-12-01  Jeff Law  <law@redhat.com>

	* flow.c (count_or_remove_death_notes_bb): New.  Extracted from
	count_or_remove_death_notes.
	(count_or_remove_death_notes): Use EXECUTE_IF_SET_IN_SBITMAP.

2003-12-01  Andreas Krebbel  <krebbel1@de.ibm.com>

	* builtins.c (expand_builtin_longjmp): Added two memory clobbers.

2003-12-01  Ulrich Weigand  <uweigand@de.ibm.com>

	* reload.c (find_reloads_address): Split addresses of type
	(plus (plus (reg) (reg)) (const_int)) only if one register
	is either a valid base register or else one of the stack
	frame related registers (sp/fp/ap).

2003-12-01  Steven Bosscher  <stevenb@suse.de>

	* function.c (update_epilogue_consts): Don't use PARAMS.
	* rtl.h (web_main): Ditto.
	* target.h (is_costly_dependence): Ditto

2003-12-01  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR middle-end/7847
	* expr.c (expand_expr) [normal_inner_ref]: When 'offset' is non-zero,
	do not recheck that 'op0' is a MEM.  Move comment.  When testing for
	unaligned objects, take also into account the alignment of 'op0' and
	'mode1' if 'op0' is a MEM.

2003-12-01 Gabriel Dos Reis <gdr@integrable-solutions.net>

	* doc/c-tree.texi (Function Bodies): Update HANDLER documentation.

2003-12-01  Kelley Cook  <kcook@gcc.gnu.org>

	* doc/install.texi: Note that fastjar is built with automake 1.7.x
	and autoconf 2.57.

2003-12-01  Alan Modra  <amodra@bigpond.net.au>

	* config/rs6000/linux64.h (SUBSUBTARGET_OVERRIDE_OPTIONS): Test
	target_flags directly rather than using TARGET_* defines.

2003-11-30  Ben Elliston  <bje@wasabisystems.com>

	* doschk.c: Remove.

2003-11-30  Richard Sandiford  <rsandifo@redhat.com>

	PR target/12727
	* config/mips/mips.c (mips_save_reg): Fix frame information for sdc1
	on 32-bit big-endian targets.

2003-11-30  Kazu Hirata  <kazu@cs.umass.edu>

	* genemit.c (register_constraints): Remove.

2003-11-30  Andreas Krebbel  <krebbel1@de.ibm.com>

	* config/s390/s390.md ("tmdi_reg", "tmsi_reg", "*movdi_64", "*movdi_31",
	"iordi3"): Insns now use multiple letter constraints.
	("*movdi_lhi", "*movdi_lli", "*movdi_lay"): Insns deleted. They are now
	covered by "*movdi_64".
	("*movsi_lhi", "*movsi_lli", "*movsi_lay"): Insns deleted. They are now
	covered by "*movsi_zarch" and "*movsi_esa".
	("*movsi_zarch", "*movsi_!zarch"): New insns.
	("*llgt_sisi_split", "*llgt_didi_split"): Insns deleted. Now covered
	by "*andsi3_zarch" and "anddi3".
	("*anddi3_ni"): Insn merged with "anddi3".
	("*andsi3_ni"): Insn merged with "*andsi3_zarch".
	("*andsi3_zarch", "*andsi3_esa"): New insns.
	("*iordi3_oi"): Insn merged with "iordi3".
	("*iorsi3_oi"): Insn merged with "*iorsi3_zarch".
	("*iorsi3_zarch", "*iorsi3_esa"): New insns.

	* config/s390/s390.c (s390_single_qi, s390_single_hi): Functions
	merged to s390_single_part.
	(s390_single_part): New function.
	NOTE: Semantics have changed a bit. Now the value of the part must
	be different from the others to get a non-negative return value.
	(s390_extract_qi, s390_extract_hi): Functions merged to
	s390_extract_part.
	(s390_extract_part, s390_extra_constraint_str,
	s390_const_ok_for_constraint_p): New functions. The L constraint got a
	new meaning and the N constraint was added as a multiple letter
	constraint.
	(s390_extra_constraint): Function deleted.
	(print_operand): New output modifier 'i' and 'j' added.
	All uses of CONST_OK_FOR_LETTER_P were replaced by
	CONST_OK_FOR_CONSTRAINT_P.

	* config/s390/s390-protos.h: Function prototypes adapted.
	* doc/md.texi: Documentation for new constraint letters added.

2003-11-30  Andreas Schwab  <schwab@suse.de>

	* Makefile.in ($(DESTDIR)$(infodir)/%.info): Fix missing semicolon.

2003-11-29  James E Wilson  <wilson@specifixinc.com>

	* gcc.c (init_spec): Pass -lunwind to init_gcc_specs in eh_name
	instead of in shared_name.

	* final.c (final_start_function): Delete code for NON_SAVING_SETJMP.
	* reload1.c (reload): Re-add it here.

2003-11-30  Alan Modra  <amodra@bigpond.net.au>

	* config/rs6000/rs6000.c (rs6000_elf_section_type_flags): Don't
	set SECTION_WRITE on TARGET_RELOCATABLE.

2003-11-29  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.h (LIBCALL_VALUE): Use R0_REG.

2003-11-28  Gunther Nikl  <gni@gecko.de>

	* config/m68k/m68k.c (MOTOROLA): Move from here...
	* config/m68k/m68k.h (MOTOROLA): ... to here.
	(OUTPUT_JUMP): Use do {...} while (0).
	* config/m68k/m68k.md: Replace #ifdef MOTOROLA with C statements.

2003-11-28  Gunther Nikl  <gni@gecko.de>

	* config.gcc (m68020-*-elf*, m68k-*-elf*, m68010-*-netbsdelf*,
	m68k*-*-netbsdelf*, m68k-*-rtems*): Add tm_defines containing
	MOTOROLA and USE_GAS.
	* config/m68k/rtemself.h (MOTOROLA): Delete.
	* config/m68k/netbsd-elf.h (MOTOROLA, USE_GAS): Delete.
	* config/m68k/m68kelf.h (MOTOROLA, USE_GAS, SGS_CMP_ORDER): Delete.

2003-11-29  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.h (WORDS_BIG_ENDIAN): Update the comment.

2003-11-29  Kelley Cook  <kcook@gcc.gnu.org>

	* Makefile.in (install-info): Install gccinstall.info too.

2003-11-29  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.md ("cmpint_di"): Fix incorrect instruction lengths.

2003-11-29  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.md ("movhi"): Do not emit extender pattern
	when loading from a (MEM (ADDRESSOF ...)).
	("movqi"): Likewise.

2003-11-29  Joseph S. Myers  <jsm@polyomino.org.uk>

	PR c/10333
	* c-parse.in (typespec_reserved_nonattr): Reject typeof on
	bit-fields.

2003-11-29  Richard Sandiford  <rsandifo@redhat.com>

	* stmt.c (expand_asm_operands): Check whether force_const_mem
	succeeded.

2003-11-28  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* config/gnu.h (HURD_TARGET_OS_CPP_BUILTINS): New.
	* config/linux.h (LINUX_TARGET_OS_CPP_BUILTINS): New.

	* config/alpha/gnu.h, config/alpha/linux.h,
	config/arm/linux-elf.h, config/cris/cris.h, config/cris/linux.h,
	config/i370/linux.h, config/i386/gnu.h, config/i386/i386.h,
	config/i386/linux-aout.h, config/i386/linux.h,
	config/i386/linux64.h, config/ia64/linux.h, config/m68k/linux.h,
	config/m68k/uclinux.h, config/mips/linux.h,
	config/mn10300/linux.h, config/pa/pa-linux.h,
	config/rs6000/sysv4.h, config/s390/linux.h, config/sh/linux.h,
	config/sparc/linux.h, config/sparc/linux64.h,
	config/xtensa/linux.h (TARGET_OS_CPP_BUILTINS): Use
	HURD_TARGET_OS_CPP_BUILTINS/LINUX_TARGET_OS_CPP_BUILTINS or ensure
	all necessary assertions are included.

2003-11-28  Jan Hubicka  <jh@suse.cz>

	* emit-rtl.c (set_used_flags): New.
	(verify_rtx_sharing, verify_rtl_sharing): New.
	(unshare_all_rtl_1): Rename to....
	(unshare_all_rtl_in_chain): ... this one; make static.
	(copy_rtx_if_shared): LABEL_REF chan be shared.
	* ifcvt.c (unshare_ifcvt_sequence): New.
	(noce_try_move, noce_try_store_flag, noce_try_store_flag_constants,
	noce_try_addcc, noce_try_addcc, noce_try_store_flag_mask,
	noce_try_cmove, noce_try_store_flag_mask, noce_try_minmax,
	noce_try_abs, noce_process_if_block, find_cond_trap
	* rtl.h (verify_rtl_sharing, set_used_flags, unshare_all_rtl_in_chain):
	Declare.

2003-11-28  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md: Fix a comment typo.

2003-11-28  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (*movsf_h8300h): Change to
	*movsf_h8300hs.
	(addsi_h8300): Change to *addsi_h8300.
	(addsi_h8300h): Change to *addsi_h8300hs.
	(subsi3_h8300): Change to *subsi3_h8300.
	(subsi3_h8300h): Change to *subsi3_h8300hs.
	(neghi2_h8300h): Change to *neghi2_h8300hs.
	(negsi2_h8300h): Change to *negsi2_h8300hs.

2003-11-28  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (*subhi3_h8300): Remove '&' from the
	constraint.
	(*subhi3_h8300hs): Likewise.

2003-11-28  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.h (MASK_MFCRF): New.
	(TARGET_MFCRF): Test target_flags, not processor type.
	(TARGET_SWITCHES): Add mfcrf and no-mfcrf.
	Change Don't to Do not.
	* config/rs6000/rs6000.c (processors_target_table): Add MASK_MFCRF
	to power4, 970, G5.

2003-11-27  J"orn Rennecke <joern.rennecke@superh.com>

	* cse.c (cse_set_around_loop): When changing a constant load
	to a register -register copy, add a REG_EQUAL note.

2003-11-27  Randolph Chung  <tausq@debian.org>
	    John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.c (hppa_profile_hook): Split gen_call_profiler into separate
	insns.  Use the regular call expander for the call to the profiler.
	* pa.md (call_profiler): Delete.
	(load_offset_label_address): New insn to load the address of the
	current function for the profiler.
	(lcla1, lcla2): New insns to output a code label and load its address.

2003-11-27  Kazu Hirata  <kazu@cs.umass.edu>

	* final.c (final_scan_insn): Remove commented-out code.

2003-11-27  Nathanael Nerode  <neroden@gcc.gnu.org>

	* doc/install.texi: Remove ADAC reference and make accurate.

2003-11-27  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.h (FUNCTION_VALUE): Use R0_REG.
	(FUNCTION_VALUE_REGNO_P): Likewise.
	* config/h8300/h8300.md: Define R0_REG.

2003-11-27  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c: Fix formatting.
	* config/h8300/h8300.md: Likewise.

2003-11-27  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.h (ELIMINABLE_REGS): Update a comment.

2003-11-27  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md: Give names to anonymous insns.

2003-11-27  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (extendqisi2): Remove constraints.

2003-11-27  Gunther Nikl  <gni@gecko.de>

	* doc/tm.texi (SYSROOT_HEADERS_SUFFIX_SPEC): Fix typo.

2003-11-27  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/13041
	* final.c (frame_pointer_needed): Fix comment.
	* reload1.c (reload): Decrease alignment of the frame
	pointer if it was used for register allocation.

2003-11-27  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR target/12900
	* reg-stack (move_for_stack_reg): New prototype.  Return
	whether a control flow insn was deleted.
	(subst_stack_regs_pat): Likewise, using the information provided
	by move_for_stack_reg.
	(subst_stack_regs): Likewise, using the information provided
	by subst_stack_regs_pat.
	(convert_regs_1): Record whether a control flow insn was deleted,
	using the information provided by subst_stack_regs.  Purge dead
	edges only if a control flow insn was deleted.

2003-11-27  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR middle-end/8028
	PR middle-end/9890
	PR middle-end/11151
	PR middle-end/12210
	PR middle-end/12503
	PR middle-end/12692
	* builtins.c (expand_builtin_apply): Use virtual_outgoing_args_rtx
	as the base address to copy the memory arguments to.

2003-11-26  Danny Smith  <dannysmith@users.sourceforge.net>

	* config/i386/cygming.h (ASM_OUTPUT_DEF_FROM_DECLS): Declare
	function aliases as functions.

2003-11-26  Nathanael Nerode  <neroden@gcc.gnu.org>

	* aclocal.m4 (gcc_AC_PROG_GNAT): Rewrite to account for removal
	of ADAC.
	* configure: Regenerate.

	* Makefile.in: Remove references to ADAC.

	* configure.in: Remove check for whether ${ADAC} accepts -Wno-long-long.
	* configure: Regenerate.

2003-11-26  Eric Botcazou  <ebotcazou@libertysurf.fr>
	    Olivier Hainque  <hainque@act-europe.fr>

	PR target/6466
	* config/sparc/sparc-protos.h (compute_frame_size): New prototype.
	(sparc_flat_compute_frame_size): Likewise.
	(sparc_flat_save_restore): Move prototype...
	* config/sparc/sparc.c (sparc_flat_save_restore): ...here.
	(save_regs): New prototype.
	(build_big_number): Likewise.
	(apparent_fsize): Change type to HOST_WIDE_INT.
	(actual_fsize): Likewise.
	(frame_base_offset): Likewise.
	(build_big_number): Add support for HOST_BITS_PER_WIDE_INT == 64.
	Change string descriptor to HOST_WIDE_INT_PRINT_DEC.
	[TARGET_ARCH64]: Use the sequence of sparc_emit_set_const64_longway
	to load a 64-bit constant.
	(sparc_nonflat_function_prologue): Change string descriptor to
	HOST_WIDE_INT_PRINT_DEC.  Change offset type to HOST_WIDE_INT.
	(output_restore_regs): Change offset type to HOST_WIDE_INT.
	(sparc_nonflat_function_epilogue): Change string descriptor to
	HOST_WIDE_INT_PRINT_DEC.  Use build_big_number.
	(output_sibcall): Change size type to HOST_WIDE_INT.  Use
	build_big_number.  Change string descriptor to HOST_WIDE_INT_PRINT_DEC.
	(sparc_frame_info): Change types for several components.
	(sparc_flat_compute_frame_size): Update types according to previous
	change.
	(sparc_flat_function_prologue): Change string descriptor to
	HOST_WIDE_INT_PRINT_DEC.  Change offset type to int.  Use
	build_big_number.
	(sparc_flat_function_epilogue): Change offset type to int.
	Rename 'size1' into 'reg_offset1'.  Change string descriptor to
	HOST_WIDE_INT_PRINT_DEC.  Use build_big_number.  Change big number
	limit to 4096 instead of 4095.

	* config/sparc/sparc.c (mems_ok_for_ldd_peep): Change offset type to
	HOST_WIDE_INT.

2003-11-24  Waldek Hebisch <hebisch@math.uni.wroc.pl>

	* function.c: Make outer_function-chain external.
	* function.h: Likewise.

2003-11-24  Richard Sandiford  <rsandifo@redhat.com>

	* config.gcc (mips-sgi-irix6*): Add t-iris6gld to tmake_file when
	using GNU ld.
	* config/mips/iris6.h (IRIX6_STARTFILE_SPEC): New, taking the
	whole of the previous STARTFILE_SPEC except crtbegin.o%s.
	(IRIX6_ENDFILE_SPEC): Likewise ENDFILE_SPEC and crtend.o%s.
	(STARTFILE_SPEC, ENDFILE_SPEC): Define in terms of the above.
	(SUBTARGET_EXTRA_SPECS): Define.
	* config/mips/iris6gld.h (LINK_SPEC): Change -init function
	to __gcc_init and -fini function to __gcc_fini.
	(STARTFILE_SPEC): Redefine, including irix6-crti.o before crtbegin.o.
	(ENDFILE_SPEC): Likewise, including irix6-crtn.o after crtend.o.
	(INIT_SECTION_ASM_OP, FINI_SECTION_ASM_OP): Define.
	* config/mips/t-iris6gld,
	* config/mips/irix6-crti.asm,
	* config/mips/irix6-crtn.asm: New files.

2003-11-24  Eric Christopher  <echristo@redhat.com>

	PR C/13014
	* c-decl.c (c_in_iteration_stmt, c_in_case_stmt): New.
	(start_function): Use.
	(c_push_function_context): Ditto.
	(c-pop_function_context): Ditto.
	(language_function): Move...
	* c-tree.h: ... here. Add x_in_iteration_stmt, and
	x_in_case_stmt.
	* c-parse.in (do_stmt_start, select_or_iter_stmt, stmt): Use
	c_in_iteration_stmt, c_in_case_stmt for parser state. Move
	check for valid break or continue statment here...
	* c-semantics.c (genrtl_break_stmt, genrtl_continue_stmt): From
	here. Change original errors to abort.

2003-11-24  Jan Hubicka  <jh@suse.cz>

	* fold-const.c (fold):  Do not return early when optimizing
	COMPONENT_REF and constant.

2003-11-24  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (tablejump_h8300): Change to
	*tablejump_h8300.
	(tablejump_h8300h): Change to *tablejump_h8300hs_advanced.
	(tablejump_normal_mode): Change to *tablejump_h8300hs_normal.
	(indirect_jump_h8300): Change to *indirect_jump_h8300.
	(indirect_jump_h8300h): Change to
	*indirect_jump_h8300hs_advanced.
	(indirect_jump_normal_mode): Change to
	*indirect_jump_h8300hs_normal.

2003-11-24  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md: Remove constraints from expanders.

2003-11-24  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md: (stm_h8300s_2): Change the name to
	stm_h8300s_2_advanced.
	(stm_h8300s_2_normal): New.
	(stm_h8300s_2): Likewise.
	(stm_h8300s_3): Change the name to stm_h8300s_3_advanced.
	(stm_h8300s_3_normal): New.
	(stm_h8300s_3): Likewise.
	(stm_h8300s_4): Change the name to stm_h8300s_4_advanced.
	(stm_h8300s_4_normal): New.
	(stm_h8300s_4): Likewise.
	(ldm_h8300s_2): Change the name to ldm_h8300s_2_advanced.
	(ldm_h8300s_2_normal): New.
	(ldm_h8300s_2): Likewise.
	(ldm_h8300s_3): Change the name to ldm_h8300s_3_advanced.
	(ldm_h8300s_3_normal): New.
	(ldm_h8300s_3): Likewise.
	(ldm_h8300s_4): Change the name to ldm_h8300s_4_advanced.
	(ldm_h8300s_4_normal): New.
	(ldm_h8300s_4): Likewise.
	(two peephole2's): Enable only with !TARGET_NORMAL_MODE.
	(two peephole2's): New.

2003-11-24  Zdenek Dvorak  <rakdver@atrey.karlin.mff.cuni.cz>

	* genattrtab.c (simplify_cond): Update indices correctly.
	(attr_alt_subset_p, attr_alt_subset_of_compl_p, attr_alt_intersection,
	attr_alt_union, attr_alt_complement, attr_alt_bit_p, mk_attr_alt): New.
	(check_attr_test, encode_units_mask, compute_alternative_mask,
	make_alternative_compare, simplify_and_tree,
	attr_rtx_cost, simplify_test_exp, gen_attr,
	write_test_expr, walk_attr_value): Handle EQ_ATTR_ALT.
	* rtl.def (EQ_ATTR_ALT): New.

2003-11-23  Zdenek Dvorak  <rakdver@atrey.karlin.mff.cuni.cz>

	* genattrtab.c (strcmp_check, DEF_ATTR_STRING): New macros.
	(length_str, delay_type_str, delay_1_0_str, num_delay_slots_str):
	New variables.
	(main): Initialize them.
	(find_attr): Canonicalize the attribute name string.
	(attr_rtx_1, copy_boolean, expand_delays, gen_unit): Always canonicalize
	string arguments.
	(attr_printf, attr_eq): Use DEF_ATTR_STRING.
	(check_attr_test, check_attr_value, make_length_attrs,
	write_length_unit_log, simplify_by_exploding, gen_attr,
	write_test_expr, write_attr_value, write_eligible_delay,
	write_complex_function, make_internal_attr,
	write_const_num_delay_slots): Changed due to change of type of
	find_attr.
	(fill_attr, evaluate_eq_attr, simplify_and_tree,
	attr_rtx_cost, simplify_by_exploding, walk_attr_value): Use
	strcmp_check.

2003-11-23  Kazu Hirata  <kazu@cs.umass.edu>

	PR target/13122
	* config/h8300/h8300.c (push): Call push_h8300hs_normal in
	normal mode.
	(pop): Call pop_h8300hs_normal in normal mode.
	* config/h8300/h8300.md: Likewise.
	(pushqi1_h8300hs_normal): New.
	(pushqi1): Call pushqi1_h8300hs_normal in normal mode.
	(pushhi1_h8300hs_normal): New.
	(pushhi1): Call pushhi1_h8300hs_normal in normal mode.
	(push_h8300hs_normal): New.
	(pop_h8300hs_normal): Likewise.

2003-11-23  Zdenek Dvorak  <rakdver@atrey.karlin.mff.cuni.cz>

	* genattrtab.c (count_sub_rtxs): Removed.

2003-11-23  Richard Earnshaw  <rearnsha@arm.com>

	* recog.c (preprocess_constraints): Only zero those elements of
	recog_op_alt that are needed for this insn.
	* arm.c (note_invalid_constants): A function can't contain invalid
	constants if it has no constraints.

2003-11-22  Jan Hubicka  <jh@suse.cz>

	* i386.c (classify_argument): Pass __float128 in memory.
	(ix86_return_in_memory): Likewise.
	(ix86_libcall_value): Likewsie.

2003-11-22  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (dosize): Convert to ISO-C.

2003-11-22  J"orn Rennecke <joern.rennecke@superh.com>

	* flow.c (update_life_info): Amend comment about when a register
	can become dead.

2003-11-21  Kelley Cook  <kcook@gcc.gnu.org>

	* doc/.cvsignore: Delete.

2003-11-21  Daniel Berlin  <dberlin@dberlin.org>
	    David Edelsohn  <edelsohn@gnu.org>

	* dwarf2out.c (add_location_or_const_value_attribute): Add support
	for PARALLEL.

2003-11-21  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config/mips/t-iris6 (CRTSTUFF_T_CFLAGS): Add -Wno-error.
	(TARGET_LIBGCC2_CFLAGS): Define.

	* crtstuff.c [HAS_INIT_SECTION] (__do_global_dtors): Declare.
	(__do_global_ctors): Likewise.

2003-11-21  Mark Wielaard  <mark@klomp.org>

	* doc/invoke.texi (-O2): Doesn't enable -fweb.

2003-11-21  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/invoke.texi: Mention dV and dZ.

2003-11-21  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/invoke.texi: Update dump file names.
	Remove de, dW, and dX.

2003-11-20  James E Wilson  <wilson@specifixinc.com>

	PR c/13133
	* reload1.c (reload): Delete special handling for setjmp.

2003-11-21  Andreas Tobler  <a.tobler@schweiz.ch>

	* mklibgcc.in: Evaluate shlib_slibdir_qual during link
	step too.
	* config/t-slibgcc-darwin: Adjust install path.
	* config/rs6000/t-darwin: Revert multilib matches since
	it is not used on darwin.

2003-11-20  Richard Henderson  <rth@redhat.com>

	* ssa.c, ssa-dce.c, ssa-ccp.c: Remove files.
	* Makefile.in (OBJS-common, GTFILES): Don't reference them.
	(gtype-desc.o, toplev.o, flow.o): Remove ssa.h.
	(ssa.o, ssa-dce.o, ssa-ccp.o): Remove.
	* flow.c: Don't include ssa.h.
	(set_phi_alternative_reg): Remove.
	(calculate_global_regs_live): Don't call it.
	(mark_used_regs): Don't handle PHI.
	* gengtype.c (open_base_files): Don't reference ssa.h.
	* rtl.def (PHI): Remove.
	* timevar.def (TV_TO_SSA, TV_SSA_CCP, TV_SSA_DCE, TV_FROM_SSA): Kill.
	* common.opt: Remove -fssa, -fssa-ccp, -fssa-dce.
	* opts.c (common_handle_option): Likewise.
	* toplev.c (f_options): Likewise.
	(DFI_ssa, DFI_ssa_ccp, DFI_ssa_dce, DFI_ussa): Remove.
	(dump_file): Update to match.
	(flag_ssa, flag_ssa_ccp, flag_ssa_dce): Remove.
	(rest_of_handle_ssa): Remove.
	(rest_of_compilation): Don't call it.
	* toplev.h (flag_ssa, flag_ssa_dce, flag_ssa_ccp): Remove.
	* doc/invoke.texi: Remove -fssa, -fssa-ccp, -fssa-dce.
	* doc/passes.texi (SSA optimizations): Remove.

2003-11-20  Bob Wilson  <bob.wilson@acm.org>

	* configure.in: Add xtensa-*-* targets to test for dwarf2 debug_line.
	* configure: Regenerate.

2003-11-20  Kelley Cook  <kcook@gcc.gnu.org>

	* Makefile.in (Makefile): Pass along CONFIG_SHELL.

2003-11-20 David Mosberger  <davidm@hpl.hp.com>

	* config/t-libunwind (LIB2ADDEH): Add unwind-c.c.
	(SHLIB_LC): Define.
	* unwind-libunwind.c (_Unwind_GetCFA): Implement.
	(_Unwind_GetBSP) [UNW_TARGET_IA64]: New function.

2003-11-20  Fariborz Jahanian  <fjahanian@apple.com>
	    David Edelsohn  <edelsohn@gnu.org>

	* calls.c (expand_call): Allocate new temp in pass1.
	(store_one_arg): If PARALLEL, calculate excess using mode size of
	rtvec elt.
	* expr.c (emit_push_insn): If PARALLEL, calculate offset using
	mode size of rtvec elt.
	* function.c (assign_parms): Use parm in register, if available.

2003-11-20  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/lib1funcs.asm (MOVP): Remove.
	(ADDP): Likewise.
	(CMPP): Likewise.

2003-11-20  Richard Earnshaw  <rearnsha@arm.com>

	* arm.c (use_return_insn): New argument, SIBLING.  Support returning
	with a single instruction if the stack has been decremented by 4
	and we have a frame pointer.  Update all callers.
	(output_return_instruction): Likewise.
	(arm_output_epilogue): Change argument to SIBLING.  Calculate
	really_return from the new argument.  Update all callers.
	* arm.h (USE_RETURN_INSN): Pass NULL for the sibling.
	* arm.md (sibcall_epilogue): Call use_return_insn directly, and
	pass the sibling call.
	* arm-protos.h (use_return_insn, arm_output_epilogue): Update
	prototypes.

2003-11-20  Joseph S. Myers  <jsm@polyomino.org.uk>

	* Makefile.in (extraclean): Delete.
	* configure.in (target_list): Remove extraclean.
	* configure: Regenerate.
	* doc/makefile.texi, doc/sourcebuild.texi: Update.
	* objc/Make-lang.in (objc.extraclean): Delete.

2003-11-20  Joseph S. Myers  <jsm@polyomino.org.uk>

	* Makefile.in (lang_checks): Add.
	(check-c++, check-f77, check-java, check-g++, check-g77,
	check-objc): Remove hardcoded targets.
	* doc/sourcebuild.texi: Document testsuite hooks.
	* objc/Make-lang.in (check-objc, lang_checks): Add.

2003-11-19  Scott Snyder  <snyder@fnal.gov>

	PR target/13131
	* dwarf2out.c (gen_array_type_die): DW_AT_declaration should be a
	flag, not a constant.

2003-11-19  Kelley Cook  <kcook@gcc.gnu.org>

	* config/arc/arc-protos.h: Update to C90 prototypes.
	* config/arc/arc.c: Likewise.
	* config/arc/initfini.c: Likewise.

2003-11-19  Andreas Krebbel  <krebbel1@de.ibm.com>

	* stmt.c (expand_goto): Memory clobbers added.

2003-11-19  Andreas Krebbel  <krebbel1@de.ibm.com>

	* reload.c (find_reloads): Added missing type casts.

2003-11-19  James E Wilson  <wilson@specifixinc.com>

	* combine.c (sets_function_arg_p): Delete unused function.

2003-11-19  Eric Christopher  <echristo@redhat.com>

	* reload1.c (reload): Revert 2 previous checkins.

2003-11-19  Nathanael Nerode  <neroden@gcc.gnu.org>

	* cpptrad.c (_cpp_scan_out_logical_line): Improve test for
	whether directive begins at the beginning of a line.

2003-11-19  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.c (frv_init_libfuncs): Correct ufix_optab entries.

2003-11-19  Gerald Pfeifer  <gp@suse.de>

	* doc/install.texi (Specific): Remove information on old versions
	of glibc versus old versions of GCC.

2003-11-19  Richard SAndiford  <rsandifo@redhat.com>

	* emit-rtl.c (gen_lowpart): Don't force MEMs into a register unless
	the register lowpart is a TRULY_NOOP_TRUNCATION.

2003-11-19  Richard Henderson  <rth@redhat.com>

	* config/i386/i386.c (print_reg): Handle QI and HI modes for
	non Q regs.

2003-11-19  Andreas Tobler  <a.tobler@schweiz.ch>

	* config/config.gcc (powerpc-*-darwin*): Add libgcc build
	specification file.
	* config/t-slibgcc-darwin: New file, libgcc build specification.
	* config/t-darwin: Add libgcc2 flag -fPIC.
	* config/rs6000/t-darwin: Multilib matches float.
	* libgcc-darwin.ver: New file, contains libgcc symbols.

2003-11-18  Nathanael Nerode  <neroden@gcc.gnu.org>

	* config/ns32k/ns32k.h: Remove obsolete comment.

2003-11-18  Roger Sayle  <roger@eyesopen.com>

	PR middle-end/11821
	* config/arm/arm.c (arm_rtx_costs_1): Improve estimate of the code
	size for calls to libgcc's div & mod subroutines when using -Os.

2003-11-18  Jan Hubicka  <jh@suse.cz>

	* cgraph.c (change_decl_assembler_name): Avoid bogus warnings.

2003-11-18  Marc Espie  <espie@openbsd.org>

	* config/rs6000/sysv4.h: OpenBSD hooks.

2003-11-18  Richard Henderson  <rth@redhat.com>

	* expr.c (expand_expr): Don't look through constant arrays if
	they don't bind locally.

2003-11-17  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* expr.c (convert_move): Use GET_MODE_PRECISION instead of bitsize
	when seeing if truncation or extension.

2003-11-17  Eric Christopher  <echristo@redhat.com>

	* reload1.c (reload): Fix previous change.

2003-11-17  Scott Snyder  <snyder@fnal.gov>

	PR debug/11325
	* dwarf2out.c (struct die_struct): Add die_definition field.
	(add_AT_specification): New.
	(gen_subprogram_die, gen_variable_die,
	gen_struct_or_union_type_die): Use it.
	(prune_unused_types_mark): If we're marking a forward declaration,
	also mark the full definition, if it exists.

2003-11-16  Nick Clifton  <nickc@redhat.com>

	* config/stormy16/stormy16.h (BUILD_VA_LIST_TYPE): Delete.
	* config/stormy16/stormy16-protos.h (xstormy16_build_va_list):
	Remove prototype.
	* config/stormy16/stormy16.c (xstormy16_build_va_list): Rename
	to xstormy16_build_builtin_va_list and make static.
	(TARGET_BUILD_BUILTIN_VA_LIST): Define.

2003-11-16  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300-protos.h: Add the prototype for
	same_cmp_following_p.
	* config/h8300/h8300.c (same_cmp_following_p): New.
	* config/h8300/h8300.md (peephole2): Use it.

2003-11-16  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md: Don't use REGNO when its operand is
	not guaranteed to be a REG.

2003-11-16  Richard Sandiford  <rsandifo@redhat.com>

	* Makefile.in (expr.o): Depend on $(TARGET_H).
	* target.h (return_in_msb): New target hook.
	* target-def.h (TARGET_RETURN_IN_MSB): New macro.
	(TARGET_CALLS): Include it.
	* calls.c (shift_returned_value): New function.
	(expand_call): Use it.
	* expr.c: Include target.h.
	(copy_blkmode_from_reg): Check targetm.calls.return_in_msb when
	deciding what padding is needed.  Change the name of the local
	padding variable from big_endian_correction to padding_correction.
	* stmt.c (shift_return_value): New function.
	(expand_return): Use it.  Adjust memory->register copy in the same
	way as copy_blkmode_from_reg.  Only change the return register's
	mode if it was originally BLKmode.
	* doc/tm.texi (TARGET_RETURN_IN_MSB): Document.
	* config/mips/mips.c (TARGET_RETURN_IN_MSB): Define.
	(mips_fpr_return_fields): New, split out from mips_function_value.
	(mips_return_in_msb, mips_return_fpr_pair): New functions.
	(mips_function_value): Rework to use the functions above.
	* config/mips/irix6-libc-compat.c: Delete.
	* config/mips/t-iris6 (LIB2FUNCS_STATIC_EXTRA): Undefine.

2003-11-16  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/install.texi (--enable-checking): Update valgrind's URL.

2003-11-16  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md: Fix warnings by replacing -2147483648
	with -2147483647 - 1.

2003-11-16  Gerald Pfeifer  <gerald@pfeifer.com>

	Fix links in online manuals.
	* doc/invoke.texi (H8/300 Options): @xref to ld, not ld.info.
	(Precompiled Headers): @pxref to cpp, not cpp.info.

2003-11-16  Jason Merrill  <jason@redhat.com>

	* Makefile.in, objc/Make-lang.in (objc.tags): Create TAGS.sub
	files in each directory and TAGS files that include them for each
	front end.

2003-11-15  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/lib1funcs.asm (divnorm): Store the sign in bit
	3 of S2L.
	(modnorm): Likewise.
	(exitdiv): Look at bit 3 of S2L only.

2003-11-15  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.h (DO_GLOBAL_CTORS_BODY): Fix warnings.
	(DO_GLOBAL_DTORS_BODY): Likewise.

2003-11-15  Joseph S. Myers  <jsm@polyomino.org.uk>

	* doc/install.texi (Prerequisites): Refine documentation of
	autoconf, automake and perl requirements.  Document required
	gettext version.

<2003-11-14  Jason Merrill  <jason@redhat.com>

	* function.c (assign_parms): Use TREE_TYPE to determine the real
	type of the argument object.

2003-11-14  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/lib1funcs.asm (___udivsi3): Peel off the first
	iteration.

2003-11-14  Fariborz Jahanian <fjahanian@apple.com>

	* config/rs6000/rs6000.c (rs6000_move_block_from_reg):
	  New routine to save vararg registers on stack. Support for
	  -mpowerpc64 in mixed mode.

2003-11-14  Bernardo Innocenti  <bernie@develer.com>

	* config/m68k/m68k.c: Use C statements instead of #ifdef's when testing
	for MOTOROLA versus MIT syntax.  Improves readability and provides
	better compile-time error checking for both code paths.

2003-11-14  Kelley Cook  <kcook@gcc.gnu.org>

	* config/frv/frv-protos.h: Update for C90.
	* config/frv/frv.h: Likewise.
	* config/frv/frvbegin.c: Likewise.
	* config/frv/frv.c: Likewise.
	(frv_adjust_field_align): Delete unused variable.

2003-11-14  Geoffrey Keating  <geoffk@apple.com>

	* config/rs6000/rs6000.md: Add 'DEFAULT_ABI == ABI_DARWIN'
	to each place where TARGET_LONG_DOUBLE_128 is used with
	DEFAULT_ABI == ABI_AIX.

	* cppfiles.c (_cpp_find_file): Make 'one or more PCH files were found'
	message comply with GNU standards.

2003-11-14  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	PR/6552
	* function.c (struct epi_info): New field const_equiv.
	(update_epilogue_consts): New function.
	(keep_stack_depressed): Clear new field and verify scratch register
	doesn't have it set.
	Call new function via note_stores.
	(handle_epilogue_set): Allow setting SP equiv reg in different mode.
	Allow PLUS where second operand is register known set to constant.
	(emit_equiv_load): Write load using proper mode if source different.
	* config/mips/mips.md (return_internal): Put (return) first.

2003-11-14  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/lib1funcs.asm (___udivsi3): Add a comment.

2003-11-14  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/lib1funcs.asm (modsi3): Don't save unused
	registers.
	(divsi3): Likewise.
	(reti): Don't restore unused registers.

2003-11-14  Nick Clifton  <nickc@redhat.com>

	* config/fr30/fr30.c: Include toplev.h

2003-11-14  Richard Earnshaw  <rearnsha@arm.com>

	* except.c (sjlj_emit_function_enter): Mark internal label as LOCAL.

2003-11-14  Richard Earnshaw  <rearnsha@arm.com>

	* arm.c (arm_emit_vector_const, arm_output_load_gr): Use ISO C
	function definition syntax.

2003-11-14  Eric Christopher  <echristo@redhat.com>

	* reload1.c (reload): Revert previous patch. Make
	check for assignment into reg_equiv_address stricter.

2003-11-14  Arnaud Charlet  <charlet@act-europe.fr>

	* Makefile.in (POSTSTAGE1_FLAGS_TO_PASS): Pass ADAFLAGS.

2003-11-14  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.c (frv_in_small_data_p): Return false for unknown
	section names.

2003-11-14  Jason Merrill  <jason@redhat.com>

	PR middle-end/12526
	* tree.c (build): A CALL_EXPR has side-effects if its arguments do.
	* calls.c (call_expr_flags): New fn.
	* tree.h: Declare it.

2003-11-13  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/lib1funcs.asm (__udivsi3): Remove.
	(divmodsi3): Change the name to ___udivsi3.
	Update all callers.

2003-11-13  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* libgcc2.c (__negdi2, __addvsi3, __addvdi3, __subvsi3, __subvdi3,
	__mulvsi3, __negvsi2, __negvdi2, __mulvdi3, __lshrdi3, __ashldi3,
	__ashrdi3, __ffsDI2, __muldi3, __clzDI2, __ctzDI2, __parityDI2,
	__udivmoddi4, __divdi3, __moddi3, __cmpdi2, __ucmpdi2,
	__fixunstfDI, __fixunsxfDI, __fixunsdfDI, __fixunssfDI,
	__floatdixf, __floatditf, __floatdidf, __floatdisf, __gcc_bcmp):
	Const-ify and/or initialize automatic variables at declaration.

2003-11-13  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/lib1funcs.asm (divmodsi4): Replace all the uses
	of er4 with er3.  Adjust all callers.

2003-11-13  Andrew Pinski <apinski@apple.com>

	* config/darwin.c (machopic_output_possible_stub_label):
	Allow stub symbol be not defined when outputting possible
	stub label.

2003-11-13  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/lib1funcs.asm (___udivsi3): Jump to reti
	instead of exitdiv.
	(___umodsi3): Likewise.
	(exitdiv): Do not restore any register.
	(reti): Restore registers.

2003-11-13  Steven Bosscher  <stevenb@suse.de>

	* tree-inline.c (walk_tree): Handle PLACEHOLDER_EXPR.

2003-11-13  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/lib1funcs.asm: Fix comment typos.

2003-11-13  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/lib1funcs.asm (udivsi3): Don't save/restore
	unused registers.  Don't jump to exitdiv.
	(umodsi3): Likewise.

2003-11-13  Mark Mitchell  <mark@codesourcery.com>
	    Kean Johnston <jkj@sco.com>

	PR c/13029
	* toplev.c (check_global_declarations): Do not warn about unused
	static consts.

2003-11-13  Pavel Pisa  <pisa@cmp.felk.cvut.cz>
	    Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/lib1funcs.asm (DenHighNonZero): Optimize using
	the approximate quotient method.

2003-11-13  Richard Earnshaw  <rearnsha@arm.com>

	* combine.c (distribute_notes): When re-distributing the notes from
	an insn we are about to delete, ensure we can't end up with a cyclic
	list of notes.

2003-11-13  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/12926
	* expr.c (expand_assignment) [COMPONENT_REF]: Don't put
	the UNCHANGING_RTX_P flag on memory references to read-only
	components that are not addressable.

2003-11-12  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/lib1funcs.asm (divmodsi4): Clear S0P in
	DenHighNonZero.

2003-11-13  Jan Hubicka  <jh@suse.cz>

	PR opt/12275
	* c-decl.c (finish_decl): Use change_decl_assembler_name.
	* c-pragma.c (handle_pragma_redefine_extname): Likewise.
	* varasm.c (make_decl_rtl): Likewise.
	* cgraph.c (change_decl_assembler_name): New function.
	* tree.h (set_decl_assembler_name): Kill dead declaration.
	(change_decl_assembler_name): Declare.

	* decl.c (make_rtl_for_nonlocal_decl): Use change_decl_assembler_name.
	* decl2.c (make_rtl_for_nonlocal_decl): Use change_decl_assembler_name.

2003-11-12  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/lib1funcs.asm (___mulsi3): Don't save/restore
	an unused register.

2003-11-12  Richard Sandiford  <rsandifo@redhat.com>

	PR bootstrap/12752
	* config/mips/t-iris6 (MULTILIB_OPTIONS): Put -mabi=n32 first.
	(MULTILIB_OSDIRNAMES): Reorder accordingly.

2003-11-12  Janis Johnson  <janis187@us.ibm.com>

	* rs6000-protos.h (rs6000_initial_elimination_offset): Add.
	(rs6000_stack_info): Remove.  (debug_stack_info): Remove.
	(rs6000_emit_eh_reg_restore): Add
	* rs6000.c (rs6000_stack_t): Move from rs6000.h, change data type
	of vars_size and total_size to HOST_WIDE_INT.
	(emit_frame_save): Change parameter size to HOST_WIDE_INT.
	(rs6000_stack_info): Make static; change data size to HOST_WIDE_INT.
	(debug_stack_info): Make static; change output format of HOST_WIDE_INT
	values.
	(rs6000_emit_eh_reg_restore): New, with code formerly in rs6000.md.
	(rs6000_initial_elimination_offset): New, with code formerly in
	INITIAL_ELIMINATION_OFFSET.
	* rs6000.h (rs6000_stack_t): Remove.
	(INITIAL_ELIMINATION_OFFSET): Replace code with call to function
	rs6000_initial_elimination_offset.
	* rs6000.md (UNSPECV_EH_RR split): Replace code with call to
	rs6000_emit_eh_reg_restore.

2003-11-12  Mike Stump  <mrs@apple.com>

	* c-typeck.c (c_convert_parm_for_inlining): Add argnum, which
	is the argumnt we are processing so that warnings and errors
	will have that information.
	* c-tree.h (c_convert_parm_for_inlining): Add argnum.
	* lang-hooks-def.h
	(lhd_tree_inlining_convert_parm_for_inlining): Likewse.
	* langhooks.c (lhd_tree_inlining_convert_parm_for_inlining): Likewise.
	* langhooks.h (convert_parm_for_inlining): Likewise.
	* tree-inline.c (initialize_inlined_parameters): Compute and
	pass argnum down.

2003-11-12  Alexey Starovoytov  <alexey.starovoytov@sun.com>
	    Roger Sayle  <roger@eyesopen.com>

	PR optimization/12953
	* tree-inline.c (inline_forbidden_p_1): Added check for BUILT_IN
	before switch by FUNCTION_CODE.

2003-11-12  Richard Earnshaw  <rearnsha@arm.com>

	* arm.md (storehi): Avoid use of explicit subreg.
	(storehi_bigend, storeinthi, movhi_bigend): Likewise.

2003-11-12  J"orn Rennecke <joern.rennecke@superh.com>

	* config/sh/sh.md (prefetch): New pattern.

2003-11-11  Eric Christopher  <echristo@redhat.com>

	* reload1.c (reload): Verify that addresses for
	reg_equiv_* are valid for the architecture.

2003-11-11  Eric Christopher  <echristo@redhat.com>

	* function.c (purge_addressof_1): Add libcall check.
	Remove test for cached replacements on fallback case.
	Simplify mode comparisons. Add libcall test for
	paradoxical subregs.

2003-11-11  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/t-h8300: Fix an obsolete comment.

2003-11-11  James E Wilson  <wilson@specifixinc.com>

	* expmed.c (store_bit_field, extract_bit_field): Revert last two
	changes.

2003-11-11  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/lib1funcs.asm: Replace DenHighZero with
	DenHighNonZero.

2003-11-11  Jan Hubicka  <jh@suse.cz>

	* cgraphunit.c (cgraph_function_possibly_inlined_p): Use
	really_no_inline.

2003-11-11  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.h (TRAMPOLINE_TEMPLATE): Fix flushing of cache lines when
	generating 64-bit code.

2003-11-10  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.c (legitimate_lo_sum_address_p): Remove
	accidental commit in previous change.

2003-11-10  Fariborz Jahanian <fjahanian@apple.com>

	* config/rs6000/rs6000.h (STACK_SIZE_MODE): Add definition.
	* config/rs6000/rs6000.c (reg_or_mem_operand): Add macho-style
	address recognition.
	(macho_lo_sum_memory_operand): Routine to recognize macho-style
	address recognition.

2003-11-10  Richard Henderson  <rth@redhat.com>

	* dwarf2out.c (gen_label_die): Cope with DECL_RTL not set.

2003-11-10  Matt Austern  <austern@apple.com>

	* config/darwin-protos.h (darwin_assemble_visibility): Declare.
	* config/darwin.c (darwin_assemble_visibility): Define.  Warn for
	anything other than VISIBILITY_DEFAULT and VISIBILITY_HIDDEN.
	* config/darwin.h (TARGET_ASM_ASSEMBLE_VISIBILITY): Use
	darwin_assemble_visibility instead of default.

2003-11-10  Waldek Hebisch  <hebisch@math.uni.wroc.pl>

	PR target/12865
	* config/sparc/sparc.c (sparc_initialize_trampoline): Call
	__enable_execute_stack only after writing onto the stack.
	(sparc64_initialize_trampoline): Likewise.

2003-11-09  Roger Sayle  <roger@eyesopen.com>

	* loop.c (check_dbra_loop): Try swapping the comparison operands
	of the loop condition to identify a suitable induction variable.
	* unroll.c (loop_iterations): Likewise.

2003-11-09  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* config/sparc/sparc.h (TARGET_CPU_CPP_BUILTINS): Fix sparc vs
	sparc64 #cpu and #machine assertions.

2003-11-09  Richard Henderson  <rth@redhat.com>

	* Makefile.in (rtlanal.o): Depend on BASIC_BLOCK_H.

2003-11-09  Jan Hubicka  <jh@suse.cz>

	* tree-optimize.c (tree_rest_of_compilation): Fix warning.

	* cgraphunit.c (cgraph_expand_function): Use
	cgraph_possibly_inlined_p.
	* tree-optimize.c (tree_rest_of_compilation): Do not kill saved tree.

	* opts.c (common_handle_option): Do not set max-inline-insns.
	* params.def: Update comments.
	(PARAM_MAX_INLINE_INSNS): Kill.
	* invoke.texi (max-inline-insns): Kill.

2003-11-08  Joseph S. Myers  <jsm@polyomino.org.uk>

	PR c/3190
	PR c/8714
	* c-format.c (set_Wformat): Do not enable -Wformat-y2k by default.
	* invoke.texi: Update.

2003-11-08  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR optimization/12630
	* pa.c (compute_movstrsi_length): Rename to compute_movstr_length.
	Handle length computation 64-bit moves.
	(compute_clrstr_length, output_block_clear): Implement block clear.
	(output_block_move): Handle 64-bit moves.
	(pa_adjust_insn_length): Use compute_movstr_length and
	compute_clrstr_length.
	* pa.md (movstrsi): Revise operand order and comments.  Don't use
	match_scratch.
	(movstrsi_internal): Delete.
	(movstrsi_prereload, movstrsi_postreload): New insns.  Define splitter
	and peephole2 patterns to transform prereload to postreload form.
	(movstrdi, movstrdi_prereload, movstrdi_postreload, clrstrsi,
	clrstrsi_prereload, clrstrsi_postreload, clrstrdi, clrstrdi_prereload,
	clrstrdi_postreload): New patterns for 64-bit block move, and block
	clear.
	* pa-protos.h (output_block_clear): New prototype.

2003-11-08  Andreas Schwab  <schwab@suse.de>

	* dbxout.c (current_file): Also wrap inside DBX_DEBUGGING_INFO ||
	XCOFF_DEBUGGING_INFO.

2003-11-08  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* dbxout.c (current_file): Wrap declaration in DBX_USE_BINCL.

2003-11-07  Geoffrey Keating  <geoffk@apple.com>

	* config/rs6000/rs6000.c (rs6000_legitimize_address): Remove
	redundant parens.

	* cppfiles.c (pch_open_file): New parameter 'invalid_pch', set it.
	(find_file_in_dir): Likewise.
	(_cpp_find_file): Print message if no header file is found
	but an invalid PCH file was.

2003-11-08  Joseph S. Myers  <jsm@polyomino.org.uk>

	* c-typeck.c (pedantic_lvalue_warning): Deprecate compound
	expressions as lvalues.
	(internal_build_compound_expr): Remove special handling for
	non-pedantic case.
	* doc/extend.texi: Document that all extended lvalues are now
	deprecated.

2003-11-07  Geoffrey Keating  <geoffk@apple.com>

	PR 11654
	* dbxout.c (struct dbx_file): Do not save for PCH.
	(current_file): Likewise.
	(dbxout_init): Don't allocate struct dbx_file using GC.
	(dbxout_start_source_file): Likewise.

2003-11-07  Falk Hueffner  <falk@debian.org>

	* config/alpha/elf.h, config/alpha/unicosmk.h,
	config/alpha/vms.h: Convert to ISO C90.

2003-11-07  Nathanael Nerode  <neroden@gcc.gnu.org>

	* config/arm/pe.h: Convert to ISO C90.

2003-11-07  J"orn Rennecke <joern.rennecke@superh.com>

	* sh-protos.h (sh_pch_valid_p): Declare.
	* sh.c ("intl.h"): Include.
	(TARGET_PCH_VALID_P): Override.
	(sh_target_switches): New variable.
	(target_switches): Define.
	(sh_pch_valid_p): New function.

	* sh.h (MODE_AFTER): Don't change mode unless TARGET_HITACHI.

2003-11-07  Jan Hubicka  <jh@suse.cz>

	* i386.c (x86_64_sign_extended_value):  Return false from tls variables.
	(x86_64_zero_extended_value):  likewise.

2003-11-07  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.md (loadgp): Take $25 as a second operand.
	* config/mips/mips.c (mips_expand_prologue): Modify accordingly.

2003-11-06  Matt Austern <austern@apple.com>

	* c-common.c (handle_visibility_attribute): Set DECL_VISIBILITY
	field instead of hanging an attribute object off the decl.
	* tree.h (DECL_VISIBLITY): New accessor macro for
	symbol_visibility field in struct tree_decl.
	(enum symbol_visibility): Move definition to before tree_decl.
	(struct tree_decl): Define new two-bit field, symbol_visibility.
	(decl_visibility): Remove declaration.
	* varasm.c (maybe_assemble_visibility): Use DECL_VISIBILITY
	instead of decl_visibility.
	(default_binds_local_p_1):  Use DECL_VISIBILITY	instead of
	decl_visibility.
	(decl_visibility): Remove.

2003-11-06  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.c (s390_emit_epilogue): Recognize more cases
	where register 14 will be saved.

2003-11-06  Geoffrey Keating  <geoffk@apple.com>

	* config/rs6000/rs6000.h (USE_FP_FOR_ARG_P): Move to rs6000.c.
	(USE_ALTIVEC_FOR_ARG_P): Likewise.
	* config/rs6000/rs6000.c (USE_FP_FOR_ARG_P): Move from rs6000.h.
	Take a pointer as the CUM parameter.  Update callers.
	(USE_ALTIVEC_FOR_ARG_P): Likewise.  Also correct for Darwin/AIX
	32-bit ABIs.
	(function_arg_advance): Use USE_ALTIVEC_FOR_ARG_P.  Correct case
	of vector parameters as named arguments of stdarg function.
	(function_arg): Likewise.

	* config/rs6000/darwin.h (ASM_SPEC): Use -force_cpusubtype_ALL when
	-maltivec is specified, not the non-existent -faltivec.

2003-11-06  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390-protos.h (s390_function_value): Declare.
	* config/s390/s390.c (TARGET_RETURN_IN_MEMORY): Define.
	(s390_return_in_memory): New function.
	(s390_function_value): New function.
	(s390_function_arg_float): Return false for all arguments larger
	than 8 bytes.
	(s390_function_arg_pass_by_reference): Likewise.  Return true for
	all vector arguments.
	(s390_function_arg_integer): New function.
	(s390_function_arg_advance): Call it.  Add sanity checks.
	(s390_function_arg): Likewise.
	* config/s390/s390.h (FUNCTION_VALUE): Call s390_function_value.
	(LIBCALL_VALUE): Likewise.
	(RET_REG): Remove.
	(RETURN_IN_MEMORY): Remove.

2003-11-06  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips-protos.h (mips_initial_elimination_offset): Change
	return type to HOST_WIDE_INT.
	* config/mips/mips.c (mips_frame_info): Give sizes type HOST_WIDE_INT.
	Make initialized a bool.  Make register masks unsigned ints.
	(compute_frame_size): Make same mask change here.  Use HOST_WIDE_INT
	where appropriate.
	(mips_initial_elimination_offset): Return a HOST_WIDE_INT.
	(mips_output_function_prologue): Print sizes as HOST_WIDE_INTs.

2003-11-06  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.c (frv_initial_elimination_offset): Remove bogus
	negation.

2003-11-06  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.h (ASM_OUTPUT_ALIGN_WITH_NOP): Define.

2003-11-06  Momchil Velikov  <velco@fadata.bg>

	* config/mips/mips.c (override_options): Set MASK_SOFT_FLOAT
	for VR4111 too.

2003-11-06  Jan Hubicka  <jh@suse.cz>

	* builtins.c (simplify_builtin_strrchr, simplify_builtin_strpbrk): Add
	missing casts.

2003-11-06  Zack Weinberg  <zack@codesourcery.com>

	* genmodes.c: Change the word "bitsize" to "precision" throughout.
	* machmode.def: Likewise.
	* machmode.h (GET_MODE_SIZE): Cast value to unsigned short.
	(GET_MODE_BITSIZE): Define as GET_MODE_SIZE * BITS_PER_UNIT.
	(GET_MODE_PRECISION): New macro.
	(mode_bitsize): Renamed mode_precision.
	* stor-layout.c (mode_for_size, smallest_mode_for_size):
	Use GET_MODE_PRECISION; clarify comments.

2003-11-05  Joseph S. Myers  <jsm@polyomino.org.uk>

	* doc/install-old.texi: Remove old documentation of building
	cross-compilers.
	* doc/install.texi: Move some of it to here.

2003-11-05  Per Bothner  <pbothner@apple.com>

	PR preprocessor/12891
	* c-opts.c (finish_options):  Set include_cursor to disable premature
	calls to push_command_line_include from cpp_scan_nooutput.
	Fixes bug reported by DJ Delorie.

2003-11-05  Geoffrey Keating  <geoffk@apple.com>

	* config/rs6000/rs6000.c (setup_incoming_varargs): Remove
	code supporting old-style varargs.

	* config/rs6000/rs6000.c (rs6000_machopic_legitimize_pic_address): Use
	an intermediate register for better optimisation.

2003-11-05  Zdenek Dvorak  <rakdver@atrey.karlin.mff.cuni.cz>

	PR optimization/10080
	* cfgloopanal.c (variable_initial_value, variable_initial_values,
	simple_loop_exit_p): Record the fact that initial value is extended
	from inner mode.
	(count_strange_loop_iterations, count_loop_iterations): Handle
	ivs that iterate in a narrower mode. Fix handling of overflows.
	Improve handling of NE conditions.
	(inverse, fits_in_mode_p): New static functions.
	(simple_increment): Detect variables that iterate in a narrower mode.
	* cfgloop.h (struct loop_desc): Fields inner_mode and extend added.

2003-11-05  Geoffrey Keating  <geoffk@apple.com>

	* config/rs6000/rs6000.c (compute_vrsave_mask): Correct off-by-one
	error.

	* config/rs6000/darwin.h (SUBTARGET_OVERRIDE_OPTIONS): Darwin
	needs VRSAVE.

2003-11-05  Joseph S. Myers  <jsm@polyomino.org.uk>

	* c-typeck.c (pedantic_lvalue_warning): Deprecate use of
	conditional expressions as lvalues.

2003-11-05  Kazu Hirata  <kazu@cs.umass.edu>

	* tsystem.h: Add the prototype of strlen.
	* unwind-pe.h (read_encoded_value_with_base): Add an
	appropriate cast to handle a case where the pointer size is
	smaller than sizeof (int).

2003-11-04  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips-protos.h (mips_global_pic_constant_p): Delete.
	(mips_delegitimize_address): Delete.
	(mips_gotoff_global, mips_load_got_page): Declare.
	(mips_load_got_global, mips_rewrite_small_data): Declare.

	* config/mips/mips.h (FIND_BASE_TERM): Remove definition.
	(DANGEROUS_FOR_LA25_P): Use global_got_operand.
	(PREDICATE_CODES): Add global_got_operand, local_got_operand and
	small_data_pattern.  Remove CONST from const_arith_operand's entry.

	* config/mips/mips.c (UNSPEC_ADDRESS_P, CONST_GP_P): New macros.
	(UNSPEC_ADDRESS, UNSPEC_ADDRESS_TYPE): Likewise.
	(mips_constant_type): Delete.
	(mips_symbol_type): Add SYMBOL_GOTOFF_PAGE, SYMBOL_GOTOFF_GLOBAL,
	SYMBOL_GOTOFF_CALL and SYMBOL_GOTOFF_LOADGP.
	(NUM_SYMBOL_TYPES): New macro.
	(mips_address_type): Remove ADDRESS_INVALID.
	(machine_function): Add has_gp_insn_p.
	(mips_constant_info): Delete.
	(mips_address_info): Add the address type as an extra field.  Replace
	the c field with symbol_type.
	(mips_split_p, mips_lo_relocs, mips_hi_relocs): New arrays.
	(TARGET_DELEGITIMIZE_ADDRESS): Remove definition.
	(mips_reloc_offset_ok_p, mips_classify_constant): Delete.
	(mips_split_const, mips_symbolic_constant_p): New functions.
	(mips_symbolic_address_p): Take the symbol type and mode as arguments.
	(mips_classify_address): Return true if the address is valid, storing
	its type in INFO.  Use mips_symbolic_constant_p.  Use mips_lo_relocs[]
	to test whether a LO_SUM address is allowed.
	(mips_symbol_insns): Return 0 for general mips16 symbols.
	Reorder SYMBOL_GOT_GLOBAL case to match mips_symbol_type definition.
	Handle the new SYMBOL_GOTOFF_*s.
	(mips_address_insns): Update call to mips_classify_address.
	(mips_const_insns): Be more fussy about HIGH constants.  Remove use
	of mips_classify_constant.  Be more accurate about CONSTs.
	(mips_global_pic_constant_p): Delete.
	(const_arith_operand): Only accept CONST_INTs.
	(call_insn_operand): Remove call to mips_classify_constant.
	Let mips_symbolic_constant_p check for invalid offsets.
	(move_operand): Check for general_operands first.  Only accept symbolic
	constants if they satisfy mips_symbolic_constant_p and cannot be split.
	(symbolic_constant): Use mips_symbolic_constant_p.
	(global_got_operand, local_got_operand): New predicates.
	(stack_operand): Update call to mips_classify_address.
	(mips_legitimate_address_p): Likewise.
	(mips_reloc, mips_lui_reloc): Delete.
	(mips_force_temporary): Only use the given temporary if no_new_pseudos.
	Use emit_move_insn.
	(mips_split_symbol, mips_unspec_address): New functions.
	(mips_unspec_offset_high): New function.
	(mips_load_got): Replace reloc argument with a symbol_type.
	Use mips_unspec_address to create the address and put it in a
	LO_SUM with the base register.
	(mips_load_got16, mips_load_got32): Delete.
	(mips_emit_high, mips_legitimize_symbol): Delete.
	(mips_gotoff_global): New function.
	(mips_load_got_page, mips_load_got_global): New functions.
	(mips_legitimize_symbol): Inline handling of LO_SUM splits.
	(mips_legitimize_const_move): Likewise.  Remove HIGH handling.
	Inline code to handle constants plus invalid offsets.  Use
	mips_split_symbol to legitimize constant pool addresses.
	(mips_delegitimize_address): Delete.
	(mips_rtx_costs): Give legitimate symbolic constants and CONST_DOUBLEs
	a cost of 1 insn.  Give the rest a cost of CONSTANT_POOL_ADDRESS.
	(mips_subword): Pass memrefs through mips_rewrite_small_data.
	(mips_output_move): Remove use of mips_classify_constant.
	(mips_expand_call): Use mips_unspec_offset_high to calculate the
	high part of the GOT address for calls to global functions.
	(override_options): Initialize mips_split_p[], mips_lo_relocs[]
	and mips_hi_relocs[].
	(print_operand): Use print_operand_reloc to handle '%h' and '%R'.
	Remove use of mips_classify_constant.
	(mips_reloc_string): Delete.
	(print_operand_reloc): New function.
	(print_operand_address): Update call to mips_classify_address.
	(mips_rewrite_small_data_p, small_data_pattern_1): New functions.
	(small_data_pattern): New predicate.
	(mips_rewrite_small_data_1, mips_rewrite_small_data): New functions.
	(mips_function_has_gp_insn): New function.
	(mips_global_pointer): Use it.
	(mips_gp_insn): Delete.
	(mips_expand_prologue): When compiling for n32/n64 abicalls, use a
	single loadgp pattern to initialize $gp.  Pass it the offset of _gp
	from the start of the current function.
	(mips16_gp_pseudo_reg): Revert last patch.

	* config/mips/mips.md (RELOC_*): Delete.
	(UNSPEC_LOADGP, UNSPEC_FIRST_ADDRESS): New constants.
	(got): New insn attribute.
	(type): Set to "load" if got == load.
	(length): Set to 4 if got == load, 8 if got == xgot_high.
	(lui[sd]i): Delete.
	(*xgot_hi[sd]i, *xgot_lo[sd]i): New patterns.
	(*got_disp[sd]i, *got_page[sd]i): Likewise.
	(*low[sd]i): Change constraints to "d".  Add a new define_split to
	rewrite small data constants into LO_SUMs.
	(loadgp): New insns.

2003-11-04  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config/mips/_tilib.c: Use _ABI* in _MIPS_SIM tests.

2003-11-04  DJ Delorie  <dj@redhat.com>

	* config/v850/v850.md (mulhisi3): Expand the const_int case
	separately to avoid trying to sign extend the const.

2003-11-04  Richard Sandiford  <rsandifo@redhat.com>

	* emit-rtl.c (copy_rtx_if_shared): Don't allow MEMs with constant
	addresses to be shared.
	(force_const_mem): Return a copy of the pool entry.

2003-11-03  Andreas Jaeger  <aj@suse.de>

	* Makefile.in (GCC_CFLAGS): Remove @WERROR@ again.

2003-11-03  Kelley Cook  <kcook@gcc.gnu.org>

	* Makefile.in (cpp.dvi): New target split from cpp.info.
	(gcc.dvi):  New target split from gcc.info.
	(gccint.dvi): New target split from gccint.info.
	(cppinternals.dvi): New target split from cppinternals.info
	(gccinstall.info): New specific rule.
	(gccinstall.dvi): Likewise.
	(dvi): Move targets to $(docobjdir).
	($(docobjdir)/%.dvi): New implicit rule.

2003-11-03  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* doc/gty.texi (tag, desc): Say more about role of desc values in
	selecting between tags.

2003-11-03  Alexander Kabaev  <ak03@gte.com>

	* real.c (encode_ieee_single): Ensure proper promotion.

2003-11-03  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	* doc/contrib.texi: Add Giovanni Bajo, Dara Hazeghi, Falk Hueffner,
	and Andrew Pinski.

2003-11-03  Syd Polk  <spolk@apple.com>

	* config/rs6000/rs6000.c (rs6000_override_options): Add G3, G4, and G5
	marketing names to the list of supported processors.
	* config/rs6000/rs6000.h: Ditto.
	* doc/invoke.texi: Ditto.
	* config.gcc: Ditto.

2003-11-03  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* fixinc/inclhack.def (stdio_va_list): Allow tab before va_list.
	Merge two substitutions.
	* fixinc/fixincl.x: Regenerate.
	Fixes PR bootstrap/12666.

2003-11-03  Joseph S. Myers  <jsm@polyomino.org.uk>

	* doc/install-old.texi: Remove VMS documentation.

2003-11-03  Jan Hubicka  <jh@suse.cz>

	* i386.c (override_options):  Remove hack enabling 128bit long double
	commited by accident.

2003-11-02  Per Bothner  <per@bothner.com>

	* c-opts.c (needValue):  Do cpp_find_main_file before processing
	any imacros flags, so pfile->main_file is set for the latter.

2003-11-03  Andreas Jaeger  <aj@suse.de>
	    Zack Weinberg  <zack@codesourcery.com>

	* Makefile.in (GCC_CFLAGS): Allow blacklisting of warnings.
	(SYSCALLS.c.X-warn): Suppress warnings.

2003-11-02  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR optimization/12845
	* pa.c (output_cbranch): Use cmpb for DImode comparisons with 0.

2003-11-02  Zack Weinberg  <zack@codesourcery.com>

	* print-rtl.c (print_rtx): Call PRINT_REG with second argument -1.
	* config/i386/i386.c (print_reg): Abort on a virtual register
	if code != -1; not if file == asm_out_file.
	* config/i386/i386.h (PRINT_REG): Document meaning of CODE == -1.
	(DEBUG_PRINT_REG): Delete, unused.

2003-11-02  Andreas Schwab  <schwab@suse.de>

	* config/ia64/fde-glibc.c (_GNU_SOURCE): Define to 1 instead of
	empty to avoid conflict with the definition from configure.

2003-11-02  Roger Sayle  <roger@eyesopen.com>

	PR optimization/10817
	* ifcvt.c (noce_emit_move_insn): Improve documentation comment.
	(noce_try_move): New function to optimize an if-the-else into an
	unconditional move, i.e. "if (a!=b) x=a; else x=b" into "x=a".
	(noce_process_if_block): Attempt simplification with noce_try_move.

	* simplify-rtx.c (simplify_ternary_operation): Some minor fixes
	and improvements to the optimizations of IF_THEN_ELSE expressions.
	(simplify_subreg): Silence signed/unsigned comparison warning.

2003-11-02  Richard Sandiford  <rsandifo@redhat.com>

	* Makefile.in (targhooks.o, reload.o): Update dependencies.
	(GTFILES): Add targhooks.c.
	(gt-targhooks.h): New rule; depend on s-gtype.
	* target.h (direct_pool_load_p): New hook.
	* target-def.h (TARGET_DIRECT_POOL_LOAD_P): New macro.
	(TARGET_INITIALIZER): Include it.
	* targhooks.h (default_direct_pool_load_p): Declare.
	(hook_bool_machine_mode_true): Declare.
	* targhooks.c: Include insn-config.h, recog.h, ggc.h and
	gt-targhooks.h.
	(pool_symbol): New variable.
	(default_direct_pool_load_p): New function.
	(hook_bool_machine_mode_true): New function.
	* reload.c: Include target.h.
	(find_reloads): If an alternative will force a constant into memory,
	count an extra reload if constant pool symbols are not valid
	addresses.  If an alternative uses memory to move values between
	registers, count the move as two reloads rather than one.
	* config/s390/s390.c (TARGET_DIRECT_POOL_LOAD_P): Define.
	* doc/tm.texi (TARGET_DIRECT_POOL_LOAD_P): Document.

2003-11-02  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/12799
	* postreload.c (reload_cse_move2add): Generate the add2
	patterns manually.

2003-11-02  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* config/sparc/sparc.c (function_arg_partial_nregs) [TARGET_ARCH64]:
	Return 0 for all complex modes whose size is lesser or equal to
	a word.  Add a ??? comment for the condition used with 16-byte
	aligned modes.

2003-11-01  Kelley Cook  <kcook@gcc.gnu.org>

	* .cvsignore: Remove c-parse* and tradcif.c.
	* objc/.cvsignore: Delete.

2003-11-01  Roger Sayle  <roger@eyesopen.com>

	* unwind-sjlj.c (_Unwind_GetCFA): Return (_Unwind_Word)0 instead
	of NULL.

2003-11-01  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* som.h (DO_GLOBAL_DTORS_BODY): Change to C90 declaration.

	* libgcc2.c (SYMBOL__MAIN): Provide C90 declaration.

	* collect2.c (scan_libraries): Fix typos.

	PR preprocessor/12847
	* cppfiles.c, cppexp.c, cpperror.c, cpplib.h, cpplib.c, cpplex.c,
	cppinit.c, cpptrad.c, cppmacro.c, fix-header.c, cpppch.c, c-pch.c,
	c-incpath.c, cppcharset.c (DL_WARNING, DL_WARNING_SYSHDR, DL_PEDWARN,
	DL_ERROR, DL_ICE, DL_EXTRACT, DL_WARNING_P): Prefix macro names with
	"CPP_".

2003-11-01  Fariborz Jahanian  <fjahanian@apple.com>

	* config/rs6000/rs6000.c (rs6000_mixed_function_arg): Correct
	no_units calculation.

2003-11-01  Andreas Jaeger  <aj@suse.de>

	* unwind-dw2.c (_Unwind_FrameState): Remove commas at end of
	enumeration list.

2003-11-01  Andreas Schwab  <schwab@suse.de>

	* config/ia64/sysv4.h (SDATA_SECTION_FUNCTION): Update to C90
	prototypes.
	(SBSS_SECTION_FUNCTION): Likewise.

2003-11-01  Andreas Jaeger  <aj@suse.de>

	* Makefile.in (GCC_CFLAGS): Add @WERROR@ for target files.

2003-11-01  Andreas Tobler  <a.tobler@schweiz.ch>

	* config/rs6000/sysv4.h (EXTRA_SECTION_FUNCTIONS): Update to C90
	prototypes.

2003-11-01  Andreas Jaeger  <aj@suse.de>

	* unwind-dw2.c (_Unwind_FindEnclosingFunction): Constify variable.
	(uw_frame_state_for): Constify variables.
	(extract_cie_info): Constify first argument.

	* unwind-dw2-fde-darwin.c: Adjust prototype of
	_Unwind_Find_registered_FDE for recent changes.
	(examine_objects): Constify return value and local variable result.
	(_Unwind_Find_FDE): Constify return value and local variable ret.

2003-10-31  Per Bothner  <pbothner@apple.com>

	* c-opts.c (finish_options):  Change to returns boolean - false iff
	the call to cpp_find_main_file fails.
	(c_common_init):  Skip preprocess_file if finish_options failed.
	(c_common_parse_file):  Break if finish_options failed.
	Fixes PR preprocessor/12545.

2003-10-31  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* aclocal.m4: Blacklist ultrix* for mmap file.
	* configure: Rebuilt.

	* function.c (assign_parms): Add ATTRIBUTE_UNUSED to variable
	reg_parm_stack_space.
	* toplev.c (default_get_pch_validity): Fix warning.

	* vax.c: Include toplev.h.
	(vax_init_libfuncs): Fix typo (umod).
	* vax.h (ASM_COMMENT_START): Define.
	(PRINT_OPERAND): Fix warning when HOST_WIDE_INT is a long long.

2003-10-31  Roger Sayle  <roger@eyesopen.com>

	PR middle-end/11968
	* expr.c (expand_expr <MULT_EXPR>): Remove inappropriate and
	confusing comment; distributivity isn't handled in expand_expr.
	* fold-const.c (extract_muldiv_1 <PLUS_EXPR>):  Allow overflow
	in distributivity, if wrap-around semantics are specified with
	-fwrapv.

2003-11-01  Alan Modra  <amodra@bigpond.net.au>

	PR 12315
	* final.c (profile_function): Allow for NULL svrtx.

2003-10-31  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.c (pa_select_section): Use new style declaration.
	* som.h (readonly_data): Likewise.

2003-10-31  Kelley Cook  <kcook@gcc.gnu.org>

	* config/rs6000/rs6000.c: Update to C90 prototypes.

2003-10-31  Richard Earnshaw  <rearnsha@arm.com>

	PR target/7513
	* arm.h (CONDITIONAL_REGISTER_USAGE): Disable use of LR in Thumb
	code.

2003-10-31  Andreas Jaeger  <aj@suse.de>,
	    Zack Weinberg  <zack@codesourcery.com>


	* crtstuff.c (__register_frame_info, __register_frame_info_bases)
	(__deregister_frame_info, __deregister_frame_info_bases):
	Constify void * argument.
	* unwind-dw2-fde.h (struct fde_vector):
	Constify 'orig_data' and 'array' fields.
	(__register_frame_info, __register_frame_info_bases)
	(__deregister_frame_info, __deregister_frame_info_bases):
	Constify void * argument.
	(get_cie, next_fde, _Unwind_Find_FDE): Constify arguments,
	return values, and casts of type fde *, struct dwarf_fde *,
	and struct dwarf_cie *.
	* unwind-dw2-fde.c (__register_frame_info, __register_frame_info_bases)
	(__deregister_frame_info, __deregister_frame_info_bases):
	Constify void * argument.
	(get_cie_encoding, ): Constify struct dwarf_cie * argument.
	(get_fde_encoding, fde_unencoded_compare, fde_single_encoding_compare)
	(fde_mixed_encoding_compare, fde_compare_t, start_fde_sort, fde_insert)
	fde_split, SWAP, frame_downheap, frame_heapsort)
	(classify_object_over_fdes, add_fdes, linear_search_fdes,
	binary_search_unencoded_fdes, binary_search_single_encoding_fdes,
	binary_search_mixed_encoding_fdes, search_object, _Unwind_Find_FDE):
	Constify arguments, local variables, return values, and casts
	of type fde *, fde **, struct dwarf_fde *, and struct dwarf_cie *.
	Use const pointer types in sizeof expressions, for clarity.
	* unwind-dw2-fde-glibc.c
	(_Unwind_find_registered_FDE, _Unwind_find_FDE): Constify return value.
	(struct unw_eh_callback_data): Constify 'ret' field.

2003-10-31  Fariborz Jahanian  <fjahanian@apple.com>
	    David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.c (rs6000_mixed_function_arg): New.
	(function_arg): Call it.
	(rs6000_function_value): Widen integral return value to mode based
	on TARGET_32BIT, not word_mode.
	* config/rs6000/rs6000.h (PROMOTE_MODE): Likewise.
	(UNITS_PER_ARG): New.
	(RS6000_ARG_SIZE): Use it.

2003-10-31  Gerald Pfeifer  <gerald@pfeifer.com>

	* .cvsignore: No longer ignore gengtype-lex.c, gengtype-yacc.c,
	and gengtype-yacc.h.

2003-10-31  Richard Earnshaw  <rearnsha@arm.com>

	PR optimization/8896
	* postreload.c (reload_combine): Check that REGY doesn't die in an
	insn of the form (set (regx) (plus (regx) (regy))), ie REGX != REGY.

2003-10-31  Josef Zlomek  <zlomekj@suse.cz>

	PR/10239
	* cfgrtl.c (delete_insn): Decrease LABEL_NUSES for all REG_LABEL notes.

2003-10-31  Josef Zlomek  <zlomekj@suse.cz>

	PR/11640
	* cfgrtl.c (try_redirect_by_replacing_jump): Move jump
	immediatelly before BARRIER.

2003-10-31  Kelley Cook  <kcook@gcc.gnu.org>

	* Makefile.in (STRICT2_WARN): Add -Wold-style-definition.

2003-10-31  Richard Earnshaw  <rearnsha@arm.com>

	PR target/11271
	* reload.c (find_reloads_address): Handle any register in
	(PLUS (PLUS (REG) (REG)) (CONST_INT).

2003-10-31  Richard Earnshaw  <rearnsha@arm.com>

	* ggc-page.c (ggc_pch_read): Wrap call to poison_pages in
	ENABLE_GC_CHECKING not in GGC_POISON.

2003-10-31  Nathanael Nerode  <neroden@gcc.gnu.org>

	PR bootstrap/9863
	* configure.in: Bail out if awk is missing.
	* configure: Regenerate.

	PR ada/12761
	* Makefile.in: Move default definitions of X_ADA_CFLAGS,
	T_ADA_CFLAGS, X_ADAFLAGS, T_ADAFLAGS from ada/Make-lang.in to here.

2003-10-30  Richard Henderson  <rth@redhat.com>

	* c-objc-common.c (c_tree_printer): Handle types correctly.
	Factor code a bit.

2003-10-30 Kelley Cook <kcook@gcc.gnu.org>

	* value-prof.c, web.c: Update to C90.

2003-10-30  Eric Christopher  <echristo@redhat.com>

	* function.c (purge_addressof_1): Add case for REG_RETVAL
	notes when modes are unequal.

2003-10-31  Jan Hubicka  <jh@suse.cz>

	* i386-modes.def: Add XFmode format adjustment.

2003-10-30  Jan Hubicka  <jh@suse.cz>

	* real.c (encode_ieee_extended): Back out previous patch.

2003-10-30  Jan Hubicka  <jh@suse.cz>

	* real.c (encode_ieee_extended): Initialize whole array.
	* reg-stack.c (move_for_stack_reg0: Use always XFmode.
	* i386-modes.def: Change definitions of TFmode and XFmode.
	* i386.c (classify_argument): Rename TFmodes to XFmodes; add new TFmode
	code.
	(construct_container): Allow constructing of TFmode integer containers.
	(ix86_return_in_memory):  XFmode is not returned in memory.
	(init_ext_80387_constants): Always use XFmode.
	(print_operand): Likewise.
	(ix86_prepare_fp_compare_regs): Likewise.
	(split_to_parts): Deal with TFmode.
	(split_long_move): Simplify.
	(ix86_init_mmx_sse_builtins): Add __float80, __float128.
	(ix86_memory_move_cost): Do not confuse TFmode.
	* i386.h (LONG_DOUBLE_TYPE_SIZE): Set to 96.
	(IS_STACK_MODE): TFmode is not stack mode.
	(HARD_REGNO_NREGS, CLASS_MAX_NREGS): Deal nicely with XFmode.
	(VALID_SSE_REG_MODE): Allow TFmode.
	(VALID_FP_MODE_P): Disallow TFmode.
	(VALID_INT_MODE_P): Allow TFmode in 64bit mode.
	* i386.md (TFmode patterns): Kill.
	(movtf, motf_rex64): New patterns.

2003-10-30  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.md (adddi3): Fix typo in mips16 stack pointer code.

2003-10-30  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.md (mov_lwl): Use memory_operand where appropriate.
	(mov_lwr, mov_swl, mov_swr): Likewise.
	(mov_ldl, mov_ldr, mov_sdl, mov_sdr): Likewise.

2003-10-30  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.c (mips_global_pointer): Don't try to use $25.

2003-10-30  Richard Henderson  <rth@redhat.com>

	* config/mips/mips.c (mips_build_builtin_va_list): Use runtime
	test for irix6 rather than preprocessor test.

2003-10-30  Richard Henderson  <rth@redhat.com>

	* cppcharset.c (one_utf8_to_utf16): Initialize 's' to silence warning.

2003-10-30  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.c (struct machine_function): Use save_return_addr_p
	as a general flag that the return address register needs to be saved,
	not necessarily because of __builtin_return_addr (0).
	(s390_split_branches): Remove TEMP_REG and TEMP_USED arguments,
	remove special handling of zSeries machines.
	(s390_optimize_prolog): Remove TEMP_USED argument, treat the return
	register as a regular register on zSeries machines.
	(s390_reorg): Adjust calls to s390_split_branches and
	s390_optimize_prolog.
	(s390_frame_info): On zSeries machines, do not assume the return
	register is always used.  Update regs_ever_live with current data
	for the special registers.
	(s390_emit_epilogue): Use save_return_addr_p to determine whether
	the return register was saved.
	* config/s390/s390.h (CONDITIONAL_REGISTER_USAGE): Do not mark
	RETURN_REGNUM fixed on zSeries machines.
	(REG_ALLOC_ORDER): Use RETURN_REGNUM last.
	* config/s390/s390.md ("*doloop_si"): Handle branch overflow
	via ahi-jgne pair on zSeries machines.
	("*doloop_di"): Likewise.
	("*doloop_di_long"): Remove.

2003-10-30  Richard Earnshaw  <rearnsha@arm.com>

	* arm.c (arm_override_options): Revert change of arm_constant_limit
	when optimizing for size.

2003-10-29  Richard Henderson  <rth@redhat.com>

	* fold-const.c (fold_single_bit_test): Convert the input to the
	operational intermediate type.

2003-10-29  Richard Henderson  <rth@redhat.com>

	* builtins.c (std_build_builtin_va_list): New.
	* expr.h (std_build_builtin_va_list): Declare.
	* defaults.h (BUILD_VA_LIST_TYPE): New.
	* system.h (BUILD_VA_LIST_TYPE): Poison.
	* target-def.h (TARGET_BUILD_BUILTIN_VA_LIST): New.
	* target.h (struct gcc_target): Add build_builtin_va_list.
	* tree.c (build_common_tree_nodes_2): Use it.

	* config/alpha/alpha-protos.h, config/alpha/alpha.c,
	config/alpha/alpha.h, config/alpha/unicosmk.h,
	config/d30v/d30v-protos.h, config/d30v/d30v.c, config/d30v/d30v.h,
	config/i386/i386-protos.h, config/i386/i386.c, config/i386/i386.h,
	config/i860/i860-protos.h, config/i860/i860.c, config/i860/i860.h,
	config/i960/i960-protos.h, config/i960/i960.c, config/i960/i960.h,
	config/mips/iris6.h, config/mips/mips-protos.h, config/mips/mips.c,
	config/mips/mips.h, config/rs6000/rs6000-protos.h,
	config/rs6000/rs6000.c, config/rs6000/rs6000.h,
	config/s390/s390-protos.h, config/s390/s390.c, config/s390/s390.h,
	config/sh/sh-protos.h, config/sh/sh.c, config/sh/sh.h,
	config/xtensa/xtensa-protos.h, config/xtensa/xtensa.c,
	config/xtensa/xtensa.h: Rename foo_build_va_list to
	foo_build_builtin_va_list; make it static.  Define
	TARGET_BUILD_BUILTIN_VA_LIST.  Remove BUILD_VA_LIST_TYPE.
	Update protos.

	* config/i386/i386.c (ix86_expand_carry_flag_compare): Make static.
	* config/iq2000/iq2000.h (BUILD_VA_LIST_TYPE): Remove.

2003-10-29  James E Wilson  <wilson@specifixinc.com>

	* recog.c (asm_operand_ok): Add missing break after case 'X'.
	Change if statements to else if statements in default case.
	(extract_constrain_insn_cached): Fix misspelling of constrain_operands
	in comment.
	(constrain_operands_cached): Likewise.
	(constrain_operands): Change if statements to else if statements in
	default case.
	* reload.c (find_reloads): Likewise.

2003-10-29  Richard Henderson  <rth@redhat.com>

	* config/m68k/m68k.c (notice_update_cc): Clear cc status for
	shifts and rotates.

2003-10-30  Alan Modra  <amodra@bigpond.net.au>

	* config/rs6000/rs6000.md: Remove duplicate pattern.

2003-10-29  Hans-Peter Nilsson  <hp@axis.com>

	* real.c (do_divide): Initialize result with a 0.

	* configure.in <enable-checking for valgrind>: Look for
	<valgrind/memcheck.h> first.  AC_DEFINE HAVE_VALGRIND_MEMCHECK_H
	if it exists.
	* configure, config.in: Regenerate.
	* ggc-common.c [ENABLE_VALGRIND_CHECKING &&
	HAVE_VALGRIND_MEMCHECK_H]: Include <valgrind/memcheck.h>.  Use
	#elif for other alternatives.
	* ggc-page.c: Ditto.
	* ggc-zone.c: Don't assume <valgrind/memcheck.h>; instead copy
	include structure from ggc-common.c.

2003-10-29  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa-linux.h (ASM_OUTPUT_ADDR_VEC_ELT): Use label in big switch ELTs.
	(ASM_OUTPUT_ADDR_DIFF_ELT): Use label difference in big switch ELTs.
	* pa.c (pa_adjust_insn_length): Check for btable branches using
	attribute TYPE_BTABLE_BRANCH.
	(pa_reorg): Simplify.
	* pa.h (CASE_VECTOR_MODE): Change big switch mode to SImode.
	(ASM_OUTPUT_ADDR_VEC_ELT): As above.
	(ASM_OUTPUT_ADDR_DIFF_ELT): As above.
	* pa.md (btable_branch): New instruction type.
	(in_branch_delay, in_nullified_branch_delay, in_call_delay): Disallow
	btable branches.
	(define_delay): Add btable branches to insn types that may have an
	insn in the delay position.
	(Z2, Z3): Add btable branch to list.
	Simplify unamed pattern set copy pic_label_operand to register.  Add
	PA 2.0 variant.
	(short_jump): New jump for use in branch tables.
	(casesi, casesi0): Revise for new branch table formats.
	(casesi32, casesi32p, casesi64p): New casesi patterns.
	(indirect_jump): Move.

2003-10-29  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.h (UNITS_PER_WORD): Revert to
	!TARGET_POWERPC64.
	(UNITS_PER_GPR_WORD): Delete.
	(HARD_REGNO_NREGS): Revert to UNITS_PER_WORD.
	(HARD_REGNO_MODE_OK): Same.
	(CLASS_MAX_NREGS): Same.

2003-10-29  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.h (ASM_COMMENT_START): Define.

2003-10-29  Zack Weinberg  <zack@codesourcery.com>

	* genmodes.c (complete_mode): Record MODE_CC, MODE_INT,
	MODE_FLOAT, and MODE_PARTIAL_INT modes as having one
	component, not zero.

2003-10-29  Andreas Schwab  <schwab@suse.de>

	* config/ia64/t-ia64 (LIB2ADDEH): Add $(srcdir)/gthr-gnat.c.

2003-10-29  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* config/sparc/sparc.c (function_arg_partial_nregs) [TARGET_ARCH64]:
	Never return 1 for complex integral modes whose size is lesser or
	equal to a word.
	(function_arg_pass_by_reference) [TARGET_ARCH64]: Mention CTImode
	in the comment.
	(function_arg_advance) [TARGET_ARCH64]: Don't special-case complex
	modes.
	(sparc_va_arg) [TARGET_ARCH64]: Handle any types whose size is
	greater than 16 bytes by reference.

2003-10-29  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* config/ia64/ia64.c (ia64_assemble_integer): Test POINTER_SIZE,
	not TARGET_ILP32.
	(ia64_initialize_trampoline): Use globalize_label target call.

2003-10-29  Andreas Schwab  <schwab@suse.de>

	* doc/install.texi (Building): Add a sentence about building Ada
	for a canadian cross.

2003-10-28  Zack Weinberg  <zack@codesourcery.com>

	* config/ia64/ia64.c (cmptf_libfunc): New static.
	(ia64_expand_compare): Add logic to open-code calls to
	_U_Qfcmp for TFmode comparisons.
	(ia64_hpux_init_libfuncs): Initialize cmptf_libfunc.
	Set libfuncs for TFmode eq/ne/gt/ge/lt/gt to 0; these should
	never be generated anymore.
	* config/ia64/ia64.md (cmptf): New expander.

2003-10-28  Zack Weinberg  <zack@codesourcery.com>

	* ia64.md (UNSPEC_SETF_EXP,UNSPEC_FR_SQRT_RECIP_APPROX): New constants.
	(*sqrt_approx): New instruction pattern for approximate square roots.
	(*setf_exp_xf): New instruction pattern for exponentiation.
	(*maddxf4_alts_truncsf): New instruction pattern for truncation.
	(sqrtsf2_internal_thr): New define_and_split implementing
	throughput-optimized inline calculation of SFmode square root.
	(sqrtdf2_internal_thr): Likewise for DFmode.
	(sqrtxf2_internal_thr): Likewise for XFmode.
	(sqrtsf2, sqrtdf2, sqrtxf2): New expanders to choose between
	latency- and throughput-optimized square root algorithms.
	* ia64.h (MASK_INLINE_SQRT_LAT, MASK_INLINE_SQRT_THR,
	TARGET_INLINE_SQRT_LAT, TARGET_INLINE_SQRT_THR, TARGET_INLINE_SQRT):
	New macros.
	(TARGET_SWITCHES): Add -minline-sqrt-min-latency and
	-minline-sqrt-max-throughput.
	* ia64.c (ia64_override_options): If both -minline-sqrt-min-latency
	and -minline-sqrt-max-throughput are given, notify the user
	that both options cannot be used simultaneously.
	If -minline-sqrt-min-latency is given, notify the user that
	this mode is not yet implemented.
	(rtx_needs_barrier): Reformat initial comment to obey
	72-character width limit.  Support UNSPEC_SETF_EXP and
	UNSPEC_FR_SQRT_RECIP_APPROX.

2003-10-29  Alan Modra  <amodra@bigpond.net.au>

	* config/rs6000/rs6000.md (movdf_softfloat64): Allow dummy ctr,ctr
	moves.

2003-10-28  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	PR target/11598
	PR libgcj/10610
	* config/rs6000/sysv4.h (PREFERRED_STACK_BOUNDARY): New macro.

2003-10-28  Richard Earnshaw  <rearnsha@arm.com>

	* arm.c (arm_output_epilogue): When using a frame pointer, don't emit
	an extra stack adjustment insn if the stack pointer is already
	pointing at the right place.
	(use_return_insn): Allow a return insn to be used when we have a
	frame pointer if the stack pointer is in the right place.
	(output_return_instruction): Handle it.

2003-10-28  Andreas Jaeger  <aj@suse.de>

	* ggc-zone.c (check_cookies): Add missing variable.
	Add void to prototypes.

2003-10-27  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* config/mips/irix6-libc-compat.c (inet_makeaddr): Prototype.
	* crtstuff.c (__do_global_ctors_1): Move prototype.
	* unwind-dw2.c (NO_SIZE_OF_ENCODED_VALUE): Define when
	appropriate.
	* unwind-sjlj.c (_Unwind_GetCFA, _Unwind_FindEnclosingFunction):
	Mark parameter with __attribute__((unused)).

2003-10-27  Zack Weinberg  <zack@codesourcery.com>

	* c-decl.c (pushdecl): Clarify comment.

2003-10-27  Arnaud Charlet  <charlet@act-europe.fr>

	* doc/install.texi: Update instructions for Ada cross builds

	PR ada/5909:
	* doc/sourcebuild.texi: Document Ada test suite.

2003-10-27  Stephane Carrez  <stcarrez@nerim.fr>

	* config/m68hc11/m68hc11.c: Convert to ISO C90.
	* config/m68hc11/m68hc11-protos.h: Likewise.

2003-10-27  Jan Hubicka  <jh@suse.cz>
	    Eric Botcazou  <ebotcazou@libertysurf.fr>

	* toplev.c (enum dump_file_index, dump_file): Fix ordering of
	webizer pass dump.

2003-10-27  Jakub Jelinek  <jakub@redhat.com>
	    Jan Hubicka  <jh@suse.cz>

	* reload1.c (struct elim_table): Change offset, initial_offset and
	previous_offset fields to HOST_WIDE_INT.
	(offsets_at): Change from int to HOST_WIDE_INT.
	(reload): Adjust offsets_at initialization.
	(eliminate_regs_in_insn): Change type of offset to HOST_WIDE_INT.
	(verify_initial_elim_offsets): Change type of t to HOST_WIDE_INT.
	* config/i386/i386.c (ix86_compute_frame_layout): Change offset type
	to HOST_WIDE_INT.  Don't save regs using mov for huge frame sizes
	if TARGET_64BIT.
	(pro_epilogue_adjust_stack): New function.
	(ix86_expand_prologue, ix86_expand_epilogue): Use it.
	* config/i386/i386.md (pro_epilogue_adjust_stack): Remove.
	(pro_epilogue_adjust_stack_1): Remove * in front of name.
	(pro_epilogue_adjust_stack_rex64): Handle -2147483648 properly.
	(pro_epilogue_adjust_stack_rex64_2): New insn.

	* config/i386/i386.c (ix86_expand_epilogue): Fix comment typo.

	* config/i386/i386.c (ix86_expand_call): Replace 40 with
	FIRST_REX_INT_REG + 3 /* R11 */.

2003-10-26  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.md (attr cannot_copy): New.
	(call_osf_2_er, call_value_osf_2_er, ldgp_er_1, ldgp_er_2,
	prologue_ldgp_er_2, prologue_ldgp_1): Set it.
	* config/alpha/alpha.c (alpha_cannot_copy_insn_p): Test it.

2003-10-26  Daniel Berlin  <dberlin@dberlin.org>

	* ggc-zone.c:  New file, zone allocating collector.
	* configure: Accept zone option for --with-gc
	* configure.in: Ditto.
	* ggc.h (ggc_pch_count_object): Pass bool indicating
	stringiness. Update all callers.
	(ggc_pch_alloc_object): Ditto.
	(ggc_pch_write_object): Ditto.
	(ggc_alloc_rtx): Use typed allocation, since all RTX's are of a single
	type.
	(ggc_alloc_rtvec): Ditto.
	(ggc_alloc_tree): Use zone allocation, since some things using this macro
	aren't a single typecode.
	* ggc-none.c (ggc_alloc_typed): New function.
	(ggc_alloc_zone): Ditto.
	* ggc-page.c: Ditto on both functions.

2003-10-26  Gunther Nikl  <gni@gecko.de>

	* config/m68k/m68k.c (m68k_compute_frame_layout): Ensure FPU related
	frame information is always valid.
	(m68k_output_function_prologue): Remove superfluous TARGET_68881
	test; fix formatting.

2003-10-26  Gunther Nikl  <gni@gecko.de>

	* config/m68k/m68k.c (m68k_compute_frame_layout): Swap reg_mask and
	reg_rev_mask computation.
	(m68k_output_function_prologue): Fix usage of current_frame (one typo
	and one missing); use reg_rev_mask not reg_mask.
	(m68k_output_function_epilogue): Fix usage of current_frame;
	use fpu_rev_mask not fpu_mask.

2003-10-26  Bernardo Innocenti  <bernie@develer.com>

	* config/m68k/m68k.c (m68k_output_function_prologue): Eliminate
	num_saved_regs, use current_frame.reg_no instead.

2003-10-26  Bernardo Innocenti  <bernie@develer.com>
	    Paul Dale  <pauli@snapgear.com>

	* doc/extend.texi (interrupt_handler): Add m68k to the
	list of processors implementing it.
	* doc/invoke.texi (-msep-data): Document new m68k option.
	(-mno-sep-data): Likewise.
	(-mid-shared-library): Likewise.
	(-mno-id-shared-library): Likewise.
	(-mshared-library-id): Likewise.

2003-10-26  Andreas Jaeger  <aj@suse.de>

	* unwind-dw2.c (_Unwind_GetGR): Avoid warning about unsigned
	comparison.
	(_Unwind_SetGR): Likewise.

2003-10-26  Ottavio Campana <ottavio@campana.vi.it>

	PR target/12690
	* config/i386/mmintrin.h (_mm_set1_pi8): Fix comment.

2003-10-26  Gunther Nikl  <gni@gecko.de>

	* config/m68k/m68k.c (m68k_output_function_prologue): Move front
	comment from here to...
	(m68k_save_reg): ...here. Fix comment formatting.
	(m68k_output_function_prologue): Fix comment formatting.
	(m68k_output_function_epilogue): Likewise.
	(const_method): Likewise.

2003-10-26  Kazu Hirata  <kazu@cs.umass.edu>

	* toplev.c (default_get_pch_validity): Guard the use of
	target_options with #ifdef TARGET_OPTIONS.
	(default_pch_valid_p): Likewise.

2003-10-26  Andreas Jaeger  <aj@suse.de>
	    Zack Weinberg  <zack@codesourcery.com>
	    Andreas Tobler <toa@pop.agri.ch>

	* dwarf2out.c (output_cfi): Use HOST_WIDE_INT_PRINT.
	(output_die): Likewise.
	(print_die): Likewise.

2003-10-26  Andreas Jaeger  <aj@suse.de>

	* tree.h (dwarf2out_def_cfa, dwarf2out_args_size,
	dwarf2out_reg_save, new_loc_descr): Update prototypes for recent
	dwarf2out.c change.

	* toplev.c (default_pch_valid_p): Fix warning.

2003-10-25  Roger Sayle  <roger@eyesopen.com>

	* simplify-rtx.c (simplify_replace_rtx): Avoid allocating duplicate
	RTL nodes.  If an operator's operands are unchanged, return the
	original argument unchanged.

2003-10-26  Graham Stott  <graham.stott@btinternet.com>

	Fix bootstrap failure.
	* expmed.c (store_bit_field): Don't compare bitsize against
	modes with zero bit-size.

	(extract_bit_field): Likewise

2003-10-25  Jan Hubicka  <jh@suse.cz>

	* dwarf2out.c (dw_cfi_oprnd_struct): Offset is HOST_WIDE_INT.
	(cfa_loc): Likewise.
	(reg_save, stack_adjust_offset, queue_reg_save): Replace long by
	HOST_WIDE_INT.
	(args_size, old_args_size): change type to HOST_WIDE_INT.
	(dwarf2out_def_cfa, dwarf2out_args_size,
	dwarf2out_reg_save, new_loc_descr): offset is HOST_WIDE_INT.
	(dw_val_struct): integers, unsigneds and offsets are HOST_WIDE_INT.
	(add_AT_int, add_AT_unsigned, att_AT_offset, AT_int, AT_unsigned,
	AT_offset): Use HOST_WIDE_INT.
	(based_loc_descr): offset is HOST_WIDE_INT.
	(add_data_member): Likewise.
	(add_const_value_attribute): Simplify.

2003-10-25  Richard Henderson  <rth@redhat.com>

	* config/i386/i386.c (ix86_eax_live_at_start_p): New.
	(ix86_expand_prologue): Save and restore eax around stack probe
	if it's live.

2003-10-25  Jan Hubicka  <jh@suse.cz>

	* cppcharset.c (one_utf8_to_utf32): Initialize 's' to silence warning.

2003-10-25  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR target/12712
	* reg-stack.c (convert_regs_1): Create an arbitrary input stack
	if the block has no predecessors.
	(convert_regs_2): Document the problem with successors whose
	only predecessor is the block to be processed.
	(convert_regs): Don't create the arbitrary input stack here.

2003-10-24  Zack Weinberg  <zack@codesourcery.com>

	* genmodes.c (struct mode_data): Add contained and next_cont
	fields.
	(complete_mode): Maintain linked list of modes that have a
	given component.
	(emit_mode_unit_size): Delete.
	(emit_mode_nunits): New.
	(emit_insn_modes_c): Update to match.
	(emit_mode_adjustments): Propagate size and alignment
	adjustments from component modes to their containers.
	* machmode.h (mode_unit_size): Delete.
	(mode_nunits): New.
	(GET_MODE_NUNITS): Just return the value in the table.
	(GET_MODE_UNIT_SIZE): Compute using GET_MODE_INNER and
	GET_MODE_SIZE.
	* expmed.c (store_bit_field, extract_bit_field): Can use a
	plain move instruction if bitsize >= GET_MODE_BITSIZE of
	destination/source mode, respectively.
	* varasm.c (assemble_real): Write out the full size of the
	constant, not just its bitsize.
	(output_constant): Honor TYPE_MODE of TREE_REAL_CSTs.

	* config/ia64/ia64-modes.def: Define XFmode as well as TFmode.
	Use ADJUST_BYTESIZE and ADJUST_ALIGNMENT to set size and
	alignment of XF and TF modes in compliance with ia64 ABIs.
	Can now hardwire the format of both modes.
	* config/ia64/ia64.c: Change TFmode to XFmode wherever appropriate.
	(general_tfmode_operand, destination_tfmode_operand)
	(tfreg_or_fp01_operand, spill_tfmode_operand): Rename to
	general_xfmode_operand, destination_xfmode_operand,
	xfreg_or_fp01_operand, spill_xfmode_operand respectively.
	(ia64_init_builtins): Make TYPE_PRECISION of fpreg_type
	and float80_type be 96 so they get XFmode.  Use !TARGET_HPUX,
	not INTEL_EXTENDED_IEEE_FORMAT, to decide how to define
	__float128.
	* config/ia64/ia64.h: Default TARGET_HPUX to 0.
	Change TFmode to XFmode wherever appropriate.  Remove all
	references to INTEL_EXTENDED_IEEE_FORMAT.
	(LONG_DOUBLE_TYPE_SIZE): Varies with TARGET_HPUX.
	(LIBGCC2_LONG_DOUBLE_TYPE_SIZE): Define (always 96).
	(PREDICATE_CODES): Update to match function renames.
	* config/ia64/ia64.md: Change TF to XF throughout; rename all
	patterns to match.  Remove all references to
	INTEL_EXTENDED_IEEE_FORMAT.  Update predicate calls to match
	function renames.
	* config/ia64/ia64-protos.c: Update all prototypes to match
	renamed functions.
	* config/ia64/hpux.h: Redefine TARGET_HPUX to 1.
	Remove all references to INTEL_EXTENDED_IEEE_FORMAT.
	* config/ia64/lib1funcs.asm: Add __divxf3 as new name for
	__divtf3; keep old name for backward compatibility.
	(L__compat): New section providing forwarding stubs for
	__fixtfti, __fixunstfti, __floattitf.
	* config/ia64/t-ia64: Add __compat to LIB1ASMFUNCS.

2003-10-24  Geoffrey Keating  <geoffk@apple.com>

	PR 10757
	* c-pch.c: Include target.h.  Improve comments.
	(struct c_pch_validity): Add target_data_length.
	(pch_init): Add target's validity data.
	(c_common_valid_pch): Check target's validity data.
	* target-def.h (TARGET_GET_PCH_VALIDITY): New.
	(TARGET_PCH_VALID_P): New.
	(TARGET_INITIALIZER): Add new fields.
	* target.h: Include tm.h.
	(struct gcc_target): Add get_pch_validity, pch_valid_p.
	* toplev.h (default_get_pch_validity): New prototype.
	(default_pch_valid_p): New prototype.
	* toplev.c (default_get_pch_validity): New routine.
	(default_pch_valid_p): New routine.
	* Makefile.in (TARGET_H): Add TM_H.  Replace all users of
	target.h with $(TARGET_H).
	(c-pch.o): Add TARGET_H.
	* doc/tm.texi (PCH Target): New node.
	(TARGET_GET_PCH_VALIDITY): Document.
	(TARGET_PCH_VALID_P): Document.

2003-10-24  Kelley Cook  <kcook@gcc.gnu.org>

	* Makefile.in: Define a vpath for %.texi.  Remove explicit $(docdir)
	and $(docdir)/include from any *.texi dependencies.
	($(docobjdir)/%.dvi): Depend on stmp-docobjdir.
	($(docobjdir)/%.1): Depend on .pod instead of .texi.
	($(docobjdir)/%.7): Likewise.
	(%.pod): New implicit rule.
	(cpp.pod): New dependency only rule.
	(gcc.pod): New intermediate rule with dependencies and commands.
	(gfdl.pod): Likewise.
	(fsf-funding.pod): Likewise.

2003-10-24  Nathanael Nerode  <neroden@gcc.gnu.org>

	* fixinc/mkfixinc.sh: Remove special cases for svr4 and ptx, and
	related code.
	* fixinc/fixinc.ptx: Remove.
	* fixinc/fixinc.svr4: Remove.

2003-10-24  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.c (load_multiple_operation): Allow both SImode
	and DImode if word_mode is DImode.
	(store_multiple_operation): Likewise.
	* config/s390/s390.md ("load_multiple", "store_multiple"): Likewise.
	("*load_multiple_di"): Allow only if word_mode == DImode.
	("movqi"): Use LLGC whenever TARGET_ZARCH.
	("fix_truncdfsi2"): Fix incorrect temporary size.
	("fix_truncsfsi2"): Likewise.
	("*bras_r", "*brasl_r", "*basr_r"): Remove predicate and constraint
	string for function return value operand.
	("*bras_tls", "*brasl_tls", "*basr_tls"): Likewise.

2003-10-24  Joseph S. Myers  <jsm@polyomino.org.uk>

	* c-parse.in (array_declarator): Use expr_no_commas.
	Fixes PR c/11943.

2003-10-24  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/linux.h: Wrap MD_FALLBACK_FRAME_STATE_FOR and
	associated includes in #ifndef inhibit_libc.

2003-10-24  Roger Sayle  <roger@eyesopen.com>

	* doc/libgcc.texi: Document some more of the libgcc API.

2003-10-24  Richard Earnshaw  <rearnsha@arm.com>

	* arm.c (arm_rtx_costs_1, case TARGET_THUMB): Adjust costs for
	comparing a constant with small negative numbers and add costing
	for constants in conjunction with AND.
	(note_invalid_constants): Tidy previous change.
	(thumb_cmp_operand): Tidy.
	(thumb_cmpneg_operand): New function.
	* arm.h (CONDITIONAL_REGISTER_USAGE): Don't use HI regs if optimizing
	for size.
	(FIRST_LO_REGNUM, FIRST_HI_REGNUM, LAST_HI_REGNUM): Define.
	(PREDICATE_CODES): Add thumb_cmpneg_operand.
	* arm.md (cbranchsi4): Convert to define_expand.  Handle comparison
	with a negative constant.
	(cbranchsi4_insn): Matcher for cbranchsi4.
	(cbranchsi4_scratch): Similar, but a scratch is available for
	handling negative constants.
	(movsi_cbranchsi4): New pattern.
	(tstsi3_cbranch): Renamed from andsi3_cbranch_scratch, remove scratch
	and use the TST instruction.
	(andsi3_cbranch, orrsi3_cbranch, xorsi3_cbranch, cbranchne_decr1)
	(addsi3_cbranch, subsi3_cbranch): Ensure that register preferencing
	cannot see high regs or memory alternatives.
	(bicsi3_cbranch_scratch, bicsi3_cbranch): New patterns.

2003-10-24  Richard Earnshaw  <rearnsha@arm.com>

	* arm.c (note_invalid_constants): Try to extract the constant
	pool value using avoid_constant_pool_reference; only use
	get_pool_constant if that returns the original reference.

2003-10-24  Jan Hubicka  <jh@suse.cz>

	PR c++/12624
	* varasm.c (notice_global_symbol): Disqualify global registers.

2003-10-23  Roger Sayle  <roger@eyesopen.com>

	PR middle-end/11414
	* loop.c (load_mems): Use redirect_jump to forward jumps from
	the original loop end label to the new "loop sink" block's label.

2003-10-23  Roger Sayle  <roger@eyesopen.com>

	PR middle-end/12705
	* optabs.c (expand_binop): When expanding complex operations
	inline, always calculate result into a new temporary register.
	Minor code clean-ups.

2003-10-24  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* objc/lang-specs.h: Handle -print-objc-runtime-info.
	* doc/invoke.texi (Objective-C Dialect Options): Document it.

2003-10-24  Danny Smith  <dannysmith@users.sourceforge.net>

	* config/i386/cygwin.asm: Add copyright notice. Add comment
	on why this code is needed.

2003-10-23  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/clzhi2.c: Fix warnings.
	* config/h8300/ctzhi2.c: Likewise.
	* config/h8300/fixunssfsi.c: Likewise.
	* config/h8300/parityhi2.c: Likewise.
	* config/h8300/popcounthi2.c: Likewise.

2003-10-23  James E Wilson  <wilson@specifixinc.com>

	* gcc.c (option_map): Delete --target and --use-version.

2003-10-23  Fariborz Jahanian  <fjahanian@apple.com>
	    David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.h (UNITS_PER_WORD): Use TARGET_32BIT, not
	TARGET_POWREPC64.
	(UNITS_PER_GPR_WORD): Define.
	(HARD_REGNO_NREGS): Use UNITS_PER_GPR_WORD.
	(HARD_REGNO_CALL_PART_CLOBBERED): Define.
	(HARD_REGNO_MODE_OK): Use UNITS_PER_GPR_WORD.
	(CLASS_MAX_NREGS): Use UNITS_PER_GPR_WORD.
	* config/rs6000/rs6000.c (function_arg): Generate PARALLEL for
	DFmode and DImode in 32-bit ABI / 64-bit computation mode.
	(rs6000_emit_prologue): Select reg_mode and reg_size using
	TARGET_32BIT, not TARGET_POWERPC64.
	(rs6000_function_value): Generate PARALLEL for DImode in 32-bit
	ABI / 64-bit computation mode

2003-10-22  Andrew Haley  <aph@redhat.com>

	* toplev.c (output_file_directive): Allow for null input_name.

2003-10-22  Waldek Hebisch <hebisch@math.uni.wroc.pl>

	* config/i386/i386.c (classify_argument): Handle SET_TYPE.

2003-10-22  Chris Demetriou  <cgd@broadcom.com>

	* configure.in: In --enable-generated-files-in-srcdir option
	handling, fix default case handling.
	* configure: Regenerate.

2003-10-22  Phil Edwards  <phil@codesourcery.com>

	* config.gcc:  Update *-*-vxworks* generic hook and comments.
	(arm-wrs-vxworks, i[4567]86-wrs-vxworks, mips-wrs-vxworks,
	mips-wrs-windiss, sh-wrs-vxworks):  New stanzas.
	* genmultilib:  Allow the MULTILIB_OSDIRNAMES to be mapped directly.
	* config/svr4.h (SWITCH_TAKES_ARG):  Undefine it before redefining it.
	* config/windiss.h:  New file.
	* config/arm/t-vxworks:  New file.
	* config/arm/vxworks.h:  New file.
	* config/i386/t-vxworks:  New file.
	* config/i386/vxworks.h:  New file.
	* config/mips/t-vxworks:  New file.
	* config/mips/vxworks.h:  New file.
	* config/mips/windiss.h:  New file.
	* config/sh/t-vxworks:  New file.
	* config/sh/vxworks.h:  New file.

2003-10-22  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (h8300_output_function_epilogue): Remove.
	(h8300_saveall_function_p): New.
	(h8300_insert_attributes): Insert the saveall attribute if
	#pragma saveall is specified.
	(h8300_attribute_table): Add saveall.
	(TARGET_ASM_FUNCTION_EPILOGUE): Remove.
	* doc/extend.texi: Mention the saveall attribute.

2003-10-22  Joseph S. Myers  <jsm@polyomino.org.uk>

	* c-typeck.c (pedantic_lvalue_warning): Unconditionally warn of
	deprecation of casts as lvalues.
	* fixinc/inclhack.def (obstack_lvalue_cast): New fix.
	* fixinc/fixincl.x: Regenerate.
	* fixinc/tests/base/obstack.h: New test.

2003-10-22  Andreas Schwab  <schwab@suse.de>

	PR target/12676
	* config/m68k/m68k.c (output_addsi3): Fix range check to work on
	LP64 platforms.

2003-10-22  Jan Hubicka  <jh@suse.cz>

	* dwarf2out.c (dwarf2out_abstract_function): Use DW_AT to check
	presence of DW_AT_inline.
	(gen_subprogram_die): Likewise; do not abort instead of emitting
	DW_AT_not_inline.

2003-10-22  Jan Hubicka  <jh@suse.cz>

	* cgraph.c (cgraph_function_possibly_inlined_p): Be conservative when
	global info is not ready.

2003-10-22  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/extend.texi: Mention H8S wherever H8/300H is mentioned.

2003-10-22  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.md ("movstr_short_64", "movstr_short_31"): Merge ...
	("*movstr_short"): ... into this insn pattern.
	("movstr_short"): New expander.
	("*movstr_long_64"): Rename from "movstr_long_64", simplify.
	("*movstr_long_31"): Rename from "movstr_long_31", simplify.
	("movstr_long"): New expander.
	("clrstr_short_64", "clrstr_short_31"): Merge ...
	("*clrstr_short"): ... into this insn pattern.
	("clrstr_short"): New expander.
	("*clrstr_long_64"): Rename from "clrstr_long_64", simplify.
	("*clrstr_long_31"): Rename from "clrstr_long_31", simplify.
	("clrstr_long"): New expander.
	("cmpmem_short_64", "cmpmem_short_31"): Merge ...
	("*cmpmem_short"): ... into this insn pattern.
	("cmpmem_short"): New expander.
	("*cmpmem_long_64"): Rename from "cmpmem_long_64".
	("*cmpmem_long_31"): Rename from "cmpmem_long_31".
	("cmpmem_long"): New expander.
	* config/s390/s390.c (s390_expand_movstr): Use new expanders.
	(s390_expand_clrstr): Likewise.
	(s390_expand_cmpmem): Likewise.

2003-10-22  Mark Mitchell  <mark@codesourcery.com>

	* c-pch.c (struct c_pch_validity): Add pch_init field.
	(pch_init): Set it.
	(c_common_valid_pch): Check it.

2003-10-22  David Taylor <dtaylor@emc.com>

	PR debug/12500
	* dbxout.c (dbxout_typedefs): Use COMPLETE_OR_VOID_TYPE_P.

2003-10-22  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* config/alpha/alpha.c (function_value [ENABLE_CHECKING]): Don't call
	alpha_return_in_memory if no VALTYPE specified.

2003-10-22  Jan Hubicka  <jh@suse.cz>

	PR debug/12389
	* Makefile.in (dwarf2out.o): Depend on cgraph.h.
	* cgraph.c (cgraph_function_possibly_inlined_p): New function.
	* cgraph.h (cgraph_function_possibly_inlined_p): Declare.
	(cgraph_global_info): Add flag inlined
	* dwarf2out.c (gen_subprogram_die, gen_decl_die): Use
	cgraph_function_possibly_inded_p
	* cgraphunit.c (mark_inline): Set inlined flag.
	* toplev.c (rest_of_decl_compilation): Call outlining_inline_function
	only for possibly inlined functions.
	* c-decl.c (duplicate_decls): Never output abstract DIE representing old
	body of function.

2003-10-22  Andrew Haley  <aph@redhat.com>

	* varasm.c (output_constructor): Make constructor annotation
	conditional on ASM_COMMENT_START.

2003-10-21  Jason Merrill  <jason@redhat.com>

	* tree.c (get_unwidened): Check TREE_UNSIGNED on the field's type.
	(get_narrower): Likewise.

	* stor-layout.c (layout_decl): Do packed field alignment for
	bit-fields, too.

2003-10-21  Eric Christopher  <echristo@redhat.com>

	* expr.c (convert_move): Use FLOAT_EXTEND for extensions.

2003-10-21  Geoffrey Keating  <geoffk@apple.com>

	* c-pch.c: Add comments in various places.
	(struct c_pch_validity): Add the lengths of various strings.
	(host_machine): New static.
	(target_machine): New static.
	(get_ident): Bump version number.
	(pch_init): Write out version, host, target validity data.
	(c_common_valid_pch): Check version, host, target.
	* Makefile.in (c-pch.o): Add version.h; define HOST_MACHINE and
	TARGET_MACHINE.

2003-10-21  Jason Merrill  <jason@redhat.com>

	* tree.h (IS_EXPR_CODE_CLASS): Use strchr.
	(EXPR_P): New macro.

2003-10-21  Zack Weinberg  <zack@codesourcery.com>

	* config/ia64/ia64.md (cmpxchg_acq_si): Mark operand 3 as DImode.
	* config/ia64/ia64.c (ia64_expand_fetch_and_op,
	ia64_expand_op_and_fetch): Make sure the REG for ar.ccv is
	DImode.   Use convert_move to load ar.ccv.
	(ia64_expand_compare_and_swap): Likewise.
	If expand_expr doesn't put 'old' and 'new' in the proper
	modes, run them through convert_to_mode.

2003-10-21  Eric Christopher  <echristo@redhat.com>

	* config/frv/frv.c (frv_adjust_field_align): Check DECL_ARTIFICIAL
	for too large bitfields.

2003-10-21  Mark Mitchell  <mark@codesourcery.com>

	* Makefile.in ($(docobjdir)/%.info): Honor BUILD_INFO.

2003-10-21  Andrew Haley  <aph@redhat.com>

	* varasm.c (output_constructor): Annotate constructor.

2003-10-21  Mark Mitchell  <mark@codesourcery.com>

	* Makefile.in ($(DESTDIR)$(infodir)/%.info): Conditionalize chmod
	on existence of destination file.

2003-10-21  Jan Hubicka  <jh@suse.cz>

	* haifa-sched.c (choose_ready): Initialize index.

2003-10-21  Jason Merrill  <jason@redhat.com>

	* tree.c (build1): Fix off-by-one error.

2003-10-21  Robert Millan  <robertmh@gnu.org>

	* config/i386/kfreebsdgnu.h: New. i386-*-kfreebsd-gnu definitions.
	* config/kfreebsdgnu.h: New. *-*-kfreebsd-gnu definitions.
	* config/t-kfreebsd-gnu: New. *-*-kfreebsd-gnu tmake_file.
	* config.gcc: Add *-*-kfreebsd*-gnu and i[34567]86-*-kfreebsd*-gnu.

2003-10-21  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* web.c: Fix various comments.

2003-10-20  Nicolas Pitre <nico@cam.org>

	* config/arm/arm.c (arm_override_options): Set arm_constant_limit
	to 2 instead of 1 when optimize_size is true.  Gather code based on
	optimize_size together.  Add comment about XScale load latency.

2003-10-21  Gunther Nikl  <gni@gecko.de>

	* config/m68k/m68k.c (m68k_output_function_prologue): Remove
	obsolete comments.

2003-10-20  Kelley Cook  <kcook@gcc.gnu.org>

	* Makefile.in: Get parsedir and docobjdir from configure.
	* configure.in: Recogonize --enable-generated-files-in-srcdir.
	Pass along parsedir and docobjdir.
	* configure: Regenerate.
	* doc/install.texi: Document --enable-generated-files-in-srcdir.

2003-10-20  Kelley Cook  <kcook@gcc.gnu.org>

	* Makefile.in: Define $(docdir) before the Make-lang.in fragments are
	included.

2003-10-20  Joseph S. Myers  <jsm@polyomino.org.uk>

	* c-common.c (expand_tree_builtin): Ensure creal and cimag
	functions do not return lvalues.

2003-10-20  Jason Merrill  <jason@redhat.com>

	PR c/12553
	* tree.c (build1) <ADDR_EXPR>: Set TREE_SIDE_EFFECTS
	appropriately.

	PR c/11446
	* stor-layout.c (layout_decl): Fix alignment handling.

2003-10-20  Joseph S. Myers  <jsm@polyomino.org.uk>

	* doc/extend.texi: Deprecate casts as lvalues.

2003-10-20  Jan Hubicka  <jh@suse.cz>

	* toplev.c (rest_of_compilation): Fix webizer pass ordering.

	* cgraphunit.c (decide_is_function_needed):  Fix test dealing
	with functions implicitly made inline.

	* cgraphunit.c (cgraph_decide_inlining_incrementally):  New function.
	(cgraph_finalize_function): Use it.
	(cgraph_mark_inline): Allow incrmental decisions
	* invoke.texi (max-inline-slope, min-inline-insns): Kill.
	* params.def (PARAM_MAX_INLINE_SLOPE, PARAM_MIN_INLINE_INSNS): Kill.
	* tree-inline.c (limits_allow_inlining): Kill.
	(expand_call_inline): Always use unit-at-a-time path.

2003-10-20  Zack Weinberg  <zack@codesourcery.com>

	* fixinc/inclhack.def (hpux11_snprintf): New edit.
	* fixinc/fixincl.x: Regenerate.
	* fixinc/tests/base/stdio.h: Add test for hpux11_snprintf.

2003-10-20  Mark Mitchell  <mark@codesourcery.com>

	* Makefile.in (install-info): Simplify.
	($(DESTDIR)$(infodir)/%.info): New rule.
	* configure.in (target_list): Remove install-info.
	* doc/.cvsignore (gcc.info*): Remove.
	(gccint.info*): Likewise.
	(gccinstall.info*): Likewise.
	(cpp.info*): Likewise.
	(cppinternals.info*): Likewise.
	(*.info*): Add it.
	* doc/sourcebuild.texi: Update description of install-info.
	* objc/Make-lang.in (objc.install-info): Remove.

2003-10-20  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config/mips/linux.h (TARGET_OS_CPP_BUILTINS): Define _ABIO32.
	Use it in _MIPS_SIM definition.
	* config/mips/mips.h (CRT_CALL_STATIC_FUNCTION): Likewise.

2003-10-20  Zack Weinberg  <zack@codesourcery.com>

	* config/i386/i386.c (print_reg): Abort if REGNO (x) is a
	virtual register, but only if file == asm_out_file.
	* config/i386/i386.h (HI_REGISTER_NAMES): Use "argp", not "",
	for ARG_POINTER_REGNUM.

2003-10-20  Zack Weinberg  <zack@codesourcery.com>

	* c-common.c (registered_builtin_types): New static.
	(c_common_type_for_mode): Consult registered_builtin_types.
	(c_register_builtin_type): Add type to registered_builtin_types.
	* optabs.c (init_floating_libfuncs): Initialize libfuncs for
	all MODE_FLOAT modes, not just the ones corresponding to
	float_type_node, double_type_node, and long_double_type_node.

2003-10-20  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.h (PREDICATE_CODES): Add normal_memory_operand.
	* config/alpha/alpha-protos.h: Remove PREDICATE_CODES prototypes.

2003-10-20  Dorit Naishlos  <dorit@il.ibm.com>

	* config/rs6000/rs6000.h: (rs6000_sched_insert_nops):
	support new flag -minsert-sched-nops.
	(DEFAULT_SCHED_FINISH_NOP_INSERTION_SCHEME): Define.
	* config/rs6000/rs6000.c: (rs6000_sched_insert_nops):
	support new flag -minsert-sched-nops.
	(is_cracked_insn, is_microcoded_insn): New functions.
	(rs6000_sched_finish): New function.
	(rs6000_issue_rate): Return 5 for power4.
	(get_next_active_insn, insn_terminates_group_p): New
	functions.
	(is_costly_group, force_new_group): New functions.
	(redefine_groups, pad_groups): New functions.
	(rs6000_variable_issue): Use new functions.
	* doc/invoke.texi (-minsert-sched-nops): Document new
	option.

2003-10-20  David S. Miller  <davem@redhat.com>

	* config/sparc/sparc.md (type attribute): Add new insn types
	fpa, fpm_pack, fgm_mul, fgm_pdist, and fgm_cmp for VIS.
	(patterns emitting VIS insns): Use them.
	* config/sparc/ultra1_2.md: Add VIS scheduling rules.
	* config/sparc/ultra3.md: Likewise.

2003-10-20  Falk Hueffner  <falk@debian.org>

	PR target/12654
	* config/alpha/alpha.c (alpha_emit_conditional_branch): Don't do
	comparison against constant by adjusting the argument except for
	EQ and NE.

2003-10-19  Mark Mitchell  <mark@codesourcery.com>

	* config.gcc: Add support for arm926ejs, arm1026ejs, arm1136js,
	arm1136jfs, and armv6j.
	* config/arm/arm.c (FL_ARCH6J): New macro.
	(FL_VFPV2): Likewise.
	(all_cores): Add entries for arm926ejs, arm1026ejs, arm1136js,
	and arm1136jfs.
	(all_architectures): Add entry for armv6j.
	(arm_override_options): Add entries for arm926ejs, arm1026ejs,
	arm1136js, and arm1136jfs.
	* config/arm/arm.h (TARGET_CPU_arm926ej_s): New macro.
	(TARGET_CPU_arm1026ej_s): Likewise.
	(TARGET_CPU_arm1136j_s): Likewise.
	(TARGET_CPU_arm1136jf_s): Likewise.
	* doc/invoke.texi: Document new ARM cores and architecture
	variants.

2003-10-19  Zdenek Dvorak  <rakdver@atrey.karlin.mff.cuni.cz>

	* Makefile.in (toplev.o): Add value-prof.h dependency.
	(value-prof.o): Add REGS_H dependency.
	* common.opt (fprofile-values, fvpt): New.
	* flags.h (flag_value_profile_transformations): Declare.
	* opts.c (common_handle_option): Handle -fprofile_values and
	-fvpt.
	* profile.c (branch_prob): Don't remove death notes here.
	* timevar.def (TV_VPT): New.
	* value-prof.c: Include regs.h.
	(insn_divmod_values_to_profile, gen_divmod_fixed_value, gen_mod_pow2,
	gen_mod_subtract, divmod_fixed_value_transform,mod_pow2_value_transform,
	mod_subtract_transform, value_profile_transformations): New.
	(insn_values_to_profile): Call insn_divmod_values_to_profile.
	(find_values_to_profile): Add dumps.
	* value-prof.h (value_profile_transformations): Declare.
	* toplev.c: Include value-prof.h.
	(rest_of_handle_value_profile_transformations): New.
	(enum dump_file_index): Add DFI_vpt.
	(dump_file): Add vpt dump.
	(flag_value_profile_transformations): New.
	(lang_independent_options): Add flag_profile_values and
	flag_value_profile_transformations.
	(rest_of_compilation): Call
	rest_of_handle_value_profile_transformations.
	(process_options): Let -fvpt imply -fprofile-values.
	* doc/invoke.texi (-fvpt): Document.

2003-10-19  Jan Hubicka  <jh@suse.cz>

	* i386.c (print_reg): Do not abort on certain registers.

	PR optimization/12612
	* reg-stack.c (subst_stack_regs_pat):  Use st(1) for clobbers.
	* i386.md (fpatan, fyl2x, fscale patterns and expanders): Use
	match_scratch; avoid bogus paralles.

	PR target/12674
	* i386.c (ix86_function_regparm): Disable implicit register passing
	conventions when profiling.

2003-10-19  Eric Botcazou  <ebotcazou@libertysurf.fr>
	    Richard Henderson  <rth@redhat.com>

	PR optimization/8178
	* config/i386/i386.md (*movsi_zero): Delete.
	(*ffs_no_cmove): Use ix86_expand_clear to zero the third operand.

2003-10-19  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.c (fix_operator): New.
	(divmod_operator): Tidy.
	(alpha_emit_xfloating_cvt): Handle UNSIGNED_FIX.
	* config/alpha/alpha.h (FIXUNS_TRUNC_LIKE_FIX_TRUNC): Remove.
	(PREDICATE_CODES): Update.
	* config/alpha/alpha.md (fix_truncdfsi_ieee): Use match_operator.
	(fix_truncdfsi_internal, fix_truncdfdi_ieee): Likewise.
	(fix_truncsfsi_ieee, fix_truncsfsi_internal): Likewise.
	(fix_truncsfdi_ieee): Likewise.
	(fix_truncdfdi2, fix_truncsfdi2): Turn into define_expand.
	(fixuns_truncdfdi2, fixuns_truncsfdi2, fixuns_trunctfdi2): New.
	* config/alpha/alpha-protos.h: Update.

2003-10-19  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.h (INITIALIZE_TRAMPOLINE): Simplify.
	* config/mips/mips.c (mips_load_got): Assume Pmode == ptr_mode.
	* config/mips/mips.md (extendsidi2, *extendsidi2): Merge. Don't accept
	constant operands.

2003-10-18  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/extend.texi: Fix typos.
	* doc/invoke.texi: Likewise.

2003-10-18  Nicolas Pitre <nico@cam.org>

	* config/arm/arm.c (arm_override_options): Use arm_tune_xscale for
	XScale optimizations not arm_arch_xscale.
	* config/arm/arm.h (CONSTANT_ALIGNMENT_FACTOR, MOVE_RATIO): Likewise.

2003-10-18  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390-protos.h (shift_count_operand): Add prototype.
	* config/s390/s390.c (shift_count_operand): New function.
	(s390_extra_constraint): Use it to implement 'Y' constraint.
	(print_shift_count_operand): New function.
	(print_operand): Use it to implement '%Y'.
	* config/s390/s390.h (EXTRA_ADDRESS_CONSTRAINT): Add 'Y' constraint.
	(PREDICATE_CODES): Add shift_count_operand.
	* config/s390/s390.md ("rotldi3"): Merge alternatives,
	using "shift_count_operand" predicate and "Y" constraint,
	and "%Y" to output the combined shift count.
	("rotlsi3"): Likewise.
	("ashldi3", "*ashldi3_31", "*ashldi3_64"): Likewise.
	("ashrdi3", "*ashrdi3_31", "*ashrdi3_64", "*ashrdi3_cc_31",
	"*ashrdi3_cc_64", "*ashrdi3_cconly_31", "*ashrdi3_cconly_64"): Likewise.
	("ashlsi3", "ashrsi3", "*ashrsi3_cc", "*ashrsi3_cconly"): Likewise.
	("lshrdi3", "*lshrdi3_31", "*lshrdi3_64"): Likewise.
	("lshrsi3"): Likewise.

2003-10-18  Gunther Nikl  <gni@gecko.de>

	* config/m68k/m68k.c (m68k_output_function_epilogue): Add missing
	argument to asm_fprintf statement.

2003-10-18  Fariborz Jahanian  <fjahanian@apple.com>

	* rs6000.md: Separate TARGET_POWERPC64 patterns for TARGET_64BIT or TARGET_32BIT.
	(ashrdisi3_noppc64) Generate more efficient code for 32-bit right-shift of
	a "long long" argument.

2003-10-18  Alexandre Oliva  <aoliva@redhat.com>

	* final.c (final_scan_insn): Run FINAL_PRESCAN_INSNS on asm insns
	as well.

2003-10-18  Richard Sandiford  <rsandifo@redhat.com>

	* rtl.h (rtl_size): Declare.
	(rtunion): Remove rtwint.
	(rtx_def): Replace 'fld' with a union of an rtunion or a HOST_WIDE_INT.
	(RTX_HDR_SIZE, RTX_SIZE): New macros.
	(RTL_CHECK1): Adjust for new rtx_def layout.
	(RTL_CHECK2, RTL_CHECKC1, RTL_CHECKC2): Likewise.
	(XWINT, XCWINT): Likewise.  Access the rtx structure directly.
	(X0WINT): Remove.
	(X0ANY): New macro.
	* rtl.def: Adjust comments for new rtx_def layout.
	* ggc.h (ggc_alloc_rtx): Take the rtx code as argument, not the
	number of slots.
	* rtl.c (rtx_size): New array.
	(rtx_alloc): Adjust call to ggc_alloc_rtx.  Use RTX_HDR_SIZE.
	(copy_rtx): Use RTX_HDR_SIZE.  Adjust for new rtx_def layout.
	(shallow_copy_rtx): Adjust call to ggc_alloc_rtx.  Use RTX_SIZE.
	* integrate.c (copy_rtx_and_substitute): Use X0ANY to copy '0' fields.
	* emit-rtl.c (copy_most_rtx): Likewise.
	(copy_rtx_if_shared): Use RTX_SIZE.
	(copy_insn_1): Use RTX_HDR_SIZE.  Adjust for new rtx_def layout.
	* gengenrtl.c (gendef): Adjust ggc_alloc_rtx call.  Use RTX_HDR_SIZE.
	* gengtype.c (write_rtx_next): Use RTX_HDR_SIZE.
	(adjust_field_rtx_def): Expect "rtx_def" to be a union rather than
	an array.  Adjust output for new rtx_def layout.
	* ggc-page.c (RTL_SIZE): Use RTX_HDR_SIZE.
	* reload1.c (eliminate_regs): Use RTX_SIZE.
	* rtlanal.c (loc_mentioned_in_p): Adjust for new rtx_def layout.
	* gdbinit.in (pi): Likewise.

2003-10-18  Jan Hubicka  <jh@suse.cz>

	* integrate.c (copy_decl_for_inlining): Revert previous patch.

2003-10-18  Jan Hubicka  <jh@suse.cz>

	* integrate.c (copy_decl_for_inlining): Fix copying of copies.

2003-10-18  Roger Sayle  <roger@eyesopen.com>

	* libgcc.texi: Group multi-word types, such as "long double" and
	"unsigned int", using braces in @deftypefn and @deftypefnx nodes.
	Document __unord?f2 as returning a non-zero value, not just one.

2003-10-18  Hans-Peter Nilsson  <hp@bitrange.com>

	* config/mmix/t-mmix (CRTSTUFF_T_CFLAGS): Define.
	($(T)crti.o, $(T)crtn.o): Pass CRTSTUFF_T_CFLAGS here too.

2003-10-18  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* config/i386/k6.md (k6_alux): Use the 'mode' attribute instead of
	match_operand.

2003-10-18  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* config/sparc/sparc.c (function_arg_record_value_1): New fourth
	parameter packed_p.  Search for a DECL_PACKED field only if
	packed_p is false.  Pass packed_p recursively.
	(function_arg_record_value_2): Likewise.
	(function_arg_record_value): Update calls to
	function_arg_record_value_1 and function_arg_record_value_2.

2003-10-18  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* cse.c (cse_insn) [src_folded]: Check that the tentative replacement
	was successfully forced to memory before using the result.

2003-10-18  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/8178
	* config/i386/i386.md (*movsi_zero): New insn to set
	a register to zero on TARGET_USE_MOV0 targets.

2003-10-18  Kelley Cook  <kcook@gcc.gnu.org>

	* Makefile.in (Makefile): Depend on the all Make-lang.in fragments.
	(POSTSTAGE1_FLAGS_TO_PASS): Pass down MAKEINFO and MAKEINFOFLAGS.

2003-10-17  David Edelsohn  <edelsohn@gnu.org>

	* doc/invoke.texi (gcse-las): Fix typo.

2003-10-17  Andrew Pinski  <pinskia@physics.uc.edu>

	* doc/install.texi: Remove first part of the sentence for
	zsh not working.  Change gcc to GCC.

	PR bootstrap/12546
	* doc/install.texi: Document that zsh does not work when
	configuring gcc.

2003-10-17  Nathanael Nerode  <neroden@gcc.gnu.org>

	* config/ptx4.h: Switch to DWARF 2; update comments.

2003-10-17  Segher Boessenkool  <boessen@de.ibm.com>
	    Hartmut Penner  <hpenner@de.ibm.com>

	PR 10404, partial 11591, partial 11601
	* config/rs6000/altivec.md ("altivec_dst", "altivec_dstt",
	"altivec_dstst", "altivec_dststt", "altivec_lvsl", "altivec_lvsr",
	"altivec_lvebx", "altivec_lvehx", "altivec_lvewx", "altivec_lvxl",
	"altivec_lvx", "altivec_stvx", "altivec_stvxl", "altivec_stvebx",
	"altivec_stvehx", "altivec_stvewx"): Use a memory_operand.
	* config/rs6000/rs6000.c (altivec_expand_lv_builtin): New function.
	(altivec_expand_stv_builtin): Adjust for the memory_operand.
	(altivec_expand_builtin): Call altivec_expand_lv_builtin.
	(altivec_init_builtins): Use `long int' for memory offsets.

2003-10-17  Jan Hubicka  <jh@suse.cz>

	* opts.c  (common_handle_option): Handle OPT_fweb
	* invoke.texi (-fweb): Add missing parts of documentation.

2003-10-17  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config/mips/linux.h (FUNCTION_NAME_ALREADY_DECLARED): Undef
	before redefinition.

2003-10-17  Mostafa Hagog  <mustafa@il.ibm.com>

	* common.opt: Add description of the new -fgcse-las flag.
	* flags.h (flag_gcse_las): Declaration of global flag_gcse_las.
	* gcse.c (hash_scan_set): Handle the case of store expression and
	insert the memory expression to the hash table, this way we make it
	possible to discover redundant loads after stores and remove them.
	(pre_insert_copy_insn): moved the call to update_ld_motion_stores,
	to pre_insert_copies, it is not the correct place to call it after
	adding stores to be in the available expression hash table.
	(pre_insert_copies): Added the call to update_ld_motion_stores when
	one or more copies were inserted.
	* opts.c (common_handle_option): Handle the -fgcse-las flag.
	* toplev.c (flag_gcse_las): Initialization of flag_gcse_las.

	* doc/invoke.tex: Document new -fgcse-las flag.

2003-10-18  Alan Modra  <amodra@bigpond.net.au>

	* config/rs6000/crtsavres.asm: Correct alignment of powerpc64 code
	for posterity, then remove it.

2003-10-17  Richard Earnshaw <rearnsha@arm.com>
	    Nathan Sidwell  <nathan@codesourcery.com>

	* config/arm/arm.c (use_return_insn): Not a single instruction, if
	there's a frame pointer.
	(arm_output_epilogue): Protect stack pointer from being corrupted
	on interrupt.

2003-10-17  Ulrich Weigand  <uweigand@de.ibm.com>

	* ifcvt.c (noce_try_addcc): Handle ifs with 'else' case.

2003-10-17  Ulrich Weigand  <uweigand@de.ibm.com>

	* combine.c (simplify_set): Do not clear out undobuf.other_insn
	already set elsewhere.

2003-10-17  Kelley Cook  <kcook@gcc.gnu.org>

	* config/i386/i386.c (ix86_expand_prologue):  Use
	gen_allocate_stack_worker.

2003-10-17  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config.gcc (mips-sgi-irix6*o32): Only enable use_collect2
	without gas.
	(mips-sgi-irix6*): Likewise.

	* config/mips/iris6gas.h: New file.
	* gcc/config.gcc (mips-sgi-irix6*): Use it.

	* config/mips/mips.h (TARGET_IRIX): Provide default.
	(TARGET_IRIX5): Likewise.
	(TARGET_SGI_O32_AS): Likewise.
	* config/mips/iris5.h (TARGET_IRIX): Redefine as 1.
	(TARGET_IRIX5): Likewise.
	* config/mips/iris6.h (TARGET_IRIX6): Remove.
	(TARGET_IRIX5): Redefine as 0.

	* config/mips/mips.c (mips_output_external): Test for IRIX 6 O32
	linker workaround with TARGET_IRIX and mips_abi instead of
	ASM_OUTPUT_UNDEF_FUNCTION.
	(mips_file_end): Inline old ASM_OUTPUT_UNDEF_FUNCTION definition,
	testing TARGET_IRIX and mips_abi explicitly.
	* config/mips/iris5.h (ASM_OUTPUT_UNDEF_FUNCTION): Remove.
	* config/mips/iris6.h (ASM_OUTPUT_UNDEF_FUNCTION): Remove undef.

	* config/mips/mips.c (irix_output_external_libcall): Renamed from
	mips_output_external_libcall.
	Use new TARGET_IRIX in guard.
	* config/mips/mips-protos.h (irix_output_external_libcall): Match
	this.
	* config/mips/iris5.h (TARGET_ASM_EXTERNAL_LIBCALL): Likewise.

	* config/mips/iris5gas.h (HAVE_GAS_SHF_MERGE): Update comment.
	Define as 0.

	* config/mips/iris6.h (FUNCTION_NAME_ALREADY_DECLARED): Define
	depending on mips_abi.
	* config/mips/linux.h (FUNCTION_NAME_ALREADY_DECLARED): Define as 1.
	* config/mips/mips.c (mips_output_function_prologue): Test
	FUNCTION_NAME_ALREADY_DECLARED at runtime.
	(mips_output_function_epilogue): Likewise.
	(build_mips16_function_stub): Likewise.
	(build_mips16_call_stub): Likewise.
	* config/mips/mips.h (FUNCTION_NAME_ALREADY_DECLARED): Provide
	default.

	* config/mips/iris6.h (DWARF2_UNWIND_INFO): Don't define for native
	IRIX 6 O32 assembler.
	(SUBTARGET_CC1_SPEC): Enforce mips2 ISA with O32 ABI.
	(TARGET_OS_CPP_BUILTINS): Define _ABIO32, use it to define
	_MIPS_SIM for O32 ABI.
	(DWARF2_FRAME_INFO): Don't define for native IRIX 6 O32 assembler.
	(ASM_DECLARE_FUNCTION_NAME): Integrate mips.h version.
	(ASM_DECLARE_FUNCTION_SIZE): Move undef before redefinition.
	Integrate O32 version.
	(SUBTARGET_ASM_SPEC): Handle -mabi=32.
	(SUBTARGET_ASM_DEBUGGING_SPEC): Add mdebug_asm_spec for gas with
	O32 ABI.
	(BSS_SECTION_ASM_OP_32): Define.
	(BSS_SECTION_ASM_OP_64): Likewise.
	(BSS_SECTION_ASM_OP): Define differently for O32 and N32/N64 ABIs
	using them.
	(TARGET_ASM_NAMED_SECTION): Reflect renaming.
	Move up to allow override for O32 ABI without GNU as.
	(EH_FRAME_SECTION_NAME): Define explicitly.
	(MUST_USE_SJLJ_EXCEPTIONS): Define.
	[_MIPS_SIM == _ABIO32 && !GAS] (CTORS_SECTION_ASM_OP,
	DTORS_SECTION_ASM_OP): Dummy definitions.
	(TARGET_ASM_NAMED_SECTION): Undef statically.
	(EH_FRAME_SECTION_NAME): Likewise.
	(ASM_OUTPUT_FILENAME): Integrate mips.h version.
	(LINK_SPEC): Only use default options -call_shared -no_unresolved
	without -r.
	Don't pass -init, -fini with -mabi=32.
	(COLLECT_PARSE_FLAG): Define.

	* config/mips/mips.c (iris6_asm_named_section_1): Changed guard to
	TARGET_IRIX.
	Renamed to use irix_ prefix.
	(iris6_asm_named_section): Likewise.
	(iris_section_align_entry_eq): Likewise.
	(iris_section_align_entry_hash): Likewise.
	(iris6_file_start): Likewise.
	(iris6_section_align_1): Likewise.
	(iris6_file_end): Likewise.
	(iris6_section_type_flags): Likewise.
	(iris_section_align_htab): Likewise.
	(iris_orig_asm_out_file): Likewise.
	[TARGET_IRIX] (TARGET_ASM_FILE_START): Reflect rename.
	(TARGET_ASM_FILE_END): Likewise.
	(TARGET_SECTION_TYPE_FLAGS): Likewise.

	* config/mips/mips.c [TARGET_IRIX5 && !TARGET_IRIX6]
	(TARGET_ASM_UNALIGNED_HI_OP): Use runtime initialization in
	override_options instead.
	(TARGET_ASM_UNALIGNED_SI_OP): Likewise.
	(TARGET_ASM_UNALIGNED_DI_OP): Likewise.
	* config/mips/mips.c (override_options) [USE_COLLECT2]: Restore
	flag_gnu_linker to defaults without USE_COLLECT2 for non-IRIX O32
	assemblers.
	Likewise for constructor/destructor handling.
	(override_options): Handle IRIX O32 assembler quirks.
	[TARGET_IRIX] (irix_asm_named_section): Handle O32 ABI with and
	without gas.
	(mips_file_start): Use new TARGET_IRIX.
	(mips_declare_object_name): No special processing for IRIX O32
	assembler.
	(mips_finish_declare_object): Likewise.
	(irix_asm_output_align): Renamed from iris6_asm_output_align.
	Don't record alignment for O32 ABI.
	(irix_file_start): Renamed from iris6_file_start.
	Return early for O32 ABI.
	(irix_file_end): Renamed from iris6_file_end.
	Don't emit .section directives for O32 ABI.
	* config/mips/iris6.h (ASM_OUTPUT_ALIGN): Reflect renaming.
	* config/mips/mips-protos.h (irix_asm_output_align): Likewise.

	* config/mips/t-iris6 (MULTILIB_OPTIONS): Add mabi=32.
	(MULTILIB_OSDIRNAMES): Likewise.

2003-10-17  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* collect2.c (COLLECT_PARSE_FLAG): Provide default.
	(main): Use it.
	* doc/tm.texi (COLLECT_PARSE_FLAG): Document it.

2003-10-17  Richard Earnshaw  <rearnsha@arm.com>

	* arm-modes.def (CC_Nmode): New condition code mode.
	* arm.c (thumb_condition_code): Delete.
	(arm_select_cc_mode): Handle single-bit test for Thumb.
	(arm_print_operand, cases 'd' and 'D'): Don't special case the
	condition code logic for Thumb.
	(get_arm_condition_code): Handle CC_Nmode.
	(thumb_cbrch_target_operand): New function.
	* arm.h (PREDICATE_CODES): Add thumb_cbrch_target_operand.
	* arm-protos.h (thumb_cbrch_target_operand): Add prototype.
	* arm.md: Add Thumb split patterns for zero_extract and
	sign_extract.
	(tbit_cbranch, andsi3_cbranch_scratch, andsi3_cbranch)
	(orrsi3_cbranch_scratch, orrsi3_cbranch, xorsi3_cbranch_scratch)
	(xorsi3_cbranch, addsi3_cbranch, addsi3_cbranch_scratch)
	(subsi3_cbranch, subsi3_cbranch_scratch): New Thumb patterns.
	(cbranchne_decr1): Re-work to use CC_Nmode.

	* arm.c (thumb_expand_epilogue): Add clobbers of registers restored
	by the return instruction.  Add a use of the link register if it
	wasn't stored.

2003-10-17  Richard Earnshaw  <rearnsha@arm.com>

	* flow.c (init_propagate_block_info): Don't abort if a conditional
	jump is not a comparison of a register.  Instead, just don't record
	conditional life information.

2003-10-16  Jan Hubicka  <jh@suse.cz>

	PR optimization/12630
	* pa.md (movstrsi, movstrsi_internal): Use match_scratch in clobbers
	for operands 7 and 8.

2003-10-16  Kelley Cook  <kcook@gcc.gnu.org>

	* objc/Make-lang.in (objc-parse.o): Honor $(parsedir) for objc-parse.c.

2003-10-16  Danny Smith  <dannysmith@users.sourceforge.net>

	* config/i386/cygming.h (ASM_OUTPUT_DEF_FROM_DECLS): Define.

	* config/i386/winnt.c (gen_stdcall_suffix): Make static
	(gen_fastcall_suffix): Likewise.
	(i386_pe_dllexport_p): Likewise.
	(i386_pe_dllimport_p): Likewise.
	(i386_pe_mark_dllexport): Likewise.
	(i386_pe_mark_dllimport): Likewise.
	(i386_pe_asm_named_section): Fix formatting.

2003-10-16  Zack Weinberg  <zack@codesourcery.com>

	* configure.in: Add snprintf to gcc_AC_CHECK_DECLS list.
	* system.h: Declare snprintf if necessary.
	* configure, config.in: Regenerate.

2003-10-15  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.c (rs6000_va_arg): Only align vector
	arguments if TARGET_ALTIVEC_ABI.

2003-10-15  Roger Sayle  <roger@eyesopen.com>

	* builtins.c (fold_builtin_memcpy, fold_builtin_mempcpy,
	fold_builtin_memmove, fold_builtin_strcpy, fold_builtin_strncpy,
	fold_builtin_memcmp, fold_builtin_strcmp, fold_builtin_strncmp):
	New functions.
	(expand_builtin_memcpy): Use integer_zerop instead of testing
	host_integerp and tree_low_cst directly.  Move misapplied hunk
	for optimization wher SRC and DEST point to the same location.
	(expand_builtin_mempcpy): From here.
	(expand_builtin_memmove): Use integer_zerop instead of testing
	host_integerp and tree_low_cst_directly.
	(expand_builtin_memset): Likewise.
	(expand_builtin_memcmp): Likewise (and for integer_onep).
	(expand_builtin_strncmp): Likewise.
	(fold_builtin): Call the appropriate fold_builtin_foo functions
	to optimize memcpy, mempcpy, memmove, strcpy, strncpy, memcmp,
	strcmp and strncmp.

2003-10-15  Geoffrey Keating  <geoffk@apple.com>

	* config/darwin-protos.h (machopic_non_lazy_ptr_name): Delete
	prototype.  Clean up some whitespace.
	* config/darwin.c: Use gen_rtx_FOO (...) rather than
	gen_rtx (FOO, ...).
	(machopic_non_lazy_ptr_name): Make static.
	(name_needs_quotes): Allow '.' and '$' unquoted.
	(machopic_legitimize_pic_address): Improve codegen in dynamic-no-pic
	case.

2003-10-15  Gábor Lóki  <alga@rgai.hu>

	* fold-const.c (tree_swap_operands_p): Disable some features
	when optimizing for size.

2003-10-15  David Daney  <ddaney@avtrex.com>

	* config/mips/linux.h (MD_FALLBACK_FRAME_STATE_FOR): New
	* config/mips/mips.h (DWARF_FRAME_REGNUM): Fixed to allow unwind
	from leaf functions.
	(DWARF_FRAME_RETURN_COLUMN): Ditto.
	(SIGNAL_UNWIND_RETURN_COLUMN): New, used
	by MD_FALLBACK_FRAME_STATE_FOR.
	* testsuite/gcc.dg/cleanup-9.c: Added mips*-*-linux* target.

2003-10-15  Zack Weinberg  <zack@codesourcery.com>

	* genmodes.c: Include hashtab.h.
	(modes_by_name, hash_mode, eq_mode, struct mode_adjust)
	(adj_bytesize, adj_alignment, adj_format, new_adjust)
	(_ADD_ADJUST, ADJUST_BYTESIZE, ADJUST_ALIGNMENT, ADJUST_FORMAT)
	(print_maybe_const_decl, emit_mode_adjustments): New.
	(known_modes): Rename to modes.
	(find_mode): Kill class argument; look up in hash table.
	(new_mode): Insert into hash table also.
	(new_adjust): New.
	(reset_float_format, make_partial_integer_mode)
	(make_vector_mode): Tweak error reporting.
	(reset_float_format): Correct type of fourth argument.
	(emit_insn_modes_h): Add #defines to help make mode_size,
	mode_base_align, and real_format_for_mode conditionally const.
	(emit_mode_size, emit_mode_base_align): Use print_maybe_const_decl.
	(emit_real_format_for_mode): Likewise, but temporarily disabled.
	(emit_insn_modes_c): Call emit_mode_adjustments.
	(main): Initialize modes_by_name.
	* Makefile.in: Update dependencies.
	* machmode.def: Document EXPR arguments and new ADJUST_* statements.
	* machmode.h: Use CONST_MODE_SIZE and CONST_MODE_BASE_ALIGN in
	declarations of mode_size and mode_base_align.  Declare
	init_adjust_machine_modes.
	* toplev.c (backend_init): Call init_adjust_machine_modes.

2003-10-15  Olivier Hainque  <hainque@act-europe.fr>

	* genmodes.c (calc_wider_mode): Allocate enough room for all the
	entries we'll possibly assign in the sort buffer.

2003-10-15  Ulrich Weigand  <uweigand@de.ibm.com>

	* config.gcc (s390x-ibm-tpf*): New target.
	* doc/install.texi: Document it.
	* config/s390/t-tpf: New file.
	* config/s390/tpf.h: New file.

2003-10-15  Hans-Peter Nilsson  <hp@axis.com>

	PR target/12598
	* config/cris/cris.md (define_split "*mov_sidesi_biap_mem"+1)
	(define_splits "*mov_sidesi_mem"+1, "casesi"+9, +10, +11, +12):
	Use cris_mem_op and replace_equiv_address, not gen_rtx_MEM.
	("call", "call_value", define_split "*mov_sidesi_mem"+19, +20)
	(define_split "*mov_sidesi_mem"+21, +22, +23, +24, +25, +26, +27)
	(define_split "*mov_sidesi_mem"+28, +29, +30): Use
	replace_equiv_address, not gen_rtx_MEM.
	* config/cris/cris.c (cris_mem_op): New match_operator function.
	(cris_notice_update_cc): Use replace_equiv_address, not
	gen_rtx_MEM.
	* config/cris/cris.h (PREDICATE_CODES): Add cris_mem_op.

2003-10-15  Bernardo Innocenti <bernie@develer.com>

	* config/m68k/m68k.h (MASK_SEP_DATA, TARGET_SEP_DATA,
	MASK_ID_SHARED_LIBRARY, TARGET_ID_SHARED_LIBRARY): Move
	definitions after the other flags.

2003-10-14  Ziemowit Laski  <zlaski@apple.com>

	* c-parse.in (methoddef, methodproto): Call objc_add_method()
	instead of add_method().
	* objc/objc-act.c (objc_check_decl): Do not check for
	constant_string_type.
	(add_method): Rename to objc_add_method().
	(really_start_method): Call objc_add_method() instead of
	add_method().
	* objc/objc-act.h (add_method): Rename to objc_add_method().

2003-10-14  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390-protos.h (s390_alc_comparison): Add prototype.
	(s390_slb_comparison): Likewise.
	* config/s390/s390.c (s390_alc_comparison, s390_slb_comparison):
	New functions.
	* config/s390/s390.h (PREDICATE_CODES): Add s390_alc_comparison
	and s390_slb_comparison.
	* config/s390/s390.md ("*adddi3_31", "*subdi3_31"): Do not use on
	zSeries machines.
	("*adddi3_31z", "*subdi3_31z"): New insns.
	("*adddi3_alc_cc", "*adddi3_alc", "*subdi3_slb_cc", "*subdi3_slb",
	"*addsi3_alc_cc", "*addsi3_alc", "*subsi3_slb_cc", "*subsi3_slb"):
	New insns.

2003-10-14  Nathanael Nerode  <neroden@gcc.gnu.org>

	* configure.in: Clean up some feedback echoes.
	* configure: Regenerate.

	* aclocal.m4: Properly quote names of macros being defined.

	* config.gcc (am33_2.0-*-linux*): Use t-slibgcc-elf-ver.

2003-10-14  Steve Ellcey  <sje@cup.hp.com>

	* config/ia64/ia64.c (ia64_expand_call): Force function address
	to DImode.
	* config/ia64/ia64.md (call_gp): Put DImode on operand 0.

2003-10-14  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.md ("muldf3", "*muldf3", "*muldf3_ibm",
	"mulsf3", "*mulsf3", "*mulsf3_ibm"): Do not clobber CC.
	("divdf3", "*divdf3", "*divdf3_ibm", "divsf3", "*divsf3",
	"*divsf3_ibm"): Likewise.

2003-10-14  Nathanael Nerode  <neroden@gcc.gnu.org>

	* config.gcc, config/m68hc11/t-m68hc11-gas: Replace uses of
	target_alias with target_noncanonical.

2003-10-14  Geoffrey Keating  <geoffk@apple.com>

	* expr.c (block_move_libcall_safe_for_call_parm): Clean up,
	and add case for machines where outgoing register parameters
	get stack space.

	* config/darwin.c (machopic_indirect_data_reference): Use a scratch
	register when generating indirect address.

2003-10-14  Richard Earnshaw  <rearnsha@arm.com>

	* arm.c (arm_addimm_operand): MODE arguemnt is unused.
	* arm.md (cbranchne_decr1): Fix bootstrap warning.

2003-10-14  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* fixinc/inclhack.def (alpha_pthread_gcc): New fix.
	* fixinc/fixincl.x: Regenerate.
	* fixinc/tests/base/pthread.h [ALPHA_PTHREAD_GCC_CHECK]: New
	testcase.
	Fixes PR bootstrap/9330.

2003-10-13  Eric Christopher  <echristo@redhat.com>

	* config/frv/frv.c (frv_adjust_field_align): Redo check for
	too wide bitfields.
	(frv_hard_regno_mode_ok): Add SPR_P and AP_FIRST.
	* config/frv/frv.h (FUNCTION_PROFILER): Remove abort call.
	(SBSS_SECTION_ASM_OP): Remove.
	(EXTRA_SECTIONS): Remove in_sbss.
	(EXTRA_SECTION_FUNCTIONS): Remove SBSS_SECTION_FUNCTION.
	(SBSS_SECTION_FUNCTION, sbss_section): Remove.
	(ASM_OUTPUT_ALIGNED_DECL_LOCAL): Change sbss_section to
	named_section.

2003-10-13  Nathanael Nerode  <neroden@gcc.gnu.org>

	* Makefile.in, configure.in, config.host, mkheaders.in: Replace
	uses of ${target_alias} for directory names (and other places which
	won't like the empty string) with ${target_noncanonical}.  Introduce
	call early in configure.in to _GCC_TOPLEV_NONCANONICAL_TARGET so it's
	available.
	* configure: Regenerate.

2003-10-13  Ian Lance Taylor  <ian@wasabisystems.com>

	* config/arm/iwmmxt.md (cond_iwmmxt_movsi_insn): New pattern.
	* config/arm/arm.md: For splits which rely on conditional moves,
	remove ! TARGET_IWMMXT condition.

2003-10-13  David S. Miller  <davem@redhat.com>

	* ifcvt.c (num_removed_blocks): Rename to num_true_changes.
	(find_cond_trap): Always increment if we emit a conditional
	trap insn.

2003-10-13  Zack Weinberg  <zack@codesourcery.com>

	* Makefile.in (BUILD_RTL): Replace $(BUILD_PREFIX)insn-modes.o
	with min-insn-modes.o.
	(STAGESTUFF): Add min-insn-modes.c.
	(genobjs): Add genmodes.o.
	(print-rtl.o, print-rtl1.o): Depend on $(TM_P_H).
	(insn-modes.o): Depend on $(TM_H) not $(GTM_H); also real.h.
	(min-insn-modes.c, min-insn-modes.o): New rules.
	(s-modes): Also generate min-insn-modes.c.
	($(BUILD_PREFIX_1)insn-modes.o): Kill.
	* genmodes.c (struct mode_data): Add format field.
	(blank_mode, validate_mode, complete_mode): Update to match.
	(make_scalar_mode): Separate into make_int_mode and make_float_mode.
	(_SCALAR_MODE): Kill.
	(FLOAT_MODE, FRACTIONAL_FLOAT_MODE): Add format argument.
	(emit_insn_modes_c_header): Adjust.
	(emit_min_insn_modes_c_header, emit_real_format_for_mode)
	(emit_min_insn_modes_c): New functions.
	(emit_insn_modes_c): Call emit_real_format_for_mode.
	(main): Add -m option to generate min-insn-modes.c.
	* machmode.h: Update documentation.  Add format argument to
	all uses of FLOAT_MODE.
	* real.c: Don't define real_format_for_mode here.

	* dwarfout.c: Move default definition of PRINT_REG...
	* defaults.h: ...here.
	* print-rtl.c: Include tm_p.h.
	(DEBUG_PRINT_REG, DEBUG_REGISTER_NAMES, debug_reg_names, reg_names):
	Kill.
	(print_rtx): Use PRINT_REG, not DEBUG_PRINT_REG.  But surround
	this entire block with #ifndef GENERATOR_FILE.
	* regclass.c: Unconditionally define reg_names.
	* config/mips/mips.h, config/rs6000/rs6000.h, config/sh/sh.h
	Don't define DEBUG_REGISTER_NAMES.
	* config/rs6000/darwin.h: Don't use DEBUG_REGISTER_NAMES in
	redefinition of REGISTER_NAMES.
	* config/i386/i386.h: Don't define DEBUG_PRINT_REG.

	* combine.c: Change all preprocessor conditionals on
	EXTRA_CC_MODES to use SELECT_CC_MODE instead; rearrange a bit
	for clarity.
	* genopinit.c: Remove mention of EXTRA_CC_MODES in comment.
	* configure.in: Don't define EXTRA_CC_MODES.
	* configure, config.in: Regenerate.
	* doc/tm.texi: Remove documentation of EXTRA_CC_MODES.

	* config/arc/arc.c, config/m32r/m32r.c, config/sparc/sparc.c:
	May assume that GET_MODE_CLASS is accurate for extra CC modes
	at all times.

	* config/i860/i860.h (INIT_CUMULATIVE_ARGS): Pass correct
	number of arguments to aggregate_value_p.

	* genmodes.c (RESET_FLOAT_FORMAT, reset_float_format): New.
	* machmode.def: Explain ARCH-modes.def.  Document
	RESET_FLOAT_FORMAT.  Improve commentary on various mode
	clusters.  Do not define OI, PQI, PHI, PSI, PDI, QF, HF, TQF,
	XF, or TF modes here.  Remove backward-compatibility
	definition of CC.

	* config/alpha/alpha-modes.def: New file; define TF mode.
	* config/arc/arm-modes.def: Define XF mode.
	* config/c4x/c4x-modes.def: Define QF and HF modes.  Unset
	float format for SF and DF modes.
	* config/dsp16xx/dsp16xx-modes.def: New file; define HF mode.
	* config/i386/i386-modes.def: Define XF and TF modes.
	* config/i960/i960-modes.def: Define TF mode.
	* config/ia64/ia64-modes.def: Define TF and OI modes.
	* config/m68k/m68k-modes.def: New file; define XF mode.
	* config/mips/mips-modes.def: New file; define TF mode, reset
	formats for SF and DF modes.
	* config/pa/pa-modes.def: Define TF mode.
	* config/rs6000/rs6000.c: Define TF and PSI modes.
	* config/s390/s390-modes.def: Define OI mode.
	* config/sh/sh-modes.def: New file; define PSI mode.
	* config/sparc/sparc-modes.def: Define TF mode.
	* config/vax/vax-modes.def: New file; reset formats for SF and
	DF modes.

	* config/c4x/c4x.c (c4x_override_options): No need to mess
	with real_format_for_mode or set REAL_MODE_FORMATs.
	(c4x_immed_int_constant): Don't apply GET_MODE_CLASS to rtx
	variable.
	* config/i386/i386.c (override_options): No need to set
	REAL_MODE_FORMATs here.
	* config/i960/i960.c (i960_initialize): Likewise.
	* config/m68k/m68k.c (m68k_override_options): Likewise.
	* config/ia64/ia64.c (ia64_override_options): Set REAL_MODE_FORMAT
	for TFmode only if not the default.
	* config/mips/mips.c (override_options): Likewise.
	* config/vax/vax.c (override_optionms): Set REAL_MODE_FORMAT for
	DFmode only if not the default.

	* config/i370/i370.h (RET_REG): Don't consider TFmode.
	* config/m68hc11/m68hc11.c (print_operand): Don't consider XFmode.
	* config/dsp16xx/dsp16xx.c (hard_regno_mode_ok): #if 0 out use
	of modes that don't appear anywhere in the machine description.

	* config/arc/arc-modes.def, config/arm/arm-modes.def
	* config/c4x/c4x-modes.def, config/frv/frv-modes.def
	* config/i386/i386-modes.def, config/i960/i960-modes.def
	* config/ia64/ia64-modes.def, config/mmix/mmix-modes.def
	* config/pa/pa-modes.def, config/pdp11/pdp11-modes.def
	* config/rs6000/rs6000-modes.def, config/s390/s390-modes.def
	* config/sparc/sparc-modes.def: Convert to new style for
	declaring extra CC modes.

2003-10-13  Zack Weinberg  <zack@codesourcery.com>

	* cpplex.c (_cpp_clean_line): In the common case of a line
	with no trigraphs and no \-newline, avoid writing to memory.
	(_cpp_skip_block_comment): Use a local 'cur' pointer instead
	of the buffer member.  Make c an uchar to avoid unnecessary
	sign extensions.

2003-10-13  Nathanael Nerode  <neroden@gcc.gnu.org>

	* configure.in: Remove unnecessary test.
	* configure: Regenerate.

	* configure.in: Fix grammatical error.  Move UWIN host error to...
	* config.host: Here.
	* configure: Regenerate.

2003-10-13  Andreas Krebbel  <krebbel1@de.ibm.com>

	* config/s390/s390.md ("*fmadddf4", "*fmsubdf4", "*fmaddsf4",
	"*fmsubsf4"): Insns are now dependent on TARGET_FUSED_MADD instead
	of flag_unsafe_math_optimizations.
	* config/s390/s390.h ("MASK_NO_FUSED_MADD", "TARGET_NO_FUSED_MADD",
	"TARGET_FUSED_MADD", "TARGET_SWITCHES"): Introduced new target flags
	fused-madd and no-fused-madd.
	* doc/invoke.texi: Documented the new options fused-madd and
	no-fused-madd for S/390.

2003-10-14  Alan Modra  <amodra@bigpond.net.au>

	* config/rs6000/linux64.h (SUBSUBTARGET_OVERRIDE_OPTIONS): Choose
	MASK_ALIGN_NATURAL if rs6000_alignment_string not given.  Don't
	assign DEFAULT_ABI.
	(ADJUST_FIELD_ALIGN, ROUND_TYPE_ALIGN): Update comment.
	* config/rs6000/rs6000.c: Formatting.
	(rs6000_parse_alignment_option): Only set rs6000_alignment_flags
	when rs6000_alignment_string given.

2003-10-13  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR target/12538
	* config/sparc/sparc.c (MUST_SAVE_REGISTER): Delete.
	(sparc_flat_must_save_register_p): New function to decide whether
	a register must be saved/restored in the function prologue/epilogue.
	(sparc_flat_compute_frame_size): Use it instead of MUST_SAVE_REGISTER.

2003-10-12  Steven Bosscher  <steven@gcc.gnu.org>

	* config/avr/avr.c, config/avr/avr-protos.h: Convert to
	ISO C90 function declarations and definitions.
	* config/sh/sh.c, config/sh/sh-protos.h: Likewise.

2003-10-12  Nathanael Nerode  <neroden@gcc.gnu.org>

	* config.gcc (*-*-freebsd*): Use tm_defines instead of tiny
	config files which do the same thing.
	* config/freebsd3.h, config/freebsd4.h, config/freebsd5.h,
	config/freebsd6.h: Remove now unnecessary files.

2003-10-12  Steven Bosscher  <steven@gcc.gnu.org>

	* c-common.c (c_common_truthvalue_conversion): Warn if the
	address of a non-weak function is used as a truth value.

2003-10-12  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (WORD_REG_USED): Use SP_REG instead of
	a literal.
	* config/h8300/h8300.h (REGNO_OK_FOR_BASE_P): Use MAC_REG
	instead of a literal.

2003-10-12  Hans-Peter Nilsson  <hp@bitrange.com>

	* doc/extend.texi (Function Attributes): Mention the exceptional
	path for noreturn-marked functions.

2003-10-12  Jan Hubicka  <jh@suse.cz>

	* cgraphunit.c (cgraph_decide_inlining): Fix uninitialized variable
	warning.

2003-10-12  Danny Smith  <dannysmith@users.sourceforge.net>

	* config/i386/i386.c (x86_this_parameter): Fix typo.

203-10-11  Jan Hubicka  <jh@suse.cz>

	* Makefile.in (web.o): New.
	* web.c: New file.
	* rtl.h (web_main): Declare.
	* timervar.def (TV_WEB): New.
	* toplev.c (dump_file_index, dump_file_info): Add DFI_web.
	(rest_of_hanle_web): New.
	(flag_web): New static variable.
	(lang_independent_options): Add "web".
	(rest_of_compilation): Call rest_of_handle_web.
	* invoke.texi (-fweb): Document.
	* common.opt (fweb): New.
	* flags.h (flag_web): New.
	* opts.c (decode_options): Set flag_web at -O3.

	* passes.texi (web construction):  Document.
	* invoke.texi (-O3): Document that -fweb is enabled.

	* regrename.c (regrename_optimize): Deal better with situation when
	replacement failed.

	* sched-ebb.c: Include params.h and profile.h
	(schedule_ebbs):  Use tracer parameters to discover superblocks
	* Makefile.in (sched-ebb.o):  Add dependencies.

2003-10-11  Roger Sayle  <roger@eyesopen.com>

	* fold-const.c (negate_mathfn_p): New function to determine whether
	a built-in mathematical function is sign preserving, f(-x) == -f(x).
	Add support for BUILT_IN_ASIN, BUILT_IN_ASINF and BUILT_IN_ASINL.
	(tree_swap_operands_p): Change API to take an additional argument
	indicating that the swapped operands evaluate in reverse order.
	Canonicalize VAR_DECLs and PARM_DECLs last if we can, i.e. neither
	operand side-effects or we don't care about flag_evaluation_order.
	(reorder_operands_p): New function to check whether its safe to
	evaluate the given operands in reverse order.
	(negate_expr_p):  We can always negate integer constants unless
	we honor -ftrapv and the signed type would overflow.  Only allow
	-(A-B) into B-A if reorder_operands_p says that its OK.  Allow
	negation of COMPLEX_CST if both real and imaginary parts can be
	negated.  Allow negation through floating point extensions and
	sign-preserving built-in functions.
	(negate_expr):  Move the code to negate integers from "fold" to
	here.  Always negate integer constants unless we honor -ftrapv
	and the signed type would overflow.  Always negate real constants
	unless we honor -ftrapping-math.  Only convert -(A-B) into B-A
	if allowed by reorder_operands_p.  Add support for COMPLEX_CST.
	Optimize negation through floating point extensions and
	sign-preserving built-in functions (as defined by negate_mathfn_p).
	(fold): Adjust calls to tree_swap_operands_p.
	(fold <NEGATE_EXPR>): Move the remaining negation optimizations
	to negate_expr_p/negate_expr.
	(fold <MINUS_EXPR>): Use reorder_operands_p to check whether we're
	allowed to convert (-A) - B into (-B) - A.

2003-10-11  Roger Sayle  <roger@eyesopen.com>

	* builtins.c (expand_builtin_strcmp): Defend against the possibility
	that gen_cmpstrsi may fail: Stabilize the argument list against
	re-evaluation and expand the library call directly using this saved
	argument list if a cmpstrsi sequence can't be generated.
	(expand_builtin_strncmp): Likewise.

	* config/i386/i386.md (cmpstrsi, movstrsi): Disable with -Os.

2003-10-11  Roger Sayle  <roger@eyesopen.com>

	PR optimization/12260
	* simplify-rtx.c (simplify_unary_operation): Simplify all unary
	operations through CONST nodes.  Optimize (neg (plus X C)) as
	(minus -C X) for constant values C.
	(simplify_binary_operation): Optimize (minus (neg X) C) as
	(minus -C X) for constant values C.
	(simplify_plus_minus): Avoid creating (neg (const (plus X C)),
	instead create (minus -C X).

2003-10-11  Roger Sayle  <roger@eyesopen.com>

	* expr.c (expand_expr <PLUS_EXPR>): Let expand_operands call
	safe_from_p for us, once it chooses an evaluation order.
	(expand_expr <MULT_EXPR>): Likewise.
	(expand_expr <MIN_EXPR> <MAX_EXPR>): Likewise.  If expand_operands
	places the second operand in "target", swap the operands.
	(do_store_flag): Let expand_operands call safe_from_p for us.

2003-10-11  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/12544
	* function.c (put_var_into_stack): Don't generate ADDRESSOFs
	for DECL_NONLOCAL decls.

2003-10-11  Kazu Hirata  <kazu@cs.umass.edu>

	* expr.c: Follow spelling conventions.
	* final.c: Likewise.
	* optabs.c: Likewise.
	* sched-deps.c: Likewise.
	* sdbout.c: Likewise.

Sat Oct 11 12:24:23 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* varasm.c (notice_global_symbol):  Fix handling of variables; avoid
	re-computing of variable.

2003-10-11  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.c (alpha_return_in_memory): Rename from
	return_in_memory, make static, change signature to match target hook.
	(alpha_setup_incoming_varargs): Make static, change signature to
	match target hook, add code for vms and unicos.
	(TARGET_PROMOTE_FUNCTION_ARGS, TARGET_PROMOTE_FUNCTION_RETURN,
	TARGET_PROMOTE_PROTOTYPES, TARGET_STRUCT_VALUE_RTX,
	TARGET_RETURN_IN_MEMORY, TARGET_SETUP_INCOMING_VARARGS,
	TARGET_STRICT_ARGUMENT_NAMING,
	TARGET_PRETEND_OUTGOING_VARARGS_NAMED): New.
	* config/alpha/alpha-protos.h: Update.
	* config/alpha/alpha.h (PROMOTE_FUNCTION_ARGS,
	PROMOTE_FUNCTION_RETURN, RETURN_IN_MEMORY,
	SETUP_INCOMING_VARARGS): Remove.
	* config/alpha/unicosmk.h (SETUP_INCOMING_VARARGS): Remove.
	* config/alpha/vms.h (SETUP_INCOMING_VARARGS): Remove.

2003-10-11  Ian Lance Taylor  <ian@wasabisystems.com>

	* config/arm/arm.c (arm_regno_class): Handle IWMMXT_GR_REGS.

2003-10-11  Kazu Hirata  <kazu@cs.umass.edu>

	* config/m68k/lb1sf68.asm: Follow spelling conventions.
	* config/m68k/m68k.c: Likewise.
	* config/m68k/m68k.h: Likewise.
	* config/m68k/m68k.md: Likewise.

2003-10-11  Roger Sayle  <roger@eyesopen.com>

	* builtins.c (expand_builtin_memcpy): Optimize case when the two
	pointer arguments are the equal, non-volatile and side-effect free.
	(expand_builtin_mempcpy): Likewise.
	(expand_builtin_memmove): Likewise.
	(expand_builtin_strcpy): Likewise.
	(expand_builtin_memcmp): Likewise.
	(expand_builtin_strcmp): Likewise.
	(expand_builtin_strncmp): Likewise.

2003-10-11  Roger Sayle  <roger@eyesopen.com>

	* combine.c (apply_distributive_law): Enable "distributive" floating
	point optimizations with -funsafe-math-optimizations.

2003-10-11  Andrew Pinski <pinskia@physics.uc.edu>

	* genmodes.c (emit_mode_mask) Change MASK to MODE_MASK.

2003-10-11  Kazu Hirata  <kazu@cs.umass.edu>

	* config/m68k/m68k-protos.h: Remove the prototype for
	finalize_pic.

2003-10-11  Kazu Hirata  <kazu@cs.umass.edu>

	* config/m68k/m68k.c: Fix comment typos.

2003-10-11  Bernardo Innocenti  <bernie@develer.com>

	* config/m68k/m68k-protos.h (use_return_insn): Change return type from
	int to bool.
	* config/m68k/m68k.c (struct m68k_frame): Add funcdef_no member.
	(current_frame): New global var.
	(m68k_compute_frame_layout): Cache computations in current_frame.
	(m68k_initial_elimination_offset): Use values from current_frame
	instead of recomputing them.
	(use_return_insn): Likewise.
	(m68k_output_function_prologue): Likewise.
	(m68k_output_function_epilogue): Likewise.
	* config/m68k/m68k.h (TARGET_CPU_CPP_PREDEFINES): Fold __PIC__ handling
	inside the block for __pic__.

2003-10-11  Peter Barada <peter@baradas.org>
	    Bernardo Innocenti  <bernie@develer.com>

	* config/m68k/m68k.c (m68k_frame): Move before protos referencing it.
	(m68k_save_reg): Add boolean parameter `interrupt_handler'.
	(m68k_interrupt_function_p): New function.
	(m68k_handle_fndecl_attribute): Ditto.
	(m68k_compute_frame_layout): Ditto.
	(m68k_attribute_table): Define back-end specific attributes.
	(m68k_output_function_epilogue): Emit RTE instruction for interrupt
	functions.

2003-10-11  Bernardo Innocenti  <bernie@develer.com>

	* config/m68k/t-uclinux: New target Makefile fragment.
	* config/m68k/uclinux.h: New target macro file.
	* config.gcc (m68k-*-uclinux): New target definition.

2003-10-10  Roger Sayle  <roger@eyesopen.com>

	* builtins.c (builtin_mathfn_code): Generalize to check whether
	the call is to any built-in function by comparing the call's
	argument list against the builtin decl's function type.

2003-10-10  Roger Sayle  <roger@eyesopen.com>

	* cse.c (constant_pool_entries_regcost): New global variable to
	hold the register cost component of constant_pool_entries_cost.
	(fold_rtx): Calculate constant_pool_entries_regcost at the same
	time as constant_pool_entries_cost.
	(cse_insn): Set both src_folded_cost and src_folded_regcost from
	constant_pool_entries_cost and constant_pool_entries_regcost.
	(cse_main): Initialize constant_pool_entries_regcost to zero.

	* optabs.c (expand_unop): Attach a REG_EQUAL note describing
	the semantics of the sequence of bit operations used to negate
	a floating-point value.
	(expand_abs_nojump): Likewise attach a REG_EQUAL note describing
	the semantics of the bit operations used to abs a floating point
	value.

2003-10-11  Bernardo Innocenti  <bernie@develer.com>
	    Paul Dale  <pauli@snapgear.com>

	* config/m68k/lb1sf68.asm: Add __PIC__ and __ID_SHARED_LIBRARY__
	support.
	* config/m68k/m68k-none.h (ASM_SPEC): Pass --pcrel to assembler on
	-fpic, -fPIC, -msep-data and -mid-shared-library.
	* config/m68k/m68k.c (m68k_library_id_string): New global variable.
	(override_options): Add -msep-data and -mshared-library-id support.
	(m68k_output_function_prologue): Generate code to load A5 for
	TARGET_ID_SHARED_LIBRARY and TARGET_SEP_DATA.
	(m68k_output_mi_thunk): Emit indirect jump on TARGET_ID_SHARED_LIBRARY.
	(m68k_output_pic_call): New function.
	* gcc/config/m68k/m68k.h (TARGET_SEP_DATA): New target flag.
	(TARGET_ID_SHARED_LIBRARY): Ditto.
	(TARGET_SWITCHES): Add switches for -mid-shared-library and -msep-data.
	* gcc/config/m68k/m68k.md (call): Call m68k_output_pic_call().
	(call_value): Likewise.

2003-10-10  Zack Weinberg  <zack@codesourcery.com>

	* gengenrtl.c (find_formats, genheader): Make i an unsigned
	int, remove cast of NUM_RTX_CODE.
	* machmode.h: Make the HAVE_MACHINE_MODES #ifdef encompass the
	entire file.  Remove the #ifs on GET_MODE_MASK etc and
	GET_MODE_WIDER_MODE etc.

2003-10-10  Eric Christopher  <echristo@redhat.com>

	* lcm.c (optimize_mode_switching): Change NORMAL_MODE
	to MODE_ENTRY and MODE_EXIT. Add MODE_AFTER for insns
	that set mode.
	* config/sh/sh.h (MODE_ENTRY): New macro.
	(MODE_EXIT): Ditto.
	(MODE_AFTER): Ditto.
	* config/sh/sh.md: Change for MODE_AFTER. Add
	fp_set attribute.
	* doc/tm.texi: Document MODE_AFTER, MODE_ENTRY, and MODE_EXIT.

2003-10-10  Zack Weinberg  <zack@codesourcery.com>

	* genmodes.c, mode-classes.def: New files.
	* machmode.def: Rewritten to genmodes.c interface.
	* Makefile.in (extra_modes_file): New substitution variable.
	(MACHMODE_H): No longer includes machmode.def or
	@extra_modes_file@; instead, mode-classes.def and insn-modes.h.
	(BUILD_RTL): Add $(BUILD_PREFIX)insn-modes.o.
	(OBJS-common): Add insn-modes.o.
	(STAGESTUFF): Add insn-modes.c, insn-modes.h, s-modes, and
	genmodes$(build_exeext).
	(insn-modes.o, insn-modes.c, insn-modes.h, s-modes, genmodes.o,
	genmodes$(build_exeext), $(BUILD_PREFIX_1)insn-modes.o): New targets.
	(s-genrtl): Don't depend on $(RTL_BASE_H).
	(gengenrtl.o): Don't depend on coretypes.h, $(GTM_H), real.h,
	or $(RTL_BASE_H); just rtl.def.
	* gengenrtl.c: Don't include coretypes.h, tm.h, rtl.h, or
	real.h.  Give fake definition of CONST_DOUBLE_FORMAT and
	substitute definition of NUM_RTX_CODE.  Add casts to avoid
	warnings.
	* machmode.h: Include insn-modes.h, not machmode.def.  Include
	mode-classes.def to define enum mode_class.  Tweak definitions
	of GET_MODE_CLASS, GET_MODE_SIZE, GET_MODE_BITSIZE, GET_MODE_MASK,
	GET_MODE_INNER, GET_MODE_WIDER_MODE, GET_CLASS_NARROWEST_MODE.
	(inner_mode_array): Renamed mode_inner.
	(mode_base_align): New.
	* rtl.c (mode_name, mode_class, mode_bitsize, mode_size,
	mode_unit_size, mode_wider_mode, mode_mask_array,
	inner_mode_array, class_narrowest_mode): Delete definitions.
	* stor-layout.c (get_mode_alignment): Use mode_base_align.
	* real.h: Use MIN_MODE_FLOAT and MAX_MODE_FLOAT, not QFmode
	and TFmode, in real_format_for_mode and REAL_MODE_FORMAT.

	* config/ip2k/ip2k.h, config/iq2000/iq2000.h:
	No need to define BITS_PER_UNIT.

2003-10-10  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* config/ia64/ia64.c (ia64_vms_init_libfuncs): New function.
	(ia64_output_function_prologue): Only write .prologue if --with-gnu-as.
	(ia64_initialize_trampoline): If not using GAS, declare trampoline
	as global.
	* config/ia64/ia64.h (ASM_APP_ON, ASM_APP_OFF): Add vers for not GAS.
	(ASM_OUTPUT_DEBUG_LABEL): Likewise.

	* stor-layout.c (compute_record_mode): Don't force BLKmode if
	field is zero-length BLKmode.
	* expr.c (expand_expr, case COMPONENT_REF): Handle case of BLKmode
	zero-size references.

	* combine.c (distribute_links): Properly test for REG being set.

	* config/alpha/alpha.c (alpha_expand_block_mode): Don't use
	gen_lowpart and company except for REG.

2003-10-10  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa64-hpux.h (LINK_SPEC): Use `-z' option with HP ld.

2003-10-10  Nathanael Nerode  <neroden@gcc.gnu.org>

	* config.gcc (mips*-*-netbsd*): Remove content-free line.

2003-10-10  Herman A.J. ten Brugge <hermantenbrugge@home.nl>

	* gcov-io.h: Check BITS_PER_UNIT when defining gcov_unsigned_t,
	gcov_position_t and gcov_type.

2003-10-09  Kaz Kojima  <kkojima@gcc.gnu.org>

	* configure.in (HAVE_AS_TLS): Add sh-*-* and sh[34]*-*-* cases.
	* configure: Regenerate.

2003-10-09  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (define_asm_attributes): Specify
	the length of an asm insn more precisely.

2003-10-09  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config/mips/iris6.h (SUBTARGET_CPP_SPEC): Define.

2003-10-09  Bob Wilson  <bob.wilson@acm.org>

	* config/xtensa/xtensa.c (xtensa_dbx_register_number): Change first
	FP register number to 48 and MAC16 accumulator to 0x210.

2003-10-09  Nathanael Nerode  <neroden@gcc.gnu.org>

	* config.gcc: Remove redundant thread_file setting clauses for
	various *-*-linux* targets.

2003-10-09  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (define_asm_attributes): New.

2003-10-09  Roger Sayle  <roger@eyesopen.com>

	* optabs.c (prepare_float_lib_cmp): Always attach a REG_EQUAL note
	to the comparison, as emit_libcall_block calls copy_rtx on equiv.

2003-10-09  Dorit Naishlos  <dorit@il.ibm.com>

	* haifa-sched.c (ok_for_early_schedule): New function.
	(early_queue_to_ready): New function.
	(schedule_block): Allow early removal of insns from Q.
	(schedule_insn): Update INSN_TICK in case of premature
	issue.
	* common.opt (sched_stalled_insns): New flag.
	(sched_stalled_insns_dep): New flag.
	* flags.h: Same above flags.
	* opts.c: Same as above.
	* toplev.c: Same as above.
	* target.h (targetm.sched.is_costly_dependence): New
	hook.
	* target-def.h: Same as above.
	* config/rs6000/rs6000.h: (rs6000_sched_costly_dep):
	Support new flag -msched-costly-dep.
	(DEFAULT_SCHED_COSTLY_DEP): Define.
	* config/rs6000/rs6000.c:
	(rs6000_is_costly_dependence): New function.
	(is_load_insn, is_store_insn): New functions.
	(is_load_insn1, is_store_insn1, is_mem_ref): New
	functions.
	* doc/invoke.texi (-fsched-stalled-insns-dep)
	(-fsched-stalled-insns, -msched-costly-dep): Document
	options.
	* doc/tm.texi (is_costly_dependence): Define new
	scheduler target hook.

2003-10-09  Jason Merrill  <jason@redhat.com>

	PR c++/6392
	* c-common.c (c_build_qualified_type): Look through arrays first.
	(c_apply_type_quals_to_decl): Look through arrays.

	* c-common.c (c_apply_type_quals_to_decl): Unset TREE_READONLY for
	types with constructors.

	* coverage.c (build_ctr_info_value): Use build_decl to make a
	VAR_DECL.
	(create_coverage): Likewise.

	* stmt.c (resolve_asm_operand_names): Call check_unique_operand_names
	here.
	(expand_asm_operands): Not here.
	(parse_input_constraint): No longer static.
	* tree.h: Declare it.

2003-10-08  Kaz Kojima  <kkojima@gcc.gnu.org>

	* config/sh/t-linux (SHLIB_LINK): Override to use a linker script
	libgcc_s.so.
	(SHLIB_INSTALL): Likewise.

2003-10-08  Nathanael Nerode  <neroden@gcc.gnu.org>

	* doc/install.texi: Remove reference to removed 'pthreads' thread
	option.

2003-10-08  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000.md ("abssi2_isel"): Add early clobber to
	operand 2.

2003-10-08  Nathanael Nerode  <neroden@gcc.gnu.org>

	* config.gcc: Don't accept --enable-threads=pthreads.  Clean
	up related case statements.
	* configure.in: Don't accept --enable-threads=pthreads,
	decosf1, mach, or os2 (none of which work anyway).  Alphabetize
	supported thread files in case clause.
	* configure: Regenerate.

2003-10-08  Geoffrey Keating  <geoffk@apple.com>

	* function.c (pad_to_arg_alignment): Move 'boundary_in_bytes'
	definition to above SPARC_STACK_BOUNDARY_HACK.

2003-10-08  Jason Merrill  <jason@redhat.com>

	* c-pretty-print.c (pp_c_postfix_expression)
	<COMPOUND_LITERAL_EXPR>: Fix thinko.

2003-10-08  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* mklibgcc.in: Don't hide undefined or typeless symbols.

2003-10-08  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR optimization/12142
	* cse.c (count_reg_usage): In a SET with a REG SET_DEST, count the
	uses of the register in the SET_SRC.  Remove unnecessary argument.
	* pa.c (legitimize_pic_address): Before reload, use a scratch register
	for the intermediate result in loading the address of a SYMBOL_REF.
	Set the MEM_NOTRAP_P flag for the MEM.  Add a REG_EQUAL to the insn
	which loads the SYMBOL_REF address.

2003-10-08  Timo Kokkonen  <tjko@iki.fi>
	    Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR bootstrap/12490
	* scan-decls.c (MAX_EXTERN_C_BRACES): New preprocessor constant
	to define the size of the extern_C_braces array.  Set it to 200.
	(scan_decls): Abort when extern_C_braces_length is out-of-bounds.

2003-10-08  Carlo Wood  <carlo@alinoe.com>

	* Makefile.in (gengtype-lex.c): flex 2.5.4[a] doesn't understand
	a space after the -o option.  flex 2.5.31 understands both, with
	and without the space. Removed that space.

2003-10-08  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.c (mips_frame_info): Add cprestore_size field.
	(compute_frame_size): Initialize it.  Remove the .cprestore slot
	from args_size.
	(mips_output_function_prologue): Simplify accordingly.
	(mips_debugger_offset): Change the mips16 frame pointer offset from
	current_function_outgoing_args to cfun->machine->frame.args_size.
	(mips_initial_elimination_offset): Likewise.
	(mips_expand_prologue): Likewise.
	(mips_expand_epilogue): Likewise.

2003-10-08  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.h (EXTRA_CONSTRAINT): Add 'W' constraint.
	(EXTRA_MEMORY_CONSTRAINT): Define.
	(CAN_ELIMINATE): Remove lwu workaround.
	* config/mips/mips.md (*zero_extendsidi2_mem): Enable for mips16 too.
	Use a 'W' constraint for the source operand.

2003-10-08  Kazu Hirata  <kazu@cs.umass.edu>

	* genopinit.c (main): Output code to declare undefined
	variables.

2003-10-07  Kelley Cook  <kcook@gcc.gnu.org>

	* gengtype-lex.l: Remove -Wtraditional cruft.
	* Makefile.in (gengtype-lex.c): Likewise.

2003-10-07  Zdenek Dvorak  <rakdver@atrey.karlin.mff.cuni.cz>

	* cfgloopmanip.c (fix_irreducible_loops): Initialize e correctly.

2003-10-07  Jason Merrill  <jason@redhat.com>

	PR c++/12519
	* c-semantics.c (genrtl_cleanup_stmt): Ignore the CLEANUP_DECL if
	it isn't a decl.

2003-10-07  Alexandre Oliva  <aoliva@redhat.com>

	* gcc.c (cpp_options): Only pass -fworking-directory for -g* if
	not overridden.
	Fixes PR bootstrap/12173.

2003-10-07  Zack Weinberg  <zack@codesourcery.com>

	* errors.c: Don't include coretypes.h or tm.h.
	(trim_filename): Use IS_DIR_SEPARATOR.
	* Makefile.in: Update dependencies of errors.o and
	$(BUILD_PREFIX_1)errors.o.

2003-10-07  Geoffrey Keating  <geoffk@apple.com>

	* function.c (pad_to_arg_alignment): Take STACK_POINTER_OFFSET into
	account	when aligning arguments.
	* calls.c (STACK_POINTER_OFFSET): Move default from here ...
	* defaults.h (STACK_POINTER_OFFSET): ... to here.
	* config/sparc/sparc.h (STACK_BOUNDARY): Add comment about how
	it's wrong when TARGET_ARCH64 && TARGET_STACK_BIAS.
	(SPARC_STACK_BOUNDARY_HACK): Define.
	* config/rs6000/rs6000.c (function_arg): On non-SVR4 systems,
	arrange for vector parameters to varargs functions to be passed
	in both memory and GPRs when appropriate.
	(rs6000_va_arg): Vector arguments passed in memory are 16-byte
	aligned.

	* hooks.c (hook_bool_tree_true): New.
	(hook_rtx_tree_int_null): New.
	(hook_rtx_rtx_null): Use NULL, not 0.
	* hooks.h: Add 'extern' to everything.
	(hook_bool_tree_true): New.
	(hook_rtx_tree_int_null): New.
	* targhooks.c (hook_bool_CUMULATIVE_ARGS_true): New.
	* targhooks.h (hook_bool_CUMULATIVE_ARGS_true): New.
	* config/rs6000/rs6000-protos.h (setup_incoming_varargs): Remove
	prototype.
	* config/rs6000/rs6000.c (rs6000_return_in_memory): New.
	(setup_incoming_varargs): Prototype.
	(TARGET_PROMOTE_FUNCTION_ARGS): Define.
	(TARGET_PROMOTE_FUNCTION_RETURN): Define.
	(TARGET_STRUCT_VALUE_RTX): Define.
	(TARGET_RETURN_IN_MEMORY): Define.
	(TARGET_SETUP_INCOMING_VARARGS): Define.
	(TARGET_STRICT_ARGUMENT_NAMING): Define.
	(TARGET_PRETEND_OUTGOING_VARARGS_NAMED): Define.
	(init_cumulative_args): Use rs6000_return_in_memory.
	(setup_incoming_varargs): Make 'static'.
	* config/rs6000/rs6000.h (PROMOTE_FUNCTION_ARGS): Delete.
	(PROMOTE_FUNCTION_RETURN): Delete.
	(STRUCT_VALUE): Delete.
	(RETURN_IN_MEMORY): Delete.
	(SETUP_INCOMING_VARARGS): Delete.

2003-10-07  Gerald Pfeifer  <gerald@pfeifer.com>

	* doc/invoke.texi (Warning Options): Simplify and clarify the
	descriptions of -Wnonnull and -Winit-self.

2003-10-07  Richard Earnshaw  <rearnsha@arm.com>

	* optabs.c (init_intraclass_conv_libfuncs): Fix order of array
	indicees for floating-point conversersion libcalls.

2003-10-07  Nathanael Nerode  <neroden@gcc.gnu.org>

	* Makefile.in: Add more comments separating large conceptually
	separate sections.

	* configure.in: Clean up thread file logic.
	* configure: Regenerate.

2003-10-07  Danny Smith  <dannysmith@users.sourceforge.net>

	* config/i386/cygming.h (READONLY_DATA_SECTION_ASM_OP): Define.
	(switch_to_section): Handle in_readonly_data.
	* config/i386/winnt.c (i386_pe_asm_named_section): Handle
	readonly data.

2003-10-07  Richard Earnshaw  <rearnsha@arm.com>

	* arm.md (cmpsi2_addneg): New ARM pattern. Add peephole2 to generate
	it.
	(cbranchne_decr1): New Thumb pattern.
	* arm.c (arm_addimm_operand): New insn predicate.
	* arm-protos.h: Add a prototype for it.
	* arm.h (PREDICATE_CODES): Add it.

2003-10-07  Dorit Naishlos <dorit@il.ibm.com>

	* sched-int.h (sched_info): New field
	sched_max_insns_priority.
	* sched-rgn.c (init_ready_list): Add invocations to
	targetm.sched.adjust_priority.
	(sched_max_insns_priority): Init new field.
	* sched-ebb.c (sched_max_insns_priority): Init new field.
	* haifa-sched.c (set_priorities): Set
	sched_info->sched_max_insns_priority.
	* config/rs6000/rs6000.h:
	(rs6000_sched_restricted_insns_priority_str): Support new
	flag -mprioritize-restricted-insns.
	(DEFAULT_RESTRICTED_INSNS_PRIORITY): Define.
	* config/rs6000/rs6000.c (is_dispatch_slot_restricted): New
	function.
	(rs6000_adjust_priority): Change priority of restricted
	insns, using above new function and new flag.
	* doc/invoke.texi (-mprioritize-restricted-insns): Document
	new option.

2003-10-07  Zack Weinberg  <zack@codesourcery.com>

	* expr.c (cmpstr_optab, cmpmem_optab): New.
	* genopinit.c: Initialize them.
	* optabs.h: Declare them.
	* optabs.c (init_optabs): Clear them.
	(prepare_cmp_insn):  Use cmpstr_optab and cmpmem_optab to find
	block memory compare insns, not conditional chains.  Restructure
	the fallback generation of a call to memcmp/bcmp for better
	readability.

2003-10-07  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.c (MIPS_MAX_FIRST_STACK_STEP): New macro.
	(mips_save_restore_fn): New typedef.
	(mips_add_large_offset_to_sp, mips_emit_frame_related_store): Remove.
	(mips_set_frame_expr, mips_frame_set): Move above prologue code.
	(save_restore_insns): Remove, replacing with...
	(mips_save_restore_reg, mips_for_each_saved_reg): ...these new fns.
	(mips_save_reg, mips_restore_reg): New function.
	(mips_expand_prologue, mips_expand_epilogue): Rework.
	* config/mips/mips.h (MIPS_TEMP1_REGNUM, MIPS_TEMP2_REGNUM): Remove.
	(MIPS_PROLOGUE_TEMP_REGNUM, MIPS_EPILOGUE_TEMP_REGNUM): New macros.
	(MIPS_PROLOGUE_TEMP, MIPS_EPILOGUE_TEMP): New macros.

2003-10-07  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.c (mips_expand_prologue): Remove unused
	traversal of function arguments.

2003-10-07  Richard Sandiford  <rsandifo@redhat.com>

	* doc/invoke.texi: Remove documentation of -mentry.
	* config/mips/mips.c (mips_entry_string, mips_entry): Remove.
	(override_options, mips_save_reg_p): Remove handling.
	(compute_frame_size, mips_output_function_prologue): Likewise.
	(mips_expand_prologue, mips_expand_epilogue): Likewise.
	* config/mips/mips.h (mips_entry_string): Remove declaration.
	(TARGET_OPTIONS): Remove -mentry.
	* config/mips/mips16.S: Remove mention of -mentry.

2003-10-06  Zack Weinberg  <zack@codesourcery.com>

	* libfuncs.h (LTI_extendsfdf2, LTI_extendsfxf2, LTI_extendsftf2)
	(LTI_extenddfxf2, LTI_extenddftf2, LTI_truncdfsf2, LTI_truncxfsf2)
	(LTI_trunctfsf2, LTI_truncxfdf2, LTI_trunctfdf2, LTI_floatsisf)
	(LTI_floatdisf, LTI_floattisf, LTI_floatsidf, LTI_floatdidf)
	(LTI_floattidf, LTI_floatsixf, LTI_floatdixf, LTI_floattixf)
	(LTI_floatsitf, LTI_floatditf, LTI_floattitf, LTI_fixsfsi, LTI_fixsfdi)
	(LTI_fixsfti, LTI_fixdfsi, LTI_fixdfdi, LTI_fixdfti, LTI_fixxfsi)
	(LTI_fixxfdi, LTI_fixxfti, LTI_fixtfsi, LTI_fixtfdi, LTI_fixtfti)
	(LTI_fixunssfsi, LTI_fixunssfdi, LTI_fixunssfti, LTI_fixunsdfsi)
	(LTI_fixunsdfdi, LTI_fixunsdfti, LTI_fixunsxfsi, LTI_fixunsxfdi)
	(LTI_fixunsxfti, LTI_fixunstfsi, LTI_fixunstfdi, LTI_fixunstfti)
	(extendsfdf2_libfunc, extendsfxf2_libfunc, extendsftf2_libfunc)
	(extenddfxf2_libfunc, extenddftf2_libfunc, truncdfsf2_libfunc)
	(truncxfsf2_libfunc, trunctfsf2_libfunc, truncxfdf2_libfunc)
	(trunctfdf2_libfunc, floatsisf_libfunc, floatdisf_libfunc)
	(floattisf_libfunc, floatsidf_libfunc, floatdidf_libfunc)
	(floattidf_libfunc, floatsixf_libfunc, floatdixf_libfunc)
	(floattixf_libfunc, floatsitf_libfunc, floatditf_libfunc)
	(floattitf_libfunc, fixsfsi_libfunc, fixsfdi_libfunc, fixsfti_libfunc)
	(fixdfsi_libfunc, fixdfdi_libfunc, fixdfti_libfunc, fixxfsi_libfunc)
	(fixxfdi_libfunc, fixxfti_libfunc, fixtfsi_libfunc, fixtfdi_libfunc)
	(fixtfti_libfunc, fixunssfsi_libfunc, fixunssfdi_libfunc)
	(fixunssfti_libfunc, fixunsdfsi_libfunc, fixunsdfdi_libfunc)
	(fixunsdfti_libfunc, fixunsxfsi_libfunc, fixunsxfdi_libfunc)
	(fixunsxfti_libfunc, fixunstfsi_libfunc, fixunstfdi_libfunc)
	(fixunstfti_libfunc): Delete.
	* optabs.h (struct optab_handlers): Break out of struct optab.
	(struct convert_optab, convert_optab, enum convert_optab_index,
	convert_optab_table, sext_optab, zext_optab, trunc_optab,
	sfix_optab, ufix_optab, sfixtrunc_optab, ufixtrunc_optab,
	sfloat_optab, ufloat_optab): New.
	(set_conv_libfunc): Prototype.
	(GEN_FCN): Use C90 indirect call syntax, remove unnecessary cast.
	(trunc_optab): Renamed btrunc_optab.
	* builtins.c (expand_builtin_mathfn): Update to match.
	* optabs.c (extendtab, fixtab, fixtrunctab, floattab): Delete.
	(convert_optab_table, new_convert_optab, init_convert_optab)
	(init_interclass_conv_libfuncs, init_intraclass_conv_libfuncs)
	(set_conv_libfunc): New.
	(can_extend_p, gen_extend_insn, can_fix_p, can_float_p)
	(expand_float, expand_fix): Use new conversion optabs,
	not old insn code tables or long chains of ifs.
	(init_optabs): No need to clear old insn code tables.
	Initialize the new optabs, not the old libfunc array entries.
	Don't handle FIXUNS_TRUNC_LIKE_FIX_TRUNC here.
	* genopinit.c: Initialize conversion optabs, not the
	former insn code tables.  Remove unnecessary casts.
	Handle FIXUNS_TRUNC_LIKE_FIX_TRUNC here.
	* expr.c (convert_move): Remove redundant check that
	to_real==from_real.  Use the conversion optabs instead
	of long chains of tests of modes.  Move partial-integer-mode
	interconversion above all integer conversion.  Do not recurse
	on a value forced into a register in the original mode.

	* config/gofast.h, config/frv/frv.c, config/ia64/ia64.c
	* config/mips/mips.c, config/pa/pa.c, config/rs6000/rs6000.c
	* config/sparc/sparc.c: Use set_conv_libfunc to adjust entries
	in new conversion optabs; do not reference the old libfunc
	array entries.  No need to include libfuncs.h.

2003-10-06  Roger Sayle  <roger@eyesopen.com>

	* config/i386/i386.c (ix86_expand_setcc): Annotate the floating
	point comparison sequence with a REG_EQUAL note that describes
	the comparison's semantics.

2003-10-06  Roger Sayle  <roger@eyesopen.com>

	* expr.c (expand_expr <COND_EXPR>): Handle the void type semantics
	of COND_EXPR when expanding the "A op 0 ? FOO : A" optimizations.

2003-10-06  Roger Sayle  <roger@eyesopen.com>
	    Zack Weinberg  <zack@codesourcery.com>

	* optabs.c (prepare_float_lib_cmp): Avoid searching for REG_RETVAL
	instruction by using LCT_CONST and then calling emit_libcall_block
	ourselves.

2003-10-06  Falk Hueffner  <falk.hueffner@student.uni-tuebingen.de>

	PR optimization/11974
	* optabs.c (expand_unop): Promote libcall outmode according to
	hard_libcall_value.

2003-10-06  Zack Weinberg  <zack@codesourcery.com>

	* real.h (REAL_MODE_FORMAT): New macro.
	* c-cppbuiltin.c, optabs.c, real.c, config/alpha/alpha.c
	* config/c4x/c4x.c, config/i370/i370.c, config/i386/freebsd.h
	* config/i386/i386.c, config/i960/i960.c, config/ia64/ia64.c
	* config/m68k/m68k.c, config/mips/mips.c, config/rs6000/rs6000.c
	* config/vax/vax.c: Use REAL_MODE_FORMAT instead of referring
	directly to real_format_for_mode array, wherever possible.

2003-10-06  Devang Patel  <dpatel@apple.com>

	* dwarf2out.c (is_main_source): Remove variable.
	(dwarf2out_start_source_file): Do not check is_main_source.
	Do not reset is_main_source.
	(dwarf2out_init): Do not initialize is_main_source.

2003-10-06  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* fixinc/inclhack.def (stdio_va_list): Removed _ap fix.
	(irix_stdio_va_list): Don't require leading printf, IRIX 6.5.21
	introduced some multi-line prototypes.
	* fixinc/fixincl.x: Regenerate.

2003-10-06  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.h (PREDICATE_CODES): Add stack_operand.
	* config/mips/mips.c (stack_operand): New predicate.
	* config/mips/mips.md: Use it for the destination of mips16 insns
	that store $31.

2003-10-06  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.md (*lowsi): Renamed from lowsi.
	(*lowdi): Likewise lowdi.
	(*lowsi_mips16, *lowdi_mips16): New patterns.
	* config/mips/mips.c (mips_const_insns, mips_output_move): Remove
	mips16 CONSTANT_RELOC handling.
	(mips_delegitimize_address): Adjust for new sdata representation.

2003-10-06  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.c (mips_arg_info): If MUST_PASS_IN_STACK,
	skip any remaining register arguments.

2003-10-06  Ulrich Weigand  <uweigand@de.ibm.com>

	* reload.c (find_reloads_subreg_address): Use correct offset for
	paradoxical MEM subregs on big-endian targets.

2003-10-06  Andrew Haley  <aph@redhat.com>

	* tree.c (get_callee_fndecl): Call
	lang_hooks.lang_get_callee_fndecl.
	* langhooks-def.h (LANG_HOOKS_GET_CALLEE_FNDECL): New.
	(lhd_get_callee_fndecl): New.

2003-10-06  Andrew Pinski  <apinski@apple.com>

	* config/darwin.c (machopic_non_lazy_ptr_name): Fix off by one
	error in calculating the length of the string.
	(machopic_stub_name): Likewise.

2003-10-06  Roger Sayle  <roger@eyesopen.com>

	* optabs.c (prepare_float_lib_cmp):  Attach a REG_EQUAL note
	describing the return value of the comparison libcall to the
	REG_RETVAL instruction of the emitted sequence.

2003-10-06  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/12215
	* cse.c (cse_set_around_loop): Emit the move at the beginning
	of the next basic block for trapping sets.

2003-10-06  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/11637
	* combine.c (adjust_for_new_dest): New function to adjust the
	notes and LOG_LINKS when the dest of an insn has changed.
	(try_combine): Use it when deleting the first insn of a two-insn
	parallel or splitting a two-load parallel.

2003-10-06  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.c (mips_classify_constant): Only allow UNSPECs
	if TARGET_EXPLICIT_RELOCS.

2003-10-06  Mark Mitchell  <mark@codesourcery.com>

	PR bootstrap/12512
	* Makefile.in (info): Use double-colon rules.
	(dvi): Likewise.
	(generated-manpages): Likewise.
	* configure.in: Do not create lang.info, lang.dvi, or
	lang.generated-manpages hooks.
	* configure: Regenerated.
	* objc/Make-lang.in (objc.info): Remove.
	(objc.dvi): Remove.
	(objc.generated-manpages): Remove.
	* doc/sourcebuild.texi: Update description of info, dvi, and
	generated-manpages hooks.

2003-10-06  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.md: Merge mips16 lw/srl pattern with its splitter.

2003-10-05  Andrew Pinski  <apinski@apple.com>

	* config/darwin.c (machopic_non_lazy_ptr_name): Fix off by one
	errors in memcpy destinations.
	(machopic_stub_name): Likewise.

2003-10-05  Andrew Pinski <apinski@apple.com>

	* config/darwin.c (machopic_non_lazy_ptr_name):
	Change strcat to memcpy and add length together.
	(machopic_stub_name): Likewise.

2003-10-05  Kaz Kojima  <kkojima@gcc.gnu.org>

	* config/sh/linux.h (MD_FALLBACK_FRAME_STATE_FOR): Handle new
	signal trampoline codes.

2003-10-05  Chris Demetriou  <cgd@broadcom.com>

	* config/mips/mips.md (*divsf3): Move description of
	SB-1 F2 erratum from here to...
	(divsf3): Here.  Disable if TARGET_FIX_SB1 is set and
	flag_unsafe_math_optimizations is not.

2003-10-05  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/linuxspe.h: Define TARGET_SPE_ABI, TARGET_SPE,
	TARGET_E500, TARGET_ISEL, and TARGET_FPRS.

2003-10-05  Kazu Hirata  <kazu@cs.umass.edu>

	* c-pretty-print.c: Fix comment typos.
	* c-pretty-print.h: Likewise.
	* calls.c: Likewise.
	* cfgloopmanip.c: Likewise.
	* cgraphunit.c: Likewise.
	* cppfiles.c: Likewise.
	* final.c: Likewise.
	* function.c: Likewise.
	* gcov-io.h: Likewise.
	* gcse.c: Likewise.
	* genoutput.c: Likewise.
	* loop.c: Likewise.
	* postreload.c: Likewise.
	* reg-stack.c: Likewise.
	* regmove.c: Likewise.
	* sched-int.h: Likewise.
	* sched-rgn.c: Likewise.
	* simplify-rtx.c: Likewise.
	* tree-inline.c: Likewise.
	* config/m68hc11/m68hc11.h: Likewise.
	* config/mmix/mmix.c: Likewise.
	* config/mn10300/mn10300.md: Likewise.
	* config/sh/sh.h: Likewise.

2003-10-05  Richard Henderson  <rth@redhat.com>

	* tree-inline.c (remap_type): New.
	(remap_decl): Use it.  Remap DECL_SIZE*.
	(copy_body_r): Use it.
	(walk_tree): Walk TREE_TYPE too.
	(copy_tree_r): Don't walk subtrees of types.
	* tree.c (variably_modified_type_p): Restructure.  Consider integer
	types with non-const bounds variably modified.

2003-10-05  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/invoke.texi: Fix typos.

2003-10-05  Kazu Hirata  <kazu@cs.umass.edu>

	* fold-const.c: Follow spelling conventions.
	* function.c: Likewise.
	* config/c4x/c4x.h: Likewise.
	* config/c4x/c4x.md: Likewise.
	* config/frv/frv.md: Likewise.
	* config/rs6000/aix.h: Likewise.
	* config/rs6000/linux64.h: Likewise.
	* config/xtensa/xtensa.c: Likewise.

2003-10-05  Kazu Hirata  <kazu@cs.umass.edu>

	* c-pretty-print.c: Fix comment formatting.
	* cfglayout.c: Likewise.
	* cfgloopanal.c: Likewise.
	* cppcharset.c: Likewise.
	* dbxout.c: Likewise.
	* ggc-page.c: Likewise.
	* ggc.h: Likewise.
	* target.h: Likewise.

2003-10-04  Kelley Cook  <kelleycook@wideopenwest.com>

	* gengtype-lex.l: Recognize typedef of functions without PARAMS macro.

2003-10-04  Nathanael Nerode  <neroden@gcc.gnu.org>

	* config/v850/v850-c.c, config/v850/v850-protos.h, config/v850/v850.c:
	Convert to ISO C90 function declarations and definitions.

2003-10-04  Zack Weinberg  <zack@codesourcery.com>

	* libfuncs.h
	(LTI_eqhf2, LTI_nehf2, LTI_gthf2, LTI_gehf2, LTI_lthf2)
	(LTI_lehf2, LTI_unordhf2, LTI_eqsf2, LTI_nesf2, LTI_gtsf2)
	(LTI_gesf2, LTI_ltsf2, LTI_lesf2, LTI_unordsf2, LTI_eqdf2)
	(LTI_nedf2, LTI_gtdf2, LTI_gedf2, LTI_ltdf2, LTI_ledf2)
	(LTI_unorddf2, LTI_eqxf2, LTI_nexf2, LTI_gtxf2, LTI_gexf2)
	(LTI_ltxf2, LTI_lexf2, LTI_unordxf2, LTI_eqtf2, LTI_netf2)
	(LTI_gttf2, LTI_getf2, LTI_lttf2, LTI_letf2, LTI_unordtf2)
	(eqhf2_libfunc, nehf2_libfunc, gthf2_libfunc, gehf2_libfunc)
	(lthf2_libfunc, lehf2_libfunc, unordhf2_libfunc, eqsf2_libfunc)
	(nesf2_libfunc, gtsf2_libfunc, gesf2_libfunc, ltsf2_libfunc)
	(lesf2_libfunc, unordsf2_libfunc eqdf2_libfunc, nedf2_libfunc)
	(gtdf2_libfunc, gedf2_libfunc, ltdf2_libfunc, ledf2_libfunc)
	(unorddf2_libfunc eqxf2_libfunc, nexf2_libfunc, gtxf2_libfunc)
	(gexf2_libfunc, ltxf2_libfunc, lexf2_libfunc, unordxf2_libfunc
	(eqtf2_libfunc, netf2_libfunc, gttf2_libfunc, getf2_libfunc)
	(lttf2_libfunc, letf2_libfunc, unordtf2_libfunc):
	Delete.
	* optabs.h (OTI_eq, OTI_ne, OTI_gt, OTI_ge, OTI_lt, OTI_le)
	(OTI_unord, eq_optab, ne_optab, gt_optab, ge_optab, lt_optab)
	(le_optab, unord_optab): New.

	* optabs.c (prepare_float_lib_cmp): Rewrite.  Get the libfuncs
	from the code_to_optab table, not a giant switch; use
	swap_condition; do widening only if a comparison function that
	we can call exists in a wider mode, not if a cmp_optab insn or
	libfunc exists in a wider mode; call protect_from_queue
	exactly once on each operand.
	(init_optabs): Initialize the new optabs, not the deleted libfuncs.

	* config/gofast.h, config/ia64/ia64.c, config/mips/mips.c
	* config/pa/pa.c, config/rs6000/rs6000.c, config/sparc/sparc.c:
	Set floating point comparison libfuncs using set_optab_libfunc
	on the appropriate optab.

	* config/ia64/ia64.c (ia64_hpux_init_libfuncs): Fix typo.
	* config/rs6000/rs6000.c (rs6000_init_libfuncs): Correct ABI
	selector conditionals.

2003-10-04  Stephane Carrez  <stcarrez@nerim.fr>

	* config/m68hc11/t-m68hc11-gas (MULTILIB_MATCHES): m68hcs12 is
	identical to m68hc12 as far as libraries are concerned.

2003-10-04  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR c/12446
	* c-typeck.c (convert_for_assignment): Issue an error for
	array to pointer assignment after default conversion.
	(digest_init): Likewise.

2003-10-04  Fariborz Jahanian  <fjahanian@apple.com>

	* c-decl.c (duplicate_decls): retain DECL_COMMON of old declaration

2003-10-03  Gerald Pfeifer  <gerald@pfeifer.com>

	* doc/extend.texi (Function Attributes): Fix title of GNU C
	Preprocessor manual.
	(C++ Extensions): Fix reference to "Predefined Macros" in the
	GNU C Preprocessor manual.

